--------------------------------------------------------------------------------------
-- 文件名:	MySqlInstance.lua
-- 版  权:	(C)  *****互动科技有限公司
-- 创建人:	陆奎安
-- 日  期:	2017-7-29 11:24
-- 版  本:	1.0
-- 描  述:	MySql
-- 应  用:  
---------------------------------------------------------------------------------------
MySqlInstance = class("MySqlInstance")
MySqlInstance.__index = MySqlInstance

local mysql = require "resty.mysql"
local dbKey = g_SvrCfg.DbKey
local dbHost = g_SvrCfg.DbHost
local dbName = dbName

function MySqlInstance:query(sql, player)
	local db = self:create()
	local res, err, errcode, sqlstate = db:query(sql)
	if not res then	
		local strError = sql.." bad result: ".. err
		local strTace =  debug.traceback()
		local strDesc = string.format("%s\n%s",strError,strTace)
		
		ccDebuglog(sql,"-not query =",strDesc)
		return res, err, errcode, sqlstate
	end
	
	ngx.log(ngx.DEBUG, string.format(" MySqlInstance:query:%s => %s",sql, __tostring1(res)))
	if res ~= nil then
		local idle_timeout = 100000
		local pool_size = 100
	
		local ok, err = db:set_keepalive(idle_timeout, pool_size)
		if not ok then
			local iSessionID = -11
			if player then
				iSessionID = player:getSessionID()
			end
			
			cclog(iSessionID, sql.." bad set_keepalive: ".. err.."->"..debug.traceback())
			return nil, 'fail to set_keepalive:'..err
		end
	end
	return res, err, errcode, sqlstate 
end
