------------------
-- 文件名:	g_action.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2017-6-17 11:24
-- 版  本:	1.0
-- 描  述:	玩家数据
-- 应  用:  
-------------------
local _action = class("_action")

--函数：倒计时动画
--参数：1: Label, 2 起始时间； 3冷却时间
--返回：
function countdownAction(nLabel,coolTime,callback,TimeStrType,nType)
	local coolTime = coolTime or 0
	local TimeStrType = TimeStrType or 3
	local function labelSetTime()
		local Text 
		if TimeStrType == 1 then
			Text = cc.getStrTimeByS(coolTime)
		elseif TimeStrType == 2 then
			Text = cc.getStrTimeByS2(coolTime)
		else
			Text = cc.getStrTimeByS3(coolTime,nType)	
		end
		
		--cclog(nLabel,"=====upData==",Text,"===",coolTime)
		nLabel:setString(Text)
		if coolTime == 0 then
			g_scheduleTime:stopScheduleForever(nLabel)
			if callback then
				callback()
			end
			return
		end 
		coolTime = coolTime - 1
	end
	g_scheduleTime:stopScheduleForever(nLabel)
	g_scheduleTime:scheduleForever(nLabel,1,labelSetTime)
	labelSetTime()
end

--函数：进度条动画
--参数：1: Label,  nTime 动画时间，nTimes 重复几次
--返回：
function _action:LoadingBarAction(LoadingBar,curPercent,toPercent,nTimes,callback,nTime)
	--每一次的时间
	local nTime = nTime or 1
	local nTimes = nTimes or 1
	local nTimeOne = nTime/nTimes
	LoadingBar:setValue(curPercent)
	
	if nTimes ==  1 then
		LoadingBar:tweenValue(toPercent,nTime)
	elseif nTimes >  1 then
		local count = 0
		local function scheduFun()
			count = count+ 1
			if callback then
				callback(count)
			end 
			if count == nTimes-1 then
				LoadingBar:setValue(0)
				LoadingBar:tweenValue(toPercent,nTimeOne)
			else
				LoadingBar:setValue(0)
				LoadingBar:tweenValue(100,nTimeOne)
			end 
			
		end
		local item = LoadingBar:displayObject()	
		g_scheduleTime:scheduleByTimes(item,nTimeOne,nTimes-1,scheduFun)
		LoadingBar:tweenValue(100,nTimeOne)
	end 

end

--函数：数字增加动画
--参数：
--返回：
function textAddAction(textItem,curValue,lastValue,numbers,bDataNum)
	
	local nLabel=textItem:displayObject()
	local ntime = ntime or 0.02 
	local numbers = numbers or 20
	local eveyNumber = 1
	local nAbs = math.abs(lastValue-curValue)
	if nAbs > numbers then
		eveyNumber = math.floor(nAbs /numbers)
	end 
	
	if bDataNum == true   then
		local digits1 = math.ceil(math.log(curValue)/math.log(10))
		local digits2 = math.ceil(math.log(nAbs)/math.log(10))
		if (digits1 - digits2) >= 3 then
			local  srtnValue =  g_numberData:numberToUnit(lastValue)
			textItem:setText(srtnValue)
			return 
		end 
	end 
	
	local addNumberType = 1
	local addNumber = 0
	if curValue > lastValue then
		addNumberType = -1
	end 
	addNumber = eveyNumber*addNumberType
	local function textAdd_callback()
		local nValue = curValue + addNumber
		nValue = math.floor(nValue)
		if bDataNum then
			local  srtnValue =  g_numberData:numberToUnit(nValue)
			textItem:setText(srtnValue)
		else
			textItem:setText(nValue)
		end 
		
		if nValue >= lastValue then
			nValue= lastValue
			if bDataNum then
				local  srtnValue =  g_numberData:numberToUnit(nValue)
				textItem:setText(srtnValue)
			else
				textItem:setText(nValue)
			end 
			g_scheduleTime:stopScheduleForever(nLabel)
			return
		end 
		addNumber = addNumber + eveyNumber*addNumberType
	end
	g_scheduleTime:scheduleForever(nLabel,ntime,textAdd_callback)
end

--角色掉血闪动画
function _action:roleActionBlink(nSprite,ntime,callBack,isSetColor)
	local nSprite = nSprite 
	local ntime = ntime or 2
	
	local actionBlink = cc.Blink:create(ntime,math.floor(ntime/0.5)*4)
	local action2 = nil
	local action3 = nil

	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end
	local function actionEnd()
		cc.g_setTextColor(nSprite,2)
		nSprite:setOpacity(255)
	end
	if isSetColor then
		cc.g_setTextColor(nSprite,isSetColor)
		action3 = cc.CallFunc:create(actionEnd)
	end 

	local actionSequence = cc.Sequence:create(actionBlink,action2,action3)
	nSprite:runAction(actionSequence)
end
--角色瞬移缩放动画
function _action:roleActionScale(nSprite,ntime,callBack,Status)
	local nSprite = nSprite 
	local ntime = ntime or 2
	
	local actionScaleTo = cc.ScaleBy:create(0.1, 0,1)
	if Status then
		actionScaleTo = cc.ScaleBy:create(0.1, 0,1)
	else
		actionScaleTo = cc.ScaleTo:create(0.1, 0.8)
	end 

	local action2 = nil
	local action3 = nil

	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end

	local actionSequence = cc.Sequence:create(actionScaleTo,action2)
	nSprite:runAction(actionSequence)
end

--闪一下闪动画
function _action:actionScaleOne(nSprite,ntime,ScaleTo,Scaleback)
	local nSprite = nSprite 
	local ntime = ntime or {0.8,0.8}
	local ScaleTo = ScaleTo or  {1.3,1.3}
	local Scaleback = Scaleback or  1
	
	local actionScaleTo1 = cc.ScaleTo:create(ntime[1],ScaleTo[1],ScaleTo[2])
	local actionScaleTo2 = cc.ScaleTo:create(ntime[2],Scaleback)

	local actionSequence = cc.Sequence:create(actionScaleTo1,actionScaleTo2)
	actionSequence:setTag(18)
	nSprite:stopActionByTag(18)
	nSprite:runAction(actionSequence)
end

--闪闪动画
function _action:actionScale(nSprite,ntime,ScaleTo,Scaleback)
	local nSprite = nSprite 
	local ntime = ntime or {1.5,1.5}
	local ScaleTo = ScaleTo or  1.1
	local Scaleback = Scaleback or  1
	
	local actionScaleTo1 = cc.ScaleTo:create(ntime[1],ScaleTo)
	local actionScaleTo2 = cc.ScaleTo:create(ntime[2],Scaleback)

	local actionSequence = cc.Sequence:create(actionScaleTo1,actionScaleTo2)
	local action = cc.RepeatForever:create(actionSequence)
	action:setTag(10)
	nSprite:stopActionByTag(10)
	nSprite:runAction(action)
end
--旋转动画 
function _action:actionRotate(nSprite,ntime,rotate)
	local nSprite = nSprite 
	local ntime = ntime or 1
	local rotate = rotate or  360

	local actionRotateTo = cc.RotateBy:create(ntime, rotate)
	local action = cc.RepeatForever:create(actionRotateTo)
	nSprite:runAction(action)
end
--旋转动画 2
function _action:actionRotateTo(nSprite,ntime,ToRotate)
	local nSprite = nSprite 
	local ntime = ntime or 1
	local ToRotate = ToRotate or  360

	local actionRotateTo = cc.RotateTo:create(ntime, ToRotate)
	nSprite:runAction(actionRotateTo)
end
--旋转动画 2
function _action:actionRotateBy(nSprite,ntime,ToRotate)
	local nSprite = nSprite 
	local ntime = ntime or 1
	local ToRotate = ToRotate or  360

	local actionRotateTo = cc.RotateBy:create(ntime, ToRotate)
	nSprite:runAction(actionRotateTo)
end

--变大虚化动画
function _action:ActionScaleAndFade(Sprite,nScaleBy,callBack,ntime)
	local ntime = ntime or {0.5,0.5}
	local actionMoveTo1 = cc.EaseInOut:create(cc.ScaleBy:create(ntime[1], nScaleBy),2)
	--local actionMoveTo2 = cc.EaseInOut:create(cc.ScaleBy:create(ntime[2], 0.7),2)
	local action2 = nil

	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end
	local actionSequence = cc.Sequence:create(actionMoveTo1,action2)

	local actionFadeOut = cc.FadeOut:create(ntime[1])
	local actionSpawn = cc.Spawn:create(actionSequence,actionFadeOut)

	if Sprite then
		Sprite:runAction(actionSpawn)
	end 
end
--虚幻进入动画
function _action:ActionScaleAndFadeIn(Sprite,scaleBy,callBack,ntime,nDelayTime)
	local ntime = ntime or 0.1
	local curScale =  Sprite:getScale()
	local scaleBy = scaleBy or 1.2
	local nDelayTime = nDelayTime or 0
	Sprite:setScale(curScale*scaleBy)
	local actionScaleBy = cc.EaseInOut:create(cc.ScaleTo:create(ntime,curScale),2)
	local action2 = nil

	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end
	local delayTime =  cc.DelayTime:create(nDelayTime)
	
	local actionSequence1 = cc.Sequence:create(actionScaleBy,delayTime,action2)

	local actionFadeIn = cc.FadeIn:create(ntime)
	local actionSequence2 = cc.Sequence:create(actionFadeIn,delayTime)
	local actionSpawn = cc.Spawn:create(actionSequence1,actionSequence2)
	if Sprite then
		Sprite:runAction(actionSpawn)
	end 
end


--移动虚幻进入动画
function _action:ActionMoveAndFadeIn(Sprite,moveTo,callBack,ntime,Fade,nDelayTime)
	local ntime = ntime or 0.1
	local nDelayTime = nDelayTime or 0
	
	local actionMove = cc.MoveTo:create(ntime,moveTo)
	
	local actionScaleBy = cc.EaseInOut:create(actionMove,2)
	local action2 = nil

	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end
	local actionFade = cc.FadeIn:create(ntime)
	if Fade and Fade == 0 then
		actionFade = cc.FadeOut:create(ntime)
	end
	
	local actionSpawn = cc.Spawn:create(actionScaleBy,actionFade)
	local actionSequence1 = cc.Sequence:create(actionSpawn,action2)

	if Sprite then
		Sprite:runAction(actionSequence1)
	end 
end

--按钮变大动画
function _action:ActionBtnScale(Sprite,curScale,scaleTo,callBack,ntime)
	local ntime = ntime or 0.1
	local curScale = curScale or Sprite:getScale()
	local scaleTo = scaleTo or 1.2

	local actionScaleBy1 = cc.EaseInOut:create(cc.ScaleTo:create(ntime,scaleTo),2)
	local actionScaleBy2 = cc.EaseInOut:create(cc.ScaleTo:create(ntime,curScale),2)
	
	local action2 = nil

	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end
	local actionSequence1 = cc.Sequence:create(actionScaleBy1,actionScaleBy2,action2)

	if Sprite then
		Sprite:runAction(actionSequence1)
	end 
end

--函数：掉落动画
--参数： 
--返回： 
function _action:dropAction(Sprite,pos,height,toPos,callBack,ntime,jumpTimes,show)
	local ntime = ntime or 0.2
	local pos = pos or {x = 0,y = -30}
	local width = width or 0
	local height = height or 50
	local jump1 = cc.JumpBy:create(ntime, cc.p(pos.x, pos.y), height, 1)
	local jump2 = cc.JumpBy:create(ntime, cc.p(pos.x/2,0), height/2, 1)
	local jump3 = cc.JumpBy:create(ntime, cc.p(pos.x/4,0), height/4, 1)
	
	local EaseInOut1 = cc.EaseInOut:create(jump1,2)
	local EaseInOut2 = cc.EaseInOut:create(jump2,2)
	local EaseInOut3 = cc.EaseInOut:create(jump3,2)
	
	if jumpTimes then
		if jumpTimes == 1 then
			EaseInOut2 = nil
			EaseInOut3 = nil
		elseif jumpTimes == 2 then
			EaseInOut3 = nil
		end 
	end 
	
	local moveTo 
	if toPos == nil then	
	else
		moveTo = cc.MoveTo:create(0.5,toPos)
	end 
	
	local action2 = nil

	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end
	--local actionScalBy = cc.ScaleTo:create(nTime, 0)
	--local actionFadeOut = cc.FadeIn:create(0.2)
	local function endCallBack()
		if not show  then
			Sprite:setVisible(false)
		end 
	end
	
	local Endaction = cc.CallFunc:create(endCallBack)
	local actionSequence1 = cc.Sequence:create(EaseInOut1,EaseInOut2,EaseInOut3,moveTo,action2,Endaction)

	if Sprite then
		Sprite:runAction(actionSequence1)
	end
		
end
--对话框缩放动画
function _action:ActionDuiHuangKuang(Sprite,callBack,curScale,scaleTo,nDelayTime,ntime)
	local ntime = ntime or 0.1
	local nDelayTime = nDelayTime or 2
	local curScale = curScale or Sprite:getScale()
	local scaleTo = scaleTo or 1.2
	local scaleTo1 = scaleTo + 0.07*scaleTo
	local scaleTo2 = scaleTo - 0.06*scaleTo
	local scaleTo3 = scaleTo + 0.05*scaleTo
	local scaleTo4 = scaleTo - 0.03*scaleTo
	Sprite:setScale(curScale)
	local nActionScale = cc.ScaleTo:create(ntime,scaleTo)
	local nActionScale1 = cc.ScaleTo:create(ntime,scaleTo1)
	local nActionScale2 = cc.ScaleTo:create(ntime,scaleTo2)
	local nActionScale3 = cc.ScaleTo:create(ntime,scaleTo3)
	local nActionScale4 = cc.ScaleTo:create(ntime,scaleTo4)
	--local actionScaleBy = cc.EaseBounceInOut:create(nActionScale)
	local action2 = nil

	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end
	local delayTime =  cc.DelayTime:create(nDelayTime)
	local actionSequence1 = cc.Sequence:create(nActionScale1,nActionScale2,nActionScale3,nActionScale4,nActionScale,delayTime,action2)

	if Sprite then
		Sprite:runAction(actionSequence1)
	end 
end

--提示框缩放动画
function _action:ActionTiShiKuang(Sprite,callBack,curScale,scaleTo,ntime,nDelayTime)
	local ntime = ntime or 0.1
	local ntime1 = 0.1
	local curScale = curScale or Sprite:getScale()
	local scaleTo = scaleTo or 1.2
	local scaleTo1 = scaleTo + 0.07*scaleTo
	local scaleTo2 = scaleTo - 0.06*scaleTo
	local scaleTo3 = scaleTo + 0.05*scaleTo
	local scaleTo4 = scaleTo - 0.03*scaleTo
	Sprite:setScale(curScale)
	local nActionScale = cc.ScaleTo:create(ntime,scaleTo)
	local nActionScale1 = cc.ScaleTo:create(ntime,scaleTo1)
	local nActionScale2 = cc.ScaleTo:create(ntime,scaleTo2)
	local nActionScale3 = cc.ScaleTo:create(ntime,scaleTo3)
	local nActionScale4 = cc.ScaleTo:create(ntime,scaleTo4)
	local action2 = nil

	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end
	local delayTime =  nil
	if nDelayTime then
		delayTime =  cc.DelayTime:create(nDelayTime)
	end 
	
	local actionSequence1 = cc.Sequence:create(nActionScale1,nActionScale2,nActionScale3,nActionScale4,nActionScale,delayTime,action2)


	Sprite:stopActionByTag(88)
	actionSequence1:setTag(88)
	Sprite:runAction(actionSequence1)
end

--界面缩放动画
function _action:ActionJieMian(Sprite,callBack,curScale,scaleToY,ntime)
	Sprite:setAnchorPoint(cc.p(0.5,0))
	local ntime = ntime or 0.15
	local ntime1 = 0.1
	local curScale = curScale or Sprite:getScale()
	local scaleToY = scaleToY or 1
	local scaleTo1 = scaleToY + 0.01
	local scaleTo2 = scaleToY - 0.006
	local scaleTo3 = scaleToY + 0.003
	local scaleTo4 = scaleToY - 0.001
	--Sprite:setScale(curScale)
	local nActionScale0 = cc.ScaleTo:create(ntime,1,curScale)
	local nActionScale1 = cc.ScaleTo:create(ntime,1,scaleTo1)
	local nActionScale2 = cc.ScaleTo:create(ntime,1,scaleTo2)
	local nActionScale3 = cc.ScaleTo:create(ntime,1,scaleTo3)
	local nActionScale4 = cc.ScaleTo:create(ntime,1,scaleTo4)
	local nActionScale = cc.ScaleTo:create(ntime,1,scaleToY)
	
	local action2 = nil

	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end
	--local delayTime =  cc.DelayTime:create(nDelayTime)
	local actionSequence1 = cc.Sequence:create(nActionScale0,nActionScale1,nActionScale2,nActionScale3,nActionScale4,nActionScale,delayTime,action2)

	if Sprite then
		Sprite:runAction(actionSequence1)
	end 
end

-- bezier动画 
function _action:ActionBezierTo(Sprite,Pos_BezierTo,ntime,nScale,callBack,Pos_Bezier1,Pos_Bezier2)
	local nScale = nScale or 1
	local ntime = ntime or 0.2
	local Pos_Bezier1= Pos_Bezier1 or cc.p(0, 100)
	local Pos_Bezier2= Pos_Bezier2 or cc.p(100, 150)
	local bezier = {
		Pos_Bezier1,
		Pos_Bezier2,
		Pos_BezierTo,
	}
	
	local bezierForward = cc.BezierTo:create(ntime, bezier)
	local actionMove = cc.MoveTo:create(0.2,Pos_BezierTo )
	local actionFadeOut = cc.FadeOut:create(ntime)
	local actionScaleTo1 = cc.ScaleTo:create(ntime,nScale)
	
	local function endCallBack()
		Sprite:setVisible(false)
		if callBack then
			callBack()
		end 
	end 
	local endaction2 =cc.CallFunc:create(endCallBack)
	
	local actionSpawn = cc.Spawn:create(bezierForward,actionScaleTo1,actionFadeOut)
	local actionSequence = cc.Sequence:create(actionSpawn,endaction2)
	if Sprite then
		Sprite:runAction(actionSequence)
	end 		
end


-- bezier动画 
function _action:ActionBezierTo(Sprite,Pos_BezierTo,ntime,nScale,callBack,Pos_Bezier1,Pos_Bezier2)
	local nScale = nScale or 1
	local ntime = ntime or 0.2
	local Pos_Bezier1= Pos_Bezier1 or cc.p(0, 100)
	local Pos_Bezier2= Pos_Bezier2 or cc.p(100, 150)
	local bezier = {
		Pos_Bezier1,
		Pos_Bezier2,
		Pos_BezierTo,
	}
	
	local bezierForward = cc.BezierTo:create(ntime, bezier)
	local actionMove = cc.MoveTo:create(0.2,Pos_BezierTo )
	local actionFadeOut = cc.FadeOut:create(ntime)
	local actionScaleTo1 = cc.ScaleTo:create(ntime,nScale)
	
	local function endCallBack()
		Sprite:setVisible(false)
		if callBack then
			callBack()
		end 
	end 
	local endaction2 =cc.CallFunc:create(endCallBack)
	
	local actionSpawn = cc.Spawn:create(bezierForward,actionScaleTo1,actionFadeOut)
	local actionSequence = cc.Sequence:create(actionSpawn,endaction2)
	if Sprite then
		Sprite:runAction(actionSequence)
	end 		
end
--函数：掉落显示字 动画1  
function _action:dropPiaoziAction1(nSprit,callBack)	
	local actionMoveBy1 = cc.MoveBy:create(1,cc.p(0,40))
	nSprit:runAction(actionMoveBy1)	
end 
--函数：掉落显示字 动画end
function _action:dropPiaoziAction2(nSprit,callBack)	
	local ntime1 = 0.5
	local actionMoveBy1 = cc.MoveBy:create(ntime1,cc.p(0,40))
	local actionFadeOut2 = cc.FadeOut:create(ntime1)
	local actionSpawn2 = cc.Spawn:create(actionMoveBy1,actionFadeOut2)
	nSprit:runAction(actionSpawn2)	
end 

--函数：掉落exp or money
--参数： 
--返回： 
function _action:dropExpAction(nSprit,callBack,nMoveBy1,nMoveBy2,ntime1,ntime2)	
	local ntime1 = ntime1 or 0.5
	local ntime2 = ntime2 or 0.8
	local nMoveBy1 = nMoveBy1 or cc.p(0,80)
	local nMoveBy2 = nMoveBy2 or cc.p(0,50)
	local actionMoveBy1 = cc.EaseInOut:create(cc.MoveBy:create(ntime1,nMoveBy1),2)
	
	local function endCallback()
		nSprit:removeFromParent(true)
	end
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionMoveBy2 = cc.EaseInOut:create(cc.MoveBy:create(ntime2,nMoveBy2),2)
	local actionSequence2 = cc.Sequence:create(actionMoveBy2,actionEnd)
	local actionFadeOut2 = cc.FadeOut:create(ntime2)
	local actionSpawn2 = cc.Spawn:create(actionSequence2,actionFadeOut2)

	local actionSequence2 = cc.Sequence:create(actionMoveBy1,actionSpawn2)
	nSprit:runAction(actionSequence2)	
end 

--函数：升级动画
--参数：
--返回：
function _action:levelUpAction(ImageIcon,nScale1,nScale2,armaturePos,actionCallBack,ZOrder,speed,bExplode)
	local ImageIconClone = ImageIcon:clone()
	local speed = speed or 1
	local parent = ImageIcon:getParent()
	parent:addChild(ImageIconClone)
	ImageIconClone:setLocalZOrder(G_maxLocalZOrder-100)
	local zZOrder = ImageIcon:getLocalZOrder()
	--ImageIcon:setLocalZOrder(G_maxLocalZOrder-200)
	local posX,PosY = ImageIcon:getPosition()
	ImageIconClone:setPosition(posX,PosY)

	local function callBack()
		ImageIconClone:removeFromParent(true)
		--ImageIcon:setLocalZOrder(zZOrder)
		if actionCallBack then
			actionCallBack()
		end 
	end 
	local nScale1 = nScale1 or 1.6
	local nScale2 = nScale2 or 1
	local armaturePos = armaturePos or cc.p(68,70)
	self:ActionScaleAndFade(ImageIconClone,nScale1,callBack,{0.5*speed,0*speed})
	local bExplode = bExplode or false
	local ArmatureEndA = nil
	if bExplode == true then
		ArmatureEndA = g_gArmature:showArmature("FuncShowExplode",parent,nil,nil,armaturePos,1/speed)
		ArmatureEndA:setScale(nScale2)
		local ZOrder = ZOrder or G_maxLocalZOrder-200
		ArmatureEndA:setLocalZOrder(ZOrder)
	
	end 
	
	return ImageIconClone,ArmatureEndA
end 

--函数：打字效果动画   
--参数： 1控件；2内容；3显示间隔
--返回：
function showTextAction(nLabel,strText,nWidth,nTime,endCallBack)
	local nlen = tonumber( string.len(strText))
	local curStr = ""
	local index = 1
	local nWidth = nWidth or 525
	local function scheduleByOne()
		if index <=  nlen then
			local c = string.byte(strText, index)
			local nShift = 1
			if c > 0 and c <= 127 then
				nShift = 1
			else
				nShift = 3
			end
			local substr = string.sub(strText, index, index+nShift-1)
			curStr = curStr..substr
			--g_setString(nLabel,curStr,nWidth)
			nLabel:setTextAreaSize(cc.size(nWidth,0))
			nLabel:setString(curStr) 
			index = index + nShift
		else
			g_scheduleTime:stopScheduleForever(nLabel)
			if endCallBack then
				endCallBack()
			end 
		end
	end
	local nTime = nTime or 0.1
	nLabel:setString("")
	g_scheduleTime:scheduleForever(nLabel,nTime,scheduleByOne)
end 

--函数：打字效果动画   FGUI
--参数： 1控件；2内容；3显示间隔
--返回：
function showTextActionFGUI(nLabel,strText,nTime,endCallBack)
	local nlen = tonumber( string.len(strText))
	local curStr = ""
	local index = 1
	local function scheduleByOne()
		if index <=  nlen then
			local c = string.byte(strText, index)
			local nShift = 1
			if c > 0 and c <= 127 then
				nShift = 1
			else
				nShift = 3
			end
			local substr = string.sub(strText, index, index+nShift-1)
			curStr = curStr..substr
			nLabel:setText(curStr) 
			index = index + nShift
		else
			local nLabel = nLabel:displayObject()
			g_scheduleTime:stopScheduleForever(nLabel)
			if endCallBack then
				endCallBack()
			end 
		end
	end
	local nTime = nTime or 0.05
	nLabel:setText("")
	local nLabel = nLabel:displayObject()
	g_scheduleTime:scheduleForever(nLabel,nTime,scheduleByOne)
	
end

--函数：大招屏幕抖动效果动画   
--参数： 1控件；2 结束后的位置 ;3回调
--返回：
function  _action:shakeAction(nSprite,offY,endCallBack)
	local pos = pos or cc.p(0,0)
	local ntime1 = 0.02
	if not offY then
		offY = -10
	end 
	local PoX,PoY = 0,offY
	local nMoveBy1 = cc.p(PoX,PoY)
	local actionMoveBy1 = cc.MoveBy:create(ntime1,nMoveBy1)
	local ration = 0.8
	--ntime1 = ntime1*ration
	local PoX2 = 0
	local PoY2 = -PoY*ration
	local actionMoveBy2 = cc.MoveBy:create(ntime1,cc.p(PoX2,PoY2))
	--ntime1 = ntime1*ration
	local PoX3 = 0
	local PoY3 = PoY*ration*ration
	local actionMoveBy3 = cc.MoveBy:create(ntime1*ration,cc.p(PoX3,PoY3))
	--ntime1 = ntime1*ration
	local PoX4 =0
	local PoY4 = -PoY*ration*ration*ration
	local actionMoveBy4 = cc.MoveBy:create(ntime1*ration,cc.p(PoX4,PoY4))
	--ntime1 = ntime1*ration
	local PoX5 = 0
	local PoY5 = PoY*ration*ration*ration*ration
	local actionMoveBy5 = cc.MoveBy:create(ntime1*ration,cc.p(PoX5,PoY5))
	--ntime1 = ntime1*ration
	local PoX6 = 0
	local PoY6 = -PoY*ration*ration*ration*ration*ration
	local actionMoveBy6 = cc.MoveBy:create(ntime1*ration,cc.p(PoX6,PoY6))

	local function callback()
		nSprite:setPosition(pos)
		if endCallBack then
			endCallBack()
		end 
	end
	local actionEnd = cc.CallFunc:create(callback)
	local actionSequence2 = cc.Sequence:create(actionMoveBy1,actionMoveBy2,actionMoveBy3,actionMoveBy4,actionMoveBy5,actionEnd)
	actionSequence2:setTag(360)
	nSprite:stopActionByTag(360)
	nSprite:runAction(actionSequence2)	
end 

--函数：提示飘字动画1
--参数：
--返回：
function _action:tishiPiaoziAction(nSprite,callBackFunc,atPos)
	local function endCallback()
		if callBackFunc then
			callBackFunc()
		end 
		nSprite:setPosition(360,800)
	end
	local atPos = atPos or cc.p(360,800)
	nSprite:setPosition(atPos)
	local actionEnd = cc.CallFunc:create(endCallback)
	local nTime = 0.2
	local delayTime =  cc.DelayTime:create(0.5)
	local actionMoveBy2 = cc.EaseInOut:create(cc.MoveBy:create(0.8,cc.p(0,80)),2)
	local actionFadeOut2 = cc.FadeOut:create(1)
	local actionFadeInt = cc.FadeIn:create(0.8)
	--local actionScaleTo = cc.ScaleTo:create(nTime*3, 0.6)
	local actionSpawn2 = cc.Spawn:create(actionFadeInt,actionMoveBy2)
	
	local actionSequence = cc.Sequence:create(actionSpawn2,delayTime,actionFadeOut2,actionEnd)
	nSprite:runAction(actionSequence)	

end 

--函数：提示飘字动画2
--参数：
--返回：
function _action:tishiPiaoziAction2(nSprite,callBackFunc,midCallBack,noRemove,delayTime)
	local posX,posY = nSprite:getPosition()
	nSprite:setVisible(true)
	local function endCallback()
		if callBackFunc then
			callBackFunc()
		end 
		if not noRemove then
			nSprite:removeFromParent(true)
		else
			nSprite:setVisible(false)
			nSprite:setPosition(posX,posY)
		end 
	end
	local function midCallBack1()
		if midCallBack then
			midCallBack()
		end 
	end
	--local atPos = atPos or cc.p(360,800)
	--nSprite:setPosition(atPos)
	--cc.g_setTextColor(nSprite,1)
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionmid = cc.CallFunc:create(midCallBack1)
	local nTime = 0.2
	local delayTime = delayTime or 0.5
	local delayTime1
	if delayTime > 0 then
		delayTime1 =  cc.DelayTime:create(delayTime)
	end 
	local actionMoveBy2 = cc.EaseInOut:create(cc.MoveBy:create(1.5,cc.p(0,80)),2)
	local actionFadeOut2 = cc.FadeOut:create(1)
	local actionFadeInt = cc.FadeIn:create(1)
	--local actionScaleTo = cc.ScaleTo:create(nTime*3, 0.6)
	local actionSpawn2 = cc.Spawn:create(actionFadeInt,actionMoveBy2)
	
	local actionSequence = cc.Sequence:create(actionSpawn2,actionmid,delayTime1,actionFadeOut2,actionEnd)
	nSprite:runAction(actionSequence)	
end 

--函数：提示飘字动画3
--参数：
--返回：
function _action:tishiPiaoziAction3(nSprite,callBackFunc,atPos)
	local function endCallback()
		if callBackFunc then
			callBackFunc()
		end 
		cc.g_setTextColor(nSprite,2)
		nSprite:setPosition(360,800)
	end
	local atPos = atPos or cc.p(360,900)
	nSprite:setPosition(atPos)
	cc.g_setTextColor(nSprite,24)
	local actionEnd = cc.CallFunc:create(endCallback)
	local nTime = 0.2
	local delayTime =  cc.DelayTime:create(0.3)
	local actionMoveBy2 = cc.EaseInOut:create(cc.MoveBy:create(1,cc.p(0,-100)),2)
	local actionFadeOut2 = cc.FadeOut:create(0.5)
	local actionFadeInt = cc.FadeIn:create(1)
	--local actionScaleTo = cc.ScaleTo:create(nTime*3, 0.6)
	local actionSpawn2 = cc.Spawn:create(actionFadeInt,actionMoveBy2)

	local actionSequence = cc.Sequence:create(actionSpawn2,delayTime,actionFadeOut2,actionEnd)
	nSprite:runAction(actionSequence)
end 	


--函数：角色受击动画
--参数：1 攻击方id;2 受击方id ； 3 类型 ；4伤害
--返回： 
function _action:setHurtAction(nSprite,atPos,nPosY,nPosType,callBackFunc,nTime)
	local nTime = nTime or 0.02
	local nPosY = nPosY or 0
	local nPosType = nPosType or 2
	if not atPos then
		local pox,poy = nSprite:getPosition()
		atPos = cc.p(pox,poy)
	end 
	local actionMove1 = cc.MoveTo:create(nTime,cc.p(atPos.x,atPos.y+nPosY+6*nPosType))
	local actionMove2 = cc.MoveTo:create(nTime,cc.p(atPos.x,atPos.y+nPosY-4*nPosType))
	local actionMove3 = cc.MoveTo:create(nTime,cc.p(atPos.x,atPos.y+nPosY+2*nPosType))
	local actionMove4 = cc.MoveTo:create(nTime,cc.p(atPos.x,atPos.y+nPosY+6*nPosType))
	local actionMove5 = cc.MoveTo:create(nTime,cc.p(atPos.x,atPos.y+nPosY-4*nPosType))
	local actionMove6 = cc.MoveTo:create(nTime,cc.p(atPos.x,atPos.y+nPosY+2*nPosType))
	local actionMove7 = cc.MoveTo:create(nTime,cc.p(atPos.x,atPos.y))
	
	local function endCallback()
		if callBackFunc then
			callBackFunc()
		end 
	end
	local delayTime =  cc.DelayTime:create(2)
	local delayTime1 =  cc.DelayTime:create(0.5)
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionSequence = cc.Sequence:create(delayTime1,actionMove1,actionMove2,actionMove3,actionMove4,actionMove5,actionMove6,actionMove7,delayTime,actionEnd)
	actionSequence:setTag(50)
	nSprite:stopActionByTag(50)
	nSprite:runAction(actionSequence)	
end

--函数：角色出现动画
--参数：
--返回： 
function _action:setShowAction(nSprite,callBackFunc1,callBackFunc2,speed,curScale,atPosY,toScaleRationX,toScaleRationY)
	local curScale = curScale or 1
	local speed = speed or 1
	local nTime = 0.21*speed
	local atPosY = atPosY or 300 
	local posX,PosY = nSprite:getPosition()
	nSprite:setPosition(posX,PosY+atPosY)
	local toScaleRationX = toScaleRationX or 0.2
	local toScaleRationY = toScaleRationY or 5
	nSprite:setScale(curScale*toScaleRationX,curScale*toScaleRationY)
	
	local actionMove1 = cc.MoveTo:create(nTime,cc.p(posX,PosY))
	local actionScaleTo = cc.ScaleTo:create(nTime, curScale,curScale)
	local actionSpawn2 = cc.Spawn:create(actionMove1,actionScaleTo)

	local function showCallback()
		if callBackFunc1 then
			callBackFunc1()
		end 
	end
	local function endCallback()
		if callBackFunc2 then
			callBackFunc2()
		end 
	end
	local actionEnd1 = cc.CallFunc:create(showCallback)
	local delayTime =  cc.DelayTime:create(1)
	local actionEnd2 = cc.CallFunc:create(endCallback)
	local actionSequence = cc.Sequence:create(actionSpawn2,actionEnd1,delayTime,actionEnd2)
	
	actionSequence:setTag(52)
	nSprite:stopActionByTag(52)
	nSprite:runAction(actionSequence)
	
end

--函数：角色攻击动画
--参数：1 攻击方id;2 受击方id ； 3 类型 ；4伤害
--返回： 
function _action:setAttacAction(nSprite,atPos,nPosY,nPosType,callBackFunc,nTime)
	local nTime = nTime or 0.06
	local nPosY = nPosY or 20
	local nPosType = nPosType or 1
	local actionMove1 = cc.MoveTo:create(nTime,cc.p(atPos.x,atPos.y+nPosType*nPosY))
	local actionMove4 = cc.MoveTo:create(nTime,cc.p(atPos.x,atPos.y))
	local actionSequence = cc.Sequence:create(actionMove1,actionMove4)
	actionSequence:setTag(51)
	nSprite:stopActionByTag(51)
	nSprite:runAction(actionSequence)
	
end

--函数：伤害飘字动画
--参数：
--返回：
function _action:admageAction(nSprit)
	local actionMoveBy1 = cc.EaseInOut:create(cc.MoveBy:create(0.3,cc.p(0,10)),2)
	local function endCallback()
		nSprit:removeFromParent(true)
	end
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionMoveBy2 = cc.EaseInOut:create(cc.MoveBy:create(0.8,cc.p(0,40)),2)
	local actionSequence2 = cc.Sequence:create(actionMoveBy2,actionEnd)
	local actionFadeOut2 = cc.FadeOut:create(0.8)
	local actionSpawn2 = cc.Spawn:create(actionSequence2,actionFadeOut2)
	
	local actionSequence2 = cc.Sequence:create(actionMoveBy1,actionSpawn2)
	nSprit:runAction(actionSequence2)	
end

--函数：受伤红闪闪
--参数：
--返回：
function _action:admageHurtAction(nSprit,callBack)
	nSprit:setOpacity(0)
	local FadeTo = cc.FadeTo:create(0.03, 255)
	local FadeTo2 = cc.FadeTo:create(0.5, 0)
	local function endCallback()
		if callBack then
			callBack()
		end 
	end
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionSequence2 = cc.Sequence:create(FadeTo,FadeTo2,actionEnd)
	actionSequence2:setTag(11)
	nSprit:stopActionByTag(11)
	nSprit:runAction(actionSequence2)	
end 

--函数： 果冻效果
--参数：
--返回：
function _action:guodongAction(nSprit,nScale,nTime,callBack,number,offScale,curScale)
	local nTime = nTime or 0.1
	local offScale = offScale or 0.5
	local nScale = nScale or 1
	local nScaleTo1 = cc.ScaleTo:create(nTime,nScale + offScale)
	local nScaleTo2 = cc.ScaleTo:create(nTime,nScale - offScale*0.5)
	--local nScaleTo3 = cc.ScaleTo:create(nTime,nScale + offScale*0.5)
	--local nScaleTo4 = cc.ScaleTo:create(nTime,nScale - offScale*0.5)
	local nScaleTo5 = cc.ScaleTo:create(nTime,nScale)
	if curScale then
		nSprit:setScale(curScale)
	end 
	local function endCallback()
		if callBack then
			callBack()
		end 
	end
	local number = number or 1
	local actionEnd = cc.CallFunc:create(endCallback)
	local delayTime =  cc.DelayTime:create(1.5)
	local actionSequence2 = cc.Sequence:create(nScaleTo1,nScaleTo2,nScaleTo3,nScaleTo4,nScaleTo5,delayTime,actionEnd)

	if number then
		local actionRepeat = cc.Repeat:create(actionSequence2, number)
		actionRepeat:setTag(12)
		nSprit:stopActionByTag(12)
		nSprit:runAction(actionRepeat)	
	else
		actionSequence2:setTag(12)
		nSprit:stopActionByTag(12)
		nSprit:runAction(actionSequence2)	
	end 
end 

--函数：提示飘字动画,hszz_antion 类型
--参数：
--返回：
local tbOnlyOne = {}
local curAddCount = -2
local curAddCountTimes = 0
function _action:ts_hszz_antion(text,colorID,testIndex,addCount,parent,nDelayTime,callBack,pos,onlyOne,nTime1,nTime2,scale)
	if onlyOne  then
		if not tbOnlyOne[onlyOne] then	
			tbOnlyOne[onlyOne] = true
		else
			return
		end 
	end 
	local parentDD = 	parent or  g_GameDataMgr.rootObj 
	if not parentDD then
		return 
	end 
	cclog(text,parentDD,"======ts_hszz_antion==11====",colorID,testIndex,addCount,onlyOne)
	
	local index =  testIndex or 1
	if not g_itemPoolContorl.tipsItem then
		g_itemPoolContorl:initItemPoolRootObj("tipsItem",10,"d_node","tipsItem")
	end 
	
	local tishiLabel =  g_itemPoolContorl:getItemPoolRootObj("tipsItem") ---fgui.UIPackage:createObject("d_node","tipsItem")
	parentDD:addChild(tishiLabel)
	
	local pic = tishiLabel:displayObject()
	tishiLabel:setTouchable(false)
	
	if addCount then
		if testIndex  and curAddCountTimes == 0 then
			curAddCount = testIndex
		end 
		index = curAddCount
		curAddCountTimes = curAddCountTimes + 1
		curAddCount = curAddCount + 1
		---cclog(index,"======curAddCount======",curAddCount,curAddCountTimes)
	end 
	--local posY = 450 +(index-1)*33
	local posY = 700 +(index-1)*50
	if index > 10 then
		curAddCount = -2
		curAddCountTimes = 0
	end 
	cclog(posY,"======posY====",index,curAddCount,curAddCountTimes)
	if pos then
		tishiLabel:setPosition(pos)
	else
		if  posY >= 1350 or  posY <= 10 then
			curAddCountTimes = 0
			curAddCount = 0
			cclog(posY,"===DdD===posY====",index)
		end 
		tishiLabel:setPosition(0,posY)
	end 
	--tishiLabel:setString(text)
	--tishiLabel:setFontSize(33)
	--tishiLabel:setFontName(G_path.fontPath)
	local tishiText = tishiLabel:getChild("title")
	tishiText:setText(text)
	if scale then
		tishiText:setScale(scale,scale)
	end 

	--tishiLabel:setChildrenRenderOrder(G_maxLocalZOrder + g_ts_hszzOrder)
	local   tishiLabelD =tishiLabel:displayObject()
	tishiText=tishiText:displayObject()
	tishiLabelD:setLocalZOrder(G_maxLocalZOrder + g_ts_hszzOrder)
	if colorID then
		cc.g_setTextColor(tishiText,colorID)
	end 
	local function tishiEndCallback()
		if callBack then
			callBack()
		end 
		if onlyOne then
			tbOnlyOne[onlyOne] = nil
		end 
		g_itemPoolContorl:returnItemPool("tipsItem",tishiLabel)
		--tishiLabel:removeFromParent(true)		
	end
	
	local function tishiCallback1()
		if addCount then
			curAddCountTimes = curAddCountTimes - 1
			cclog(curAddCountTimes,"======curAddCount=222=====",curAddCount)
			if curAddCountTimes <= 0 then
				curAddCountTimes = 0
				curAddCount = -3 
			end 			
		end 
	end 
	
	local nTime = nTime1 or 1
	
	local actionMoveBy1 = cc.EaseInOut:create(cc.MoveBy:create(nTime,cc.p(0,70)),2)
	local actionFadeIn = cc.FadeIn:create(nTime)
	local actionSpawn1 = cc.Spawn:create(actionMoveBy1,actionFadeIn)
	
	local nDelayTime =  0.8
	local delayTime =  cc.DelayTime:create(nDelayTime)
	local nTime2 = nTime2 or 1
	local actionMoveBy2 = cc.EaseInOut:create(cc.MoveBy:create(nTime2,cc.p(0,20)),2)
	local actionFadeOut2 = cc.FadeOut:create(nTime2)
	local actionEnd = cc.CallFunc:create(tishiEndCallback)
	local actionEnd1 = cc.CallFunc:create(tishiCallback1)
	local actionSpawn2 = cc.Spawn:create(actionMoveBy2,actionFadeOut2)
	
	local actionSequence3 = cc.Sequence:create(actionSpawn1,delayTime,actionEnd1,actionSpawn2,actionEnd)
	tishiLabelD:runAction(actionSequence3)
	
	return	tishiLabelD
end


--函数：提示飘字动画,hszz_antion 类型
--参数：
--返回：
function _action:ts_hszz_antionIcon(text,colorID,testIndex,Icon,parent,nDelayTime,callBack,pos,onlyOne,nTime1,nTime2,addCount)
	if onlyOne  then
		if not tbOnlyOne[onlyOne] then	
			tbOnlyOne[onlyOne] = true
		else
			return
		end 
	end 
	local parentDD = 	parent or  g_GameDataMgr.rootObj 
	if not parentDD then
		return 
	end 
	cclog(text,parentDD,"======ts_hszz_antion==11====",colorID,testIndex,addCount,onlyOne)
	
	local index =  testIndex or 1
	local tishiLabel = fgui.UIPackage:createObject("d_node","tips_icon")
	parentDD:addChild(tishiLabel)
	
	local pic = tishiLabel:displayObject()
	tishiLabel:setTouchable(false)
	tishiLabel:setIcon(Icon)
	
	if addCount then
		if testIndex  and curAddCountTimes == 0 then
			curAddCount = testIndex
		end 
		index = curAddCount
		curAddCountTimes = curAddCountTimes + 1
		curAddCount = curAddCount + 1
		---cclog(index,"======curAddCount======",curAddCount,curAddCountTimes)
	end 
	local posY = 700 +(index-1)*60
	cclog(posY,"======posY==D==",index,curAddCount,curAddCountTimes)
	if pos then
		tishiLabel:setPosition(pos)
	else
		if  posY >= 1350 then
			curAddCountTimes = 0
			curAddCount = -6
			cclog(posY,"===DdD===posY==11==",index)
		end 
		tishiLabel:setPosition(0,posY)
	end 
	--tishiLabel:setString(text)
	--tishiLabel:setFontSize(33)
	--tishiLabel:setFontName(G_path.fontPath)
	local tishiText = tishiLabel:getChild("title")
	tishiText:setText(text)

	--tishiLabel:setChildrenRenderOrder(G_maxLocalZOrder + g_ts_hszzOrder)
	tishiLabel=tishiLabel:displayObject()
	tishiText=tishiText:displayObject()
	tishiLabel:setLocalZOrder(G_maxLocalZOrder + g_ts_hszzOrder)
	if colorID then
		cc.g_setTextColor(tishiText,colorID)
	end 
	local function tishiEndCallback()
		if callBack then
			callBack()
		end 
		if onlyOne then
			tbOnlyOne[onlyOne] = nil
		end 
		
		tishiLabel:removeFromParent(true)		
	end
	
	local function tishiCallback1()
		if addCount then
			curAddCountTimes = curAddCountTimes - 1
			cclog(curAddCountTimes,"======curAddCount=222=====",curAddCount)
			if curAddCountTimes <= 0 then
				curAddCountTimes = 0
				curAddCount = -3 
			end 			
		end 
	end 
	
	local nTime = nTime1 or 0.8
	
	local actionMoveBy1 = cc.EaseInOut:create(cc.MoveBy:create(nTime,cc.p(0,70)),2)
	local actionFadeIn = cc.FadeIn:create(nTime)
	local actionSpawn1 = cc.Spawn:create(actionMoveBy1,actionFadeIn)
	
	local nDelayTime =  0.5
	local delayTime =  cc.DelayTime:create(nDelayTime)
	local nTime2 = nTime2 or 1
	local actionMoveBy2 = cc.EaseInOut:create(cc.MoveBy:create(nTime2,cc.p(0,20)),2)
	local actionFadeOut2 = cc.FadeOut:create(nTime2)
	local actionEnd = cc.CallFunc:create(tishiEndCallback)
	local actionEnd1 = cc.CallFunc:create(tishiCallback1)
	local actionSpawn2 = cc.Spawn:create(actionMoveBy2,actionFadeOut2)
	
	local actionSequence3 = cc.Sequence:create(actionSpawn1,delayTime,actionEnd1,actionSpawn2,actionEnd)
	tishiLabel:runAction(actionSequence3)
	g_gameMusic:playEffect(13)
	return	tishiLabel
end


--函数：提示飘字动画222,hszz_antion 类型
--参数：
--返回：
function _action:ts_hszz_antion2(sprite,nDelayTime,callBack)
	local function endCallback()
		if callBack then
			callBack()
		end 
		sprite:removeFromParent(true)
	end
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionMoveBy1 = cc.EaseInOut:create(cc.MoveBy:create(0.8,cc.p(0,70)),2)
	local actionFadeIn = cc.FadeIn:create(0.8)
	local actionSpawn1 = cc.Spawn:create(actionMoveBy1,actionFadeIn)
	
	local nDelayTime = nDelayTime or 0.5
	local delayTime =  cc.DelayTime:create(nDelayTime)
	
	local actionMoveBy2 = cc.EaseInOut:create(cc.MoveBy:create(1,cc.p(0,20)),2)
	local actionFadeOut2 = cc.FadeOut:create(1)
	local actionSequence2 = cc.Sequence:create(actionMoveBy2,actionEnd)
	local actionSpawn2 = cc.Spawn:create(actionSequence2,actionFadeOut2)
	
	local actionSequence3 = cc.Sequence:create(actionSpawn1,delayTime,actionSpawn2)
	sprite:runAction(actionSequence3)
	cclog(text,"======ts_hszz_antion2====2222==")
	
	return	sprite
end


function _action:ts_hszz_antionEqu(text,equMsg,testIndex,addCount,parent,callBack,onlyOne)
	if onlyOne  then
		if not tbOnlyOne[onlyOne] then	
			tbOnlyOne[onlyOne] = true
		else
			return
		end 
	end 
	local parentDD = 	parent or  g_GameDataMgr.rootObj 
	if not parentDD then
		return 
	end 
	cclog(text,parentDD,"======ts_hszz_antion==11====",colorID,testIndex,addCount,onlyOne)
	
	local index =  testIndex or 1
	local tishiLabel = fgui.UIPackage:createObject("d_node","tips_Euq")
	parentDD:addChild(tishiLabel)
	
	local pic = tishiLabel:displayObject()
	tishiLabel:setTouchable(false)

	if addCount then
		if testIndex  and curAddCountTimes == 0 then
			curAddCount = testIndex
		end 
		index = curAddCount
		curAddCountTimes = curAddCountTimes + 1
		curAddCount = curAddCount + 1
		---cclog(index,"======curAddCount======",curAddCount,curAddCountTimes)
	end 
	local posY = 700 +(index-1)*60
	cclog(posY,"======posY==D==",index,curAddCount,curAddCountTimes)
	if pos then
		tishiLabel:setPosition(pos)
	else
		if  posY >= 1350 then
			curAddCountTimes = 0
			curAddCount = -6
			cclog(posY,"===DdD===posY==11==",index)
		end 
		tishiLabel:setPosition(0,posY)
	end 
	local tishiText = tishiLabel:getChild("title")
	tishiText:setText(text)
	
	
	
	for i=1,2 do
		
		local euqAtt = tishiLabel:getChild("euqAtt"..i)
		local lev = equMsg[i] or 0
		if lev <= 0 then
			euqAtt:setVisible(false)
		else
			euqAtt:setVisible(true)
			euqAtt:setIcon(g_iconConTrol:getABCDIcon(lev))
		end 
	end 
	tishiLabel=tishiLabel:displayObject()
	tishiText=tishiText:displayObject()
	tishiLabel:setLocalZOrder(G_maxLocalZOrder + g_ts_hszzOrder)
	local  colorID = equMsg.colorID
	cc.g_setTextColor(tishiText,colorID)
	local function tishiEndCallback()
		if callBack then
			callBack()
		end 
		if onlyOne then
			tbOnlyOne[onlyOne] = nil
		end 
		
		tishiLabel:removeFromParent(true)		
	end
	
	local function tishiCallback1()
		if addCount then
			curAddCountTimes = curAddCountTimes - 1
			cclog(curAddCountTimes,"======curAddCount=222=====",curAddCount)
			if curAddCountTimes <= 0 then
				curAddCountTimes = 0
				curAddCount = -3 
			end 			
		end 
	end 
	
	local nTime = nTime1 or 0.8
	
	local actionMoveBy1 = cc.EaseInOut:create(cc.MoveBy:create(nTime,cc.p(0,70)),2)
	local actionFadeIn = cc.FadeIn:create(nTime)
	local actionSpawn1 = cc.Spawn:create(actionMoveBy1,actionFadeIn)
	
	local nDelayTime =  0.5
	local delayTime =  cc.DelayTime:create(nDelayTime)
	local nTime2 = nTime2 or 1
	local actionMoveBy2 = cc.EaseInOut:create(cc.MoveBy:create(nTime2,cc.p(0,20)),2)
	local actionFadeOut2 = cc.FadeOut:create(nTime2)
	local actionEnd = cc.CallFunc:create(tishiEndCallback)
	local actionEnd1 = cc.CallFunc:create(tishiCallback1)
	local actionSpawn2 = cc.Spawn:create(actionMoveBy2,actionFadeOut2)
	
	local actionSequence3 = cc.Sequence:create(actionSpawn1,delayTime,actionEnd1,actionSpawn2,actionEnd)
	tishiLabel:runAction(actionSequence3)
	g_gameMusic:playEffect(13)
	return	tishiLabel
end

--函数：物品抖动动画
--参数：
--返回：
function _action:itemShakeAction(sprite,ntimeR)
	local rotate = 6
	local ntime1 = ntimeR or  0.2
	local ntime2 = ntimeR or  0.2
	local posX,posY = sprite:getPosition()
	local  actionRotateTo1 = cc.RotateBy:create(ntime1, rotate)
	local  actionRotateTo2 = cc.RotateBy:create(ntime1, -rotate*0.7)
	local  actionRotateTo3 = cc.RotateBy:create(ntime1, rotate*0.7)
	local  actionRotateTo4 = cc.RotateBy:create(ntime1, -rotate)
	local  actionRotateTo5 = cc.RotateBy:create(ntime1, 0)
	local actionSequence1 = cc.Sequence:create(actionRotateTo1,actionRotateTo2,actionRotateTo3,actionRotateTo4,actionRotateTo5)
	local nRandom = math.random(1,3)
	local moveTo1 = cc.MoveTo:create(ntime2,cc.p(posX+nRandom,posY+nRandom))
	local moveTo2 = cc.MoveTo:create(ntime2,cc.p(posX-nRandom,posY+nRandom))
	local moveTo3 = cc.MoveTo:create(ntime2,cc.p(posX+nRandom,posY-nRandom))
	local moveTo4 = cc.MoveTo:create(ntime2,cc.p(posX-nRandom,posY-nRandom))
	local moveTo5 = cc.MoveTo:create(ntime2,cc.p(posX,posY))
	local actionSequence2 = cc.Sequence:create(moveTo1,moveTo2,moveTo3,moveTo4,moveTo5)
	local actionSpawn1 = cc.Spawn:create(actionSequence1,actionSequence2)
	local action = cc.RepeatForever:create(actionSpawn1)
	action:setTag(1009)
	sprite:stopActionByTag(1009)
	sprite:runAction(action)
end



--函数：吸血飘字动画
--参数：
function _action:sbloodAction(nSprit)
	local actionMoveBy1 = cc.EaseInOut:create(cc.MoveBy:create(0.3,cc.p(0,-10)),2)
	local function endCallback()
		nSprit:removeFromParent(true)
	end
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionMoveBy2 = cc.EaseInOut:create(cc.MoveBy:create(0.8,cc.p(0,-40)),2)
	local actionSequence2 = cc.Sequence:create(actionMoveBy2,actionEnd)
	local actionFadeOut2 = cc.FadeOut:create(0.8)
	local actionSpawn2 = cc.Spawn:create(actionSequence2,actionFadeOut2)
	
	local actionSequence2 = cc.Sequence:create(actionSpawn2)
	nSprit:runAction(actionSequence2)	
end

--函数：暴击伤害飘字动画
--参数：
--返回：
function _action:admageCritAction(nSprit,callBack,nTime1,nTime2)
	local nTime1 = nTime1 or 0.2
	local nTime2 = nTime2 or 0.5
	local actionMoveBy1 = cc.EaseInOut:create(cc.MoveBy:create(nTime1,cc.p(0,30)),2)
	local actionScaleBy = cc.EaseInOut:create(cc.ScaleBy:create(nTime1,2),2)
	local actionSpawn1 = cc.Spawn:create(actionMoveBy1,actionScaleBy)
	
	local function endCallback()
		nSprit:removeFromParent(true)
		if callBack then
			callBack()
		end 
	end
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionMoveBy2 = cc.EaseInOut:create(cc.MoveBy:create(nTime2,cc.p(0,40)),2)
	local actionSequence2 = cc.Sequence:create(actionMoveBy2,actionEnd)
	local actionFadeOut2 = cc.FadeOut:create(nTime2)
	local actionSpawn2 = cc.Spawn:create(actionSequence2,actionFadeOut2)
	
	local actionSequence2 = cc.Sequence:create(actionSpawn1,actionSpawn2)
	nSprit:runAction(actionSequence2)	
end


--函数：飞过去飞回来
--参数：
--返回：
function _action:attackMoveToBackction(nSprite,atPos,toPos,callBack,callBack2,callBack3,nTime,delayTime)
	local nTime = nTime or 0.3
	nSprite:setPosition(atPos.x,atPos.y)
	
	local actionMoveBy1 = cc.MoveTo:create(nTime,toPos)
	local actionMoveBy2 = cc.MoveTo:create(nTime/2,atPos)
	local function endCallback3()
		if callBack3 then
			callBack3()
		end 
	end
	local function endCallback2()
		if callBack2 then
			callBack2()
		end 
	end
	
	local function endCallback1()
		if callBack then
			callBack()
		end 
	end
	local delayTime = delayTime or 0.3
	local delayTime =  cc.DelayTime:create(delayTime)
	
	local actionEnd1 = cc.CallFunc:create(endCallback1)
	local actionEnd2 = cc.CallFunc:create(endCallback2)
	local actionEnd3 = cc.CallFunc:create(endCallback3)
	local actionSequence2 = cc.Sequence:create(actionMoveBy1,actionEnd1,delayTime,actionEnd2,actionMoveBy2,actionEnd3)
	actionSequence2:setTag(13)
	nSprite:stopActionByTag(13)
	nSprite:runAction(actionSequence2)	
end 


--函数：飞过去的动画
--参数：
--返回：
function _action:attackMoveToAction(nSprite,atPos,toPos,callBack,callBack2,nTime,delayTime)
	local nTime = nTime or 0.3
	if atPos then
		nSprite:setPosition(atPos.x,atPos.y)
	end
	
	
	local actionMoveBy = cc.MoveTo:create(nTime,toPos)
	local function endCallback()
		if callBack then
			callBack()
		end 
	end
	
	local delayTime = delayTime or 0.3
	local delayTime =  cc.DelayTime:create(delayTime)
	
	local actionEnd = cc.CallFunc:create(endCallback)
	
	local function endCallback2()
		if callBack2 then
			callBack2()
		end 
	end
	local actionEnd2 = cc.CallFunc:create(endCallback2)
	
	local actionSequence2 = cc.Sequence:create(actionMoveBy,actionEnd,delayTime,actionEnd2)
	actionSequence2:setTag(13)
	nSprite:stopActionByTag(13)
	nSprite:runAction(actionSequence2)	
end 


--函数：提示框慢慢向上移动动画
--参数：
--返回：
function _action:tishiUpAction(nSprit,toPos,callBack,nTime)
	local nTime = nTime or 1
	local toPos = toPos or cc.p(0,100)
	local actionMoveBy1 = cc.MoveTo:create(nTime,toPos)
	local function endCallback()
		if callBack then
			callBack()
		end 
	end
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionSequence2 = cc.Sequence:create(actionMoveBy1,actionEnd)
	actionSequence2:setTag(115)
	nSprit:stopActionByTag(115)
	nSprit:runAction(actionSequence2)	
end

--函数：飞过去的动画
--参数：
--返回：
function _action:moveToAction(nSprite,atPos,toPos,callBack,bRotate,nTime)
	local nTime = nTime or 0.3
	if atPos then
		nSprite:setPosition(atPos.x,atPos.y)
	end 
	
	local NRotate = 0
	if bRotate then
		local nAtan = (toPos.x - atPos.x)/(toPos.y - atPos.y)
		local NRotate =  math.deg(math.atan(nAtan))	
		--cclog(NRotate,toPos,atPos,"==============NRotate===============")
		nSprite:setRotation(NRotate) 
	end 
	
	local actionMoveBy = cc.MoveTo:create(nTime,toPos)
	local function endCallback()
		if callBack then
			callBack()
		end 
	end
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionSequence2 = cc.Sequence:create(actionMoveBy,actionEnd)
	actionSequence2:setTag(13)
	nSprite:stopActionByTag(13)
	nSprite:runAction(actionSequence2)	
end 


--函数：飞过去的动画
--参数：
--返回：
function _action:moveByAction(nSprite,atPos,toPos,callBack,bRotate,nTime)
	local nTime = nTime or 0.3
	if atPos then
		nSprite:setPosition(atPos.x,atPos.y)
	end 
	
	local NRotate = 0
	if bRotate then
		local nAtan = (toPos.x - atPos.x)/(toPos.y - atPos.y)
		local NRotate =  math.deg(math.atan(nAtan))	
		--cclog(NRotate,toPos,atPos,"==============NRotate===============")
		nSprite:setRotation(NRotate) 
	end 
	
	local actionMoveBy = cc.MoveBy:create(nTime,toPos)
	local function endCallback()
		if callBack then
			callBack()
		end 
	end
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionSequence2 = cc.Sequence:create(actionMoveBy,actionEnd)
	actionSequence2:setTag(13)
	nSprite:stopActionByTag(13)
	nSprite:runAction(actionSequence2)	
end 


--函数：飞过去的动画 缩小
--参数：
--返回：
function _action:moveToScaleAction(nSprite,atPos,toPos,callBack,scale,nTime)
	local nTime = nTime or 2
	local scale = scale or 1
	--nSprite:setPosition(atPos.x,atPos.y)
	nSprite:setScale(scale)

	local actionMoveBy = cc.MoveTo:create(nTime,toPos)
	local actionScalBy = cc.ScaleTo:create(nTime, 0)
	local function endCallback()
		if callBack then
			callBack()
		end 
	end
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionSpawn = cc.Spawn:create(actionMoveBy,actionScalBy)
	
	local actionSequence2 = cc.Sequence:create(actionSpawn,actionEnd)
	actionSequence2:setTag(13)
	nSprite:stopActionByTag(13)
	nSprite:runAction(actionSequence2)	
end 

--函数：pannel 弹出 动画 22
--参数：
--返回：
function _action:pannelMoveAction(nSprite,toPos,callBack,nTime)
	local nTime = nTime or 0.5
	
	local actionMoveBy = cc.MoveTo:create(nTime,toPos)
	local function endCallback()
		cclog(toPos,"=============toPos========")
		if callBack then
			callBack()
		end 
	end
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionMoveTo1 = cc.EaseInOut:create(actionMoveBy,2)
	local actionSequence2 = cc.Sequence:create(actionMoveTo1,actionEnd)
	actionSequence2:setTag(22)
	nSprite:stopActionByTag(22)
	nSprite:runAction(actionSequence2)	
end 

--函数：提示获得： 物品名字
--参数：
--返回：
function _action:getTishiActionBycfgID(Obj,text,index,nDelayTime,callBack,endText)
	local goodsType
	if type(Obj) == "number" then
		goodsType = math.floor( Obj/100000)
	else
		local cfgID = Obj:getCfgID()
		goodsType = math.floor( cfgID/100000)
	end 
	local textName = text or "获得: "
	local endText = endText or ""
	local colorID 
	if goodsType <= 0  then --sjZb
		local tbZBMsg = g_CDataMgr:getZhuangBeiTbMsg(Obj)
		textName = textName..tbZBMsg.name..endText	
		colorID = Obj:getYanshe()
	elseif goodsType == 1  then	  --goods
		local tbDJData = g_CDataMgr:getCsvCfgData("goodsD",Obj)
		textName = textName..tbDJData.name..endText	
		colorID = tbDJData.colour
	elseif goodsType == 2  then	  --ss
		local tbZBMsg = g_CDataMgr:getZhuangBeiTbMsg(Obj)
		textName = textName..tbZBMsg.name..endText		
		
		colorID = Obj:getYanshe()
	elseif goodsType == 3  then	  --tt
		local tbZBMsg = g_CDataMgr:getZhuangBeiTbMsg(Obj)
		textName = textName..tbZBMsg.name..endText		
		
		colorID = Obj:getYanshe()
	elseif goodsType == 4  then	  --fw
		local tbfuwenData = g_CDataMgr:getCsvCfgData("runeD",Obj)
		textName = textName..tbfuwenData.name_CN1..endText		
		colorID =tbfuwenData.level
	end 
	
	local textItem  = self:ts_hszz_antion(textName,nil,index,nDelayTime,callBack)
	--cclog(colorID,goodsType,"========colorID=====")
	
	textItem:setColor(G_tb_starTextColor[colorID])
	return textItem,textName
end 

--函数：购买提示获得： 物品名字
--参数：
--返回：
function _action:getScTishiActionBycfgID(Obj,text,index,nDelayTime,callBack)
	
	local textName = text or "获得: "
	local colorID 

	local tbDJData = g_CDataMgr:getCsvCfgData("sellGoodsD",Obj)
	cclog(tbDJData.name,"============tbDJData.name=========")
	textName = textName..tbDJData.name
	colorID = tbDJData.colour
	
	local textItem  = self:ts_hszz_antion(textName,nil,index,nDelayTime,callBack)

	textItem:setColor(G_tb_starTextColor[colorID])
end 

--函数：弹出 果冻2
--参数：
--返回：
function _action:getShowKuangActionByGD2(Sprite,nScale,callBack,ntime,nType)
	local ntime = ntime or 0.5

	local actionScaleTo = cc.ScaleTo:create(ntime,nScale)
	local actionScaleBy = cc.EaseBounceIn:create(actionScaleTo)
	
	local action2 = nil
	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end
	local actionFade =cc.FadeOut:create(ntime)
	if nType ~= 1 then
		actionFade = cc.FadeIn:create(ntime)
	end 

	local actionSequence = cc.Sequence:create(actionScaleBy,action2)
	
	local actionSpawn = cc.Spawn:create(actionSequence,actionFade)
	
	if Sprite then
		actionSpawn:setTag(56)
		Sprite:stopActionByTag(56)
		Sprite:runAction(actionSpawn)
	end 
end 


--函数：弹出 果冻
--参数：
--返回：
function _action:getShowKuangActionByGD(Sprite,toPos,callBack,ntime,nType)
	local ntime = ntime or 0.2
	
	local actionMoveTo1 = cc.MoveTo:create(ntime,toPos)

	local actionScaleBy = cc.EaseBounceInOut:create(actionMoveTo1)
	
	local action2 = nil
	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end
	local actionFade =cc.FadeOut:create(ntime)
	if nType ~= 1 then
		actionFade = cc.FadeIn:create(ntime)
	end 

	local actionSequence = cc.Sequence:create(actionScaleBy,action2)
	
	local actionSpawn = cc.Spawn:create(actionSequence,actionFade)
	
	if Sprite then
		actionSpawn:setTag(56)
		Sprite:stopActionByTag(56)
		Sprite:runAction(actionSpawn)
	end 
end


--函数：点击龙蛋
--参数：
--返回：
function _action:touchDanAction(Sprite)
	local ntime = 0.04
	

	local actionRotateTo1 = cc.RotateTo:create(ntime, 8)
	local actionRotateTo2 = cc.RotateTo:create(ntime, -6)
	local actionRotateTo3 = cc.RotateTo:create(ntime, 4)
	local actionRotateTo4 = cc.RotateTo:create(ntime, -2)
	local actionRotateTo5 = cc.RotateTo:create(ntime, 0)
	local actionRotateTo6 = cc.RotateTo:create(ntime, 0)
	
	local action2 = nil
	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end
	local actionSequence = cc.Sequence:create(actionRotateTo1,actionRotateTo2,actionRotateTo3,actionRotateTo4,actionRotateTo5,actionRotateTo6,action2)
	actionSequence:setTag(102)
	if Sprite then
		Sprite:stopActionByTag(102)
		Sprite:runAction(actionSequence)
	end 
end

--函数：星星旋转移动
--参数：
--返回：
function _action:starAction(Sprite,toPos,callBack,ntime1,rotate,Pos_Bezier1,Pos_Bezier2,fadeOutTime,nScale)

	local ntime = ntime1 or 2
	local rotate = rotate or  360
	local fadeOutTime = fadeOutTime or 0.5
	local rotateByTime = ntime+fadeOutTime
	local actionRotateBy = cc.RotateBy:create(rotateByTime, rotate)	
	
	local Pos_Bezier1= Pos_Bezier1 or cc.p(300, 100)
	local Pos_Bezier2= Pos_Bezier2 or cc.p(300, 200)
	local bezier = {
		Pos_Bezier1,
		Pos_Bezier2,
		toPos,
	}
	local bezierForward = cc.BezierTo:create(ntime, bezier)
	local actionFadeOut = cc.FadeOut:create(fadeOutTime)
	local nScale = nScale or 0.5
	local actionScaleTo = cc.ScaleTo:create(rotateByTime,nScale)
	local action2 = nil
	if callBack then
		action2 = cc.CallFunc:create(callBack)
	end
	local actionSequence = cc.Sequence:create(bezierForward,actionFadeOut,action2)
	local actionSpawn = cc.Spawn:create(actionSequence,actionRotateBy)

	actionSpawn:setTag(103)
	Sprite:stopActionByTag(103)
	Sprite:runAction(actionSpawn)
end

--函数：按钮旋转缩小/放大Bezier移动
--参数：
--返回：
function _action:btnAction(Sprite,toPos,callBack,fadeType,ntime1,rotate,nScale,bBounce)

	local ntime = ntime1 or 2 --移动时间
	local rotate = rotate or  360

	
	local actionRotateBy = cc.RotateTo:create(ntime, rotate)
	local actionMoveTo1 = cc.MoveTo:create(ntime,toPos)
	if bBounce then
		actionMoveTo1 = cc.EaseBounceOut:create(actionMoveTo1)	
	end 
	local actionFade = cc.FadeOut:create(ntime)
	if not fadeType or fadeType == 1 then
		actionFade = cc.FadeIn:create(ntime)
	end 
	local nScale = nScale or 0.5
	local actionScaleTo = cc.ScaleTo:create(ntime,nScale)
	
	local function callBackAction()
		if callBack then
			callBack(Sprite)
		end
	end 
	local action2 = cc.CallFunc:create(callBackAction)
	
	local actionSpawn = cc.Spawn:create(actionMoveTo1,actionFade,actionScaleTo,actionRotateBy)

	local actionSequence = cc.Sequence:create(actionSpawn,action2)

	actionSequence:setTag(103)
	Sprite:stopActionByTag(103)
	Sprite:runAction(actionSequence)
end

--函数：闪光特效／滑光特效
--参数：
--返回：
function _action:sparkClipAction(Sprite)
	local posX,posY = Sprite:getPosition()
	local ScaleX = Sprite:getScaleX()
	local ScaleY = Sprite:getScaleY()
	local parent = Sprite:getParent()
	if Sprite then
		Sprite:removeFromParent(true)
	end 
	
	local gameTitle = display.newSprite("UEBB/loading/titleBB.png")  
	local clipSize = gameTitle:getContentSize()  
	
	local spark = display.newSprite("spark.png")  
	spark:setPosition(-clipSize.width,0)  
	
	local spark2 = display.newSprite("spark.png")  
	spark2:setPosition(0,clipSize.height)  
	  
	local clippingNode = cc.ClippingNode:create()  
	clippingNode:setPosition(posX,posY)  
	--clippingNode:addTo(self)  
	gameTitle:setScaleX(ScaleX)
	gameTitle:setScaleY(ScaleY)
	clippingNode:setAlphaThreshold(0.05)  
	clippingNode:setContentSize(clipSize)  
	  
	clippingNode:setStencil(gameTitle)  
	clippingNode:addChild(gameTitle,1)  
	clippingNode:addChild(spark,2)  
	clippingNode:addChild(spark2,3) 
	
	spark:setRotation(30)
	spark2:setRotation(-30)
	local move = cc.MoveBy:create(1.2,cc.p(clipSize.width*2,0))  
	--local actionRotateTo = cc.RotateBy:create(2, 300)
	--local actionSpawn1 = cc.Spawn:create(move,actionRotateTo)
	
	local delayTime =  cc.DelayTime:create(1)
	local moveback = cc.MoveBy:create(1.2,cc.p(-clipSize.width*2,0))  
	local actionRotateTo2 = cc.RotateBy:create(2, -300)
	--local actionSpawn1 = cc.Spawn:create(moveback,actionRotateTo2)
	spark:runAction(cc.RepeatForever:create(cc.Sequence:create(move,delayTime,moveback)))
	

	local move = cc.MoveBy:create(2,cc.p(0,-clipSize.height*2))  
	--local actionRotateTo = cc.RotateBy:create(2, 300)
	--local actionSpawn1 = cc.Spawn:create(move,actionRotateTo)
	local delayTime =  cc.DelayTime:create(1)
	
	local moveback = cc.MoveBy:create(2,cc.p(0,clipSize.height*2)) 
	--local actionRotateTo2 = cc.RotateBy:create(2, -300)
	--local actionSpawn1 = cc.Spawn:create(moveback,actionRotateTo2)
	spark2:runAction(cc.RepeatForever:create(cc.Sequence:create(move,delayTime,moveback)))
	
	parent:addChild(clippingNode,1)
	return clippingNode
end 

--函数：g攻击 飞过去的动画
--参数：
--返回：
function _action:attackCritAction(nSprite,atPos,toPos,callBack,bRotate,nTime)
	local nTime = nTime or 0.3
	nSprite:setPosition(atPos.x,atPos.y)
	local NRotate = 0
	if bRotate then
		local nAtan = (toPos.x - atPos.x)/(toPos.y - atPos.y)
		local NRotate =  math.deg(math.atan(nAtan))	
		--cclog(NRotate,toPos,atPos,"==============NRotate===============")
		nSprite:setRotation(NRotate) 
	end 
	
	local actionMoveBy = cc.MoveTo:create(nTime,toPos)
	local function endCallback()
		if callBack then
			callBack()
		end 
	end
	local actionEnd = cc.CallFunc:create(endCallback)
	local actionSequence2 = cc.Sequence:create(actionMoveBy,actionEnd)
	actionSequence2:setTag(13)
	nSprite:stopActionByTag(13)
	nSprite:runAction(actionSequence2)	
end 

function _action:ctor()
end

g_action =  _action:create()
