------------------
-- 文件名:	itemPoolContorl.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local itemPoolContorl = class("itemPoolContorl")


---=====================================
function itemPoolContorl:initItemPool(poolName,number,packageName,itemName)
	if not self.itemPool[poolName] then
		self.itemPool[poolName] = {}
		self.itemPool[poolName][0] = {packageName = packageName ,itemName = itemName}
	end 
	local index = #self.itemPool[poolName]
	if   index > number  then	
		return
	end 
	for i= index+1,number do
		local panle = fgui.UIPackage:createObject(packageName, itemName)
		panle:setCustomData(i) 
		local B_FbBat = g_WndMgr:getWnd("B_FbBat")
		local parentPanle =  B_FbBat.rootLayout:getChild("enemyPanle") 
		parentPanle:addChild(panle)
		panle:setVisible(false)
		self.itemPool[poolName][i] = {item = panle,status = 0}
	end  
end 

function itemPoolContorl:getItemPool(poolName)
	if not self.itemPool[poolName] then
		self.itemPool[poolName] = {}
	end 
	for i,tbmsg in pairs(self.itemPool[poolName])do
		if tbmsg.status  == 0  then
			self.itemPool[poolName][i].status = 1
			tbmsg.item:setVisible(true)
			return tbmsg.item
		end 
	end 
	local index = #self.itemPool[poolName]+1
	local packageName = self.itemPool[poolName][0].packageName
	local itemName = self.itemPool[poolName][0].itemName
	local panle = fgui.UIPackage:createObject(packageName,itemName)
	panle:setCustomData(index) 
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local parentPanle =  B_FbBat.rootLayout:getChild("enemyPanle") 
	parentPanle:addChild(panle)
	panle:setVisible(true)
	self.itemPool[poolName][index] = {item = panle,status = 1}
	--self.itemPool[poolName][index] = {panle,1}
	--cclog("=========adddd======",index,poolName)
	return panle
end 

function itemPoolContorl:returnItemPool(poolName,item)
	local index = item:getCustomData() 
	--cclog("=======returnItemPool======",poolName,index)
	self.itemPool[poolName][index] = {item = item,status = 0}
	item:setVisible(false)
end 

----===================================================
function itemPoolContorl:initItemPoolRootObj(poolName,number,packageName,itemName)
	if not self.itemPool[poolName] then
		self.itemPool[poolName] = {}
		self.itemPool[poolName][0] = {packageName = packageName ,itemName = itemName}
	end 
	local index = #self.itemPool[poolName]
	if   index > number  then	
		return
	end 
	for i= index+1,number do
		local panle = fgui.UIPackage:createObject(packageName, itemName)
		panle:setCustomData(i) 
		g_GameDataMgr.rootObj :addChild(panle)
		panle:setVisible(false)
		self.itemPool[poolName][i] = {item = panle,status = 0}
	end  
end 

function itemPoolContorl:getItemPoolRootObj(poolName)
	if not self.itemPool[poolName] then
		self.itemPool[poolName] = {}
	end 
	for i,tbmsg in pairs(self.itemPool[poolName])do
		if tbmsg.status  == 0  then
			self.itemPool[poolName][i].status = 1
			tbmsg.item:setVisible(true)
			return tbmsg.item
		end 
	end 
	local index = #self.itemPool[poolName]+1
	local packageName = self.itemPool[poolName][0].packageName
	local itemName = self.itemPool[poolName][0].itemName
	local panle = fgui.UIPackage:createObject(packageName,itemName)
	panle:setCustomData(index) 

	g_GameDataMgr.rootObj:addChild(panle)
	panle:setVisible(true)
	self.itemPool[poolName][index] = {item = panle,status = 1}
	--cclog("=========adddd======",index,poolName)
	return panle
end 



---=====================================
function itemPoolContorl:initItemPoolPk(poolName,number,packageName,itemName)
	if not self.itemPoolPk[poolName] then
		self.itemPoolPk[poolName] = {}
		self.itemPoolPk[poolName][0] = {packageName = packageName ,itemName = itemName}
	end 
	local index = #self.itemPoolPk[poolName]
	if   index > number  then	
		return
	end 
	for i= index+1,number do
		local panle = fgui.UIPackage:createObject(packageName, itemName)
		panle:setCustomData(i) 
		local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
		local parentPanle =  B_FbBatPk.rootLayout:getChild("skillPanle") 
		parentPanle:addChild(panle)
		panle:setVisible(false)
		self.itemPoolPk[poolName][i] = {item = panle,status = 0}
	end  
end 

function itemPoolContorl:getItemPoolPk(poolName)
	if not self.itemPoolPk[poolName] then
		self.itemPoolPk[poolName] = {}
	end 
	for i,tbmsg in pairs(self.itemPoolPk[poolName])do
		if tbmsg.status  == 0  then
			self.itemPoolPk[poolName][i].status = 1
			tbmsg.item:setVisible(true)
			return tbmsg.item
		end 
	end 
	local index = #self.itemPoolPk[poolName]+1
	local packageName = self.itemPoolPk[poolName][0].packageName
	local itemName = self.itemPoolPk[poolName][0].itemName
	local panle = fgui.UIPackage:createObject(packageName,itemName)
	panle:setCustomData(index) 
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	local parentPanle =  B_FbBatPk.rootLayout:getChild("skillPanle") 
	parentPanle:addChild(panle)
	panle:setVisible(true)
	self.itemPoolPk[poolName][index] =  {item = panle,status = 1}
	--cclog("=========adddd======",index,poolName)
	return panle
end 

function itemPoolContorl:returnItemPoolPk(poolName,item)
	local index = item:getCustomData() 
	--cclog("=======returnItemPool======",poolName,index)
	self.itemPoolPk[poolName][index] = {item = item,status = 0}
	item:setVisible(false)
end 


function itemPoolContorl:ctor()
	self.itemPool = {}
	self.itemPoolPk = {}
end

g_itemPoolContorl =  itemPoolContorl:create()