------------------
-- 文件名:	g_Botton.lua
-- 版  权:	(C)铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2017-6-17 9:37
-- 版  本:	1.0
-- 描  述:	通用Game_RewardBox控件设置函数
-- 应  用:  本例子是用类对象的方式实现
-------------------


function setCloseBtn(layerout, callback, szName)
    szName = szName or "Button_Return"
	local btnName = tolua.cast(layerout:getChildByName(szName),"Button")
	btnName:setTouchEnabled(true)
	local function onClickReturn(pSender, eventType)
		if eventType == TOUCH_EVENT_ENDED then
			layerout:setVisible(false)
			if callback then
				callback()
			end
		end
	end
	btnName:addTouchEventListener(onClickReturn)
end

function g_btnLoadTextures(widgetBtn, normalTures,selectedTures,disabledTures)
	widgetBtn:loadTextures(normalTures,selectedTures,disabledTures)
end

--设置
function g_SetBtnText(widgetBtn,text)
	widgetBtn:setTitleText(text)
end
--设置
function g_SetBtnColor(widgetBtn,Color)
	widgetBtn:setTitleColor(Color)
end

--设置
function g_SetBtnFontName(widgetBtn,FontName)
	widgetBtn:setTitleFontName(FontName)
end

--设置是否响应事件
function g_SetBtnTouch(widgetBtn, bEnabled)
	--widgetBtn:setTouchEnabled(bEnabled)
	---setChangeStateOnClick
	widgetBtn:setTouchable(bEnabled)	
end

--设置灰化
function g_SetBtnBright(widgetBtn, bEnabled)
	widgetBtn:setGrayed(not  bEnabled)
end

--设置点击放大
function g_SetBtnPressAction(widgetBtn, bEnabled)
	widgetBtn:setPressedActionEnabled(bEnabled)
end

--启用正常，禁用同时灰化
function g_SetBtnEnable(widgetBtn, bEnabled)
	g_SetBtnTouch(widgetBtn, bEnabled)
	g_SetBtnBright(widgetBtn, bEnabled)
end

--启用正常，禁用并灰化，点击放大
function g_SetBtnEnableAndPress(widgetBtn, bEnabled)
	g_SetBtnTouch(widgetBtn, bEnabled)	
	g_SetBtnPressAction(widgetBtn, bEnabled)
	g_SetBtnBright(widgetBtn, bEnabled)
end


---覆盖响应，唯一响应
function g_SetBtnOne(_view, strName,tag, funcEndCallBack,btn,isGuideWnd)
	if funcEndCallBack then
		local btn = btn or _view:getChild(strName)
		if btn then 
			btn:removeClickListener()
			btn:addClickListener(function() 
				g_gameMusic:playEffect(16)
				funcEndCallBack(btn,tag) 
				if g_newGuideWnd.tbMsg   and not isGuideWnd  then	
					if g_newGuideWnd.tbMsg.func then
						g_newGuideWnd.tbMsg.func()
					end 
				end 
			end)
			
		else	
			cclog("=not=btn===")
		end 
	end 
	return btn
end
--不覆盖 传名字
function g_SetBtn(_view, strName,tag, funcEndCallBack)
	if funcEndCallBack then
		local btn = _view:getChild(strName)
		if btn then 
			btn:addClickListener(function() 
				g_gameMusic:playEffect(16)
				funcEndCallBack(btn,tag) 
				if g_newGuideWnd.tbMsg   and not isGuideWnd  then	
					if g_newGuideWnd.tbMsg.func then
						g_newGuideWnd.tbMsg.func()
					end 
				end 
			end)
		else	
			cclog("=not=btn===")
		end 
	end 
	return btn
end
--不覆盖 传控件
function g_SetBtn2(btn,tag, funcEndCallBack)
	if funcEndCallBack then
		btn:addClickListener(function() 
			g_gameMusic:playEffect(16)
			funcEndCallBack(btn,tag) 
			if g_newGuideWnd.tbMsg   and not isGuideWnd  then	
				if g_newGuideWnd.tbMsg.func then
					g_newGuideWnd.tbMsg.func()
				end 
			end 
		end)
	end 
	return btn
end

