------------------
-- 文件名:	batBOSSSkillContorl.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local batBOSSSkillContorl = class("batBOSSSkillContorl")

---=================================================
--获取技能数值
function batBOSSSkillContorl:mathSkillValue(skillID)
	local cfgMsg =  g_cfgMsg:getCfgMsg("enemySkill_D",skillID)
	local value = cfgMsg.value
	return value
end 

---=================================================
--[[
openSkillMsg = {}
openSkillMsg.attackFront = 1
openSkillMsg.attackBehi = 2
openSkillMsg.beAttack = 3
openSkillMsg.baoji = 4
openSkillMsg.duoshan = 5
openSkillMsg.death = 6
openSkillMsg.openSkill = 7
openSkillMsg.beAttackFriend = 8
]]
function batBOSSSkillContorl:showSkillFactory(nType,attckId,toAttckId,...)
	if attckId <= 200  then
		return 
	end 
	local status = handler(self, self["showSkill"..nType])(attckId,toAttckId,...)  
	return status
end 


---主动技能触发
function batBOSSSkillContorl:showSkill7(attckId)
	local isOpen 
	--cclog("===batBOSSSkillContorl==showSkill7=====")
	for skillID=1 ,19 do
		local status = self:skillFactory(skillID,attckId)
		if status == true then
			isOpen = true
		end 
	end 
	return isOpen
end

---判断是否有该技能
function batBOSSSkillContorl:isHSkill(skillID)
	local cfgID = g_batTbMsg:getFbEnemyBossBaseMsg(EnemyBaseMsgKey.BOSSSkill)
	if cfgID == skillID then
		return skillID
	end 
	return 
end

------技能工厂 ---isOpen  必施放
function batBOSSSkillContorl:skillFactory(skillID,attckId,toAttckId,hurt)
	---判断是否有该技能
	--cclog("==BOSS=skillFactory====",skillID,attckId)
	if  attckId ~= 500 then
		return
	end 

	local skillCfg = self:isHSkill(skillID)
	----skillCfg = 87000801
	if not skillCfg then	
		--cclog("BOSS=not lev"..skillID)
		return
	end 
	
	--是否死亡或者晕眩或者禁魔
	local info =  g_batTbMsg:getBatInfo(attckId) 
	if info.status == ROLESTATUSS.death  then
		cclog("==BOSS死亡中... ")
		return 
	end 
	local tbBufMsg = {70,71,78}
	local nTime = g_batRoleSkillContorl:getBufByID(attckId,tbBufMsg)
	
	if  nTime then
		--显示禁魔火或者buf标记
		cclog(nTime,"==BOSS==显示禁魔火或者buf标记==")
		return true
	end 
	---是否在冷却
	if not info.coolTimeSkill then
		info.coolTimeSkill = {}
	end 
	if not info.coolTimeSkill[skillID] then
		info.coolTimeSkill[skillID] =  0
	end 
	local startIme = g_getCursvTime() - info.coolTimeSkill[skillID]
	if startIme < 3 and not isOpen then
		--cclog(startIme,"=BOSS=冷却中==")
		return
	end 
	info.coolTimeSkill[skillID] = g_getCursvTime() 
	
	--是否需要概率释放
	local tbMsg =  g_cfgMsg:getCfgMsg("enemySkill_D",skillCfg)
	--获取数值
	local tbValue = self:mathSkillValue(skillCfg)
	--cclog(tbMsg.isRandom,"==BOSS===tbMsg.isRandom===112====")
	if tbMsg.isRandom >= 1 and not isOpen then
		local statue = g_batRoleSkillContorl:mathRandomOpen(30)
		if not statue then
			--cclog("==BOSS=mathRandomOpen===2222====",ration)
			return
		end 
	end 
	--cclog("==BOSS=mathRandomOpen===4444==",tbMsg.costMp)

	--获取目标- 单体或者几个全体
	local tbToAttckId = self:mathSkillToObj(skillID,toAttckId)
	local stasu 

	local info =  g_batTbMsg:getBatInfo(attckId) 
	local cfgID  = tonumber(tbMsg.anima) or 0
	local wndAnima = 0
	if cfgID  >  0  then
		local tbMsg2 =  g_cfgMsg:getCfgMsg("animaEffct_D",cfgID)
		if  tbMsg2.startType == 0  then
			wndAnima = 1
		else
			wndAnima =  -1 
		end 
	end 
	--cclog(wndAnima,"=BOSS=tbToAttckId==",tbToAttckId,skillID)	
	local staus 
	for i,toAttckId in pairs(tbToAttckId)do
		if wndAnima == 1 then
			g_batWndContorl:showSkillEffctItem(attckId,toAttckId,cfgID)
		end 
		staus = handler(self, self["skillIDContorl"..skillID])(attckId,toAttckId,tbValue,hurt) 
	end 
	--播放效果
	if wndAnima == -1 then
		g_batWndContorl:showSkillEffctItem(attckId,toAttckId,cfgID)
	end 
	return staus
end
----获取目标- 单体或者几个全体
function batBOSSSkillContorl:mathSkillToObj(skillID,attckId,toAttckId)
	local tbMsg =  g_cfgMsg:getCfgMsg("enemySkill_D",skillID)
	local nType = tbMsg.attckObjType -- 目标类型1是敌人2是自己3是队友4指定
	local attckNum = tbMsg.attckNum  --- 目标个数-1是全体
	local tbToAttckId = {}
	if nType == 1  then
		tbToAttckId = g_batContorl:getAttckObj2(500,attckNum)
	elseif nType == 2  then
	
	elseif nType == 3  then
		
	elseif nType == 4  then	
	
	end 
	cclog(nType,attckNum,"=========mathSkillToObj=====",tbToAttckId)
	return tbToAttckId
end 

---技能 1  (x%概率触发)迅猛攻击目标，造成攻击的y%+z点伤害
function batBOSSSkillContorl:skillIDContorl1(attckId,toAttckId,tbValue)
	local ration = tbValue/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)
	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
	return true
end


---技能 2  (x%概率触发)造成攻击的y%+z点伤害，并使目标减防3秒
function batBOSSSkillContorl:skillIDContorl2(attckId,toAttckId,tbValue)
	local ration = tbValue/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)

	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
		
	g_batRoleSkillContorl:toBojBuf(toAttckId,75,hurt,3,attckId)		
	return true
end

---技能 3 (x%概率触发)造成攻击的y%+z点伤害，并重置目标身上效果时间
function batBOSSSkillContorl:skillIDContorl3(attckId,toAttckId,tbValue)
	local ration = tbValue/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)
	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
		
	--重置时间	
	g_batRoleSkillContorl:reloadRoleBufTime(toAttckId)
	return true
end

---技能 4  (x%概率触发)攻击全部敌人，攻击的y%+z点伤害
function batBOSSSkillContorl:skillIDContorl4(attckId,toAttckId,tbValue)
	local ration = tbValue/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)

	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
	return true
end

---技能 5  (x%概率触发)使目标中毒2秒，[中毒]每0.2秒掉血攻击的y%+z点伤害
function batBOSSSkillContorl:skillIDContorl5(attckId,toAttckId,tbValue)
	local ration = tbValue/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)
	g_batRoleSkillContorl:toBojBuf(toAttckId,72,hurt,2,attckId)	
	return true	
end

---技能 6  (x%概率触发)造成攻击的y%+z点伤害，并使目标眩晕1秒
function batBOSSSkillContorl:skillIDContorl6(attckId,toAttckId,tbValue)
	local ration = tbValue/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)
	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
	
	g_batRoleSkillContorl:toBojBuf(toAttckId,70,hurt,1,attckId)		
	
	return true
end


---技能 7 x%概率缴械目标y秒（缴械期间受到伤害提高+z点）
function batBOSSSkillContorl:skillIDContorl7(attckId,toAttckId,tbValue)
	
	local nTime =  2
	local value = tbValue or 0
	g_batRoleSkillContorl:toBojBuf(toAttckId,79,value,nTime,attckId)
	
end

---技能 95000102  x%概率禁魔敌方全体y秒（缴械期间受到伤害+z点）
function batBOSSSkillContorl:skillIDContorl8(attckId,toAttckId,tbValue)
	g_batRoleSkillContorl:toBojBuf(toAttckId,78,0,2,attckId)	
end

---技能 9  x%概率触发敌方全体寒冰术，造成魔法攻击y%+z，并冻结3秒
function batBOSSSkillContorl:skillIDContorl9(attckId,toAttckId,tbValue)
	
	local ration = tbValue/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration)
	g_batRoleSkillContorl:toBojBuf(toAttckId,71,0,3,attckId)	
	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
end

---技能 10 x%概率触发敌方全体减防，造成魔法攻击y%+z，
function batBOSSSkillContorl:skillIDContorl10(attckId,toAttckId,tbValue)
	
	local ration = tbValue/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration)

	g_batRoleSkillContorl:toBojBuf(toAttckId,75,30,3,attckId)	
	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
end

---技能 11  x%概率触发对单个目标造成大额魔法攻击y%+z的伤害
function batBOSSSkillContorl:skillIDContorl11(attckId,toAttckId,tbValue)
	
	local ration = tbValue/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration)

	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
end

---技能 12  x%概率触发对5个目标造成魔法攻击y%+z伤害
function batBOSSSkillContorl:skillIDContorl12(attckId,toAttckId,tbValue)
	
	local ration = tbValue/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration)
	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
end

---技能 13 x%概率触发对10个目标造成魔法攻击y%+z伤害
function batBOSSSkillContorl:skillIDContorl13(attckId,toAttckId,tbValue)
	
	local ration = tbValue/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration)
	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
end

---技能 14 x%概率触发控制2个目标5秒，期间目标攻击提高（物理攻击y%）
function batBOSSSkillContorl:skillIDContorl14(attckId,toAttckId,tbValue)

	g_batRoleSkillContorl:toBojBuf(toAttckId,77,tbValue,2,attckId)	
end
---技能 15  x%概率触发对目标造成魔法攻击y%+z伤害,如果目标血量大于50%,30%概率再放一次技能
function batBOSSSkillContorl:skillIDContorl15(attckId,toAttckId,tbValue,isOpen)
	
	local ration = tbValue/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration)
	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)

	local info =  g_batTbMsg:getBatInfo(toAttckId)
	local pro = math.floor( info.hp *100/info.maxHp )
	if pro > 50 then
		local nRandom = math.random(1,100)
		if nRandom <= 30 then
			local item = g_batWndContorl:getItem(toAttckId)
			local function scheduleByOne()
				self:skillFactory(95000111,attckId,nil,true)
			end 
			local TextHp = item:getChild("TextHp")
			if TextHp then
				local _viewObj = TextHp:displayObject()
				g_scheduleTime:scheduleByTimes(_viewObj, 0.2,1,scheduleByOne)
			else
				local _viewObj = item:displayObject()
				g_scheduleTime:scheduleByTimes(_viewObj, 0.2,1,scheduleByOne)
			end 
			
		end 
	end 
	


end


function batBOSSSkillContorl:ctor()

end

g_batBOSSSkillContorl =  batBOSSSkillContorl:create()