------------------
-- 文件名:	batMath.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local batMath = class("batMath")

---==============================================
---==============================================
-- 
function batMath:getMapLev(mapType) 
	local mapType = mapType or g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local fubenCurLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenCurLev) or {}
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}		
	local curMapLev = fubenCurLev[mapType] or 1
	local maxMapLev = fubenMaxLev[mapType] or 1
	return curMapLev,maxMapLev
end

function batMath:getEnemyNum()
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local cfgMsg =  g_cfgMsg:getCfgMsg("map_D",mapType)
	return cfgMsg.maxEnemy
end 
function batMath:mathFbBatKillMaxNum() 
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local fubenCurLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenCurLev) or {}
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}		
	local curMapLev = fubenCurLev[mapType] or 1
	
	local maxNum =  self:getEnemyNum() + math.floor(curMapLev/5) 
	if curMapLev <= 2  then
		maxNum = curMapLev
	end 
	return maxNum
end 
--攻击/防御
function batMath:mathFbBatEnemyDps(isBoss)  ---计算副本敌人属性
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {1,1,1,1,1,1,1,1,1}	
	local fubenCurLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenCurLev) or {1,1,1,1,1,1,1,1,}	
	local curMapLev = fubenCurLev[mapType] or 1
	--local fubenMaxLev = fubenMaxLev[1] or 1
	local value = curMapLev*2 + (curMapLev-1)*3
	
	local ration =  2 + math.floor(curMapLev/50)
	
	local maxRation = 10
	if ration > maxRation then
		ration = maxRation
	end 
	
	if isBoss  then
		local add = math.floor( curMapLev / 600)
		value = value * (ration + add)
	end 
	return value
end 
function batMath:mathFbBatEnemyDef(isBoss)  ---计算副本敌人属性
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}	
	local fubenCurLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenCurLev) or {}	
	local curMapLev = fubenCurLev[mapType] or 1
	local value = curMapLev + (curMapLev-1)
	
	local ration =  2
	local maxRation = 5
	if ration > maxRation then
		ration = maxRation
	end 
	
	if isBoss  then
		value = value * ration
	end 
	return value
end 

function batMath:mathFbBatEnemyLev(index)  ---计算副本敌人等级
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}	
	local fubenCurLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenCurLev) or {}
	local index = index  or mapType
	local curMapLev = fubenCurLev[index] or 1
	local value = curMapLev
	return value
end 

--血量
function batMath:mathFbBatEnemyHp(isBoss)  ---计算副本敌人属性
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}	
	local fubenCurLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenCurLev) or {}	
	local curMapLev = fubenCurLev[mapType] or 1
	local value = 20 +(curMapLev-1)*(50+curMapLev)
	
	local ration =  5 + math.floor(curMapLev/10)
	 
	local maxRation = 50 
	if ration > maxRation then
		ration = maxRation
	end 
	if isBoss  then
		value = value * ration
	end 
	return value
end 
--暴击/闪避  -- 加入爆伤减免 
function batMath:mathFbBatEnemyBJ(isBoss)  ---计算副本敌人属性
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}	
	local fubenCurLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenCurLev) or {}	
	local curMapLev = fubenCurLev[mapType] or 1
	
	local value = curMapLev/2
	if isBoss then
		local add = curMapLev
		value = value*2 + add
	end 
	return value
end 
--精准
function batMath:mathFbBatEnemyJZ(isBoss)  ---计算副本敌人属性
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}	
	local fubenCurLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenCurLev) or {}	
	local curMapLev = fubenCurLev[mapType] or 1
	local value = 70+ curMapLev/10
	if isBoss then
		value = value*2
	end 
	return value
end 


--金币
function batMath:mathFbBatEnemyRes(mapType,isBoss)  ---
	
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}	
	local fubenCurLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenCurLev) or {}	
	local curMapLev = fubenCurLev[1] or 1
	
	local addCoinXY =  self.addCoinXY or  g_baseMsg:getOther(otherDBMsgID.addCoinXY) or 0
	local addVa = g_tianfuConTrol:getTianfuOpenValue(1) 
	local res = curMapLev*8---- math.ceil(curMapLev/10)
	
	local lev = curMapLev + math.floor((mapType-1)*(curMapLev/20))
	if isBoss  then
		res = res*100
	end 
	
	if addCoinXY >  curMapLev*10   then
		addCoinXY = curMapLev*10
	end 
	
	res = res + addCoinXY + addVa
	res = math.floor(res)
	---cclog(res,curMapLev,mapType,"====mathFbBatEnemyRes=======",addCoinXY,fubenCurLev)
	return res,lev
end 

---===========初始化=======================================

---===============================
--速度转换为秒 1是pet
function batMath:mathSpeed(speed,nType) 
	local baseTime = 1

	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}	
	local fubenCurLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenCurLev) or {}	
	local curMapLev = fubenCurLev[mapType] or 1
	
	local level =  g_roleAttConTrol:getMaxLev()
	local minSpeed = 6 + level
	local maxSpeed = minSpeed * 1.5 + 10
	speed = tonumber(speed)
	if mapType == 1 and curMapLev <= 300  then
		if nType == 1 then
			return 0.5
		end 
		if curMapLev <= 50  then
			return 0.1
		end 
		return 0.2
	end 
	if  tonumber(speed) <= minSpeed  then	
		return baseTime
	end 
	if  speed >= maxSpeed and curMapLev > 300  then	
		if nType == 1 then
			return 0.5
		end 
		return 0.2
	end 
	local speedD = speed - minSpeed
	local offSpeed = maxSpeed - minSpeed
	local pro = speedD/offSpeed
	local nTime = 1 * pro
	local speedD = baseTime - nTime
	
	if speedD < 0.2  then
		return 0.2
	end 
	if speedD > 0.6  then
		return 0.6
	end 
	speedD = math.floor(speedD*100)/100
	return speedD
end

---随机获取x个目标
function batMath:mathFbBatEnemyObj(num)  
	local info100 = g_batTbMsg:getFbRoleMsg() 
	--获取存活
	local tbMsg = {}
	local tbMsg2 = {}
	if info100.status >= 0 and info100.status ~= ROLESTATUSS.death then
		tbMsg[1] = {100,info100.chouhen}
		tbMsg2[1] = 100
	end 
	local tbInfo = g_batTbMsg:getFbPetMsg() or {}
	local count = 0
	for  index,info in pairs(tbInfo)do
		if info.status >= 0 and info.status ~= ROLESTATUSS.death then
			tbMsg[#tbMsg+1] = {index,info.chouhen} 
			tbMsg2[#tbMsg2+1] = index
			count = count + info.chouhen
		end 
		--cclog(info,"=======info========",index)
	end 
	if num == -1 then
		return tbMsg2
	end 
	local tbObj = {}
	if  num >= #tbMsg  then
		for i=1, #tbMsg  do
			tbObj[#tbObj+1] = tbMsg2[i]
		end 
	else
		for i=1, num do
			local key,index = getRandomBytbRation2(tbMsg,count)
			--cclog(key,"===getRandomBytbRation2=====",tbMsg,count,key,index )
			tbObj[#tbObj+1] = tbMsg2[index]
			count = count -  tbMsg[index][2]
			table.remove(tbMsg,index)
			---cclog(tbObj,"===getRandomBytbRation2=====",tbMsg2[index],tbMsg2)
		end 
	end 
	return tbObj
end 


---随机获取x个目标 --我方
function batMath:mathFbBatRoleObj(num)  
	local tbMsg = {}
	local tbInfo = g_batTbMsg:getFbEnemyMsg() 
	for  index,info in pairs(tbInfo)do
		if info.status >= 0 and info.status ~= 3 then
			tbMsg[#tbMsg+1] = index
		end 
	end 
	if num == -1 then
		return tbMsg
	end 
	local tbObj = {}
	for i=1, num do
		local nRandom = math.random(1,#tbMsg)
		tbObj[#tbObj+1] = tbMsg[nRandom]
		table.remove(tbMsg,nRandom)
	end 
	return tbObj
end 

--对方是否躲闪
function batMath:mathDuoshan(jingzhun,duoshan,attckId) 
	local value = duoshan/(jingzhun*2 + duoshan)
	if attckId > 1000 and value > 0.6 then
		value = 0.6
	end 
	value = value*10000
	local rantom = math.random(1,10000)
	if rantom <= value then
		return batStatusTypes.sb 
	end 
	return
end
--是否暴击
function batMath:mathBaoji(baoji1,toBaoji)
	local nBaoji = baoji1 - toBaoji
	nBaoji = nBaoji*100
	local rantom = math.random(1,10000)
	if rantom <= nBaoji then
		return 1
	end 
	return
end
--是否释放技能
function batMath:mathIsSkill(info) 
	local isSkill
	return isSkill
end 
--计算物理伤害
function batMath:mathHurtWl(info,toinfo,dps) 
	--获取攻击
	local dps = dps or  info.dpsWl
	--获取防御
	local def = toinfo.defWL
	--计算减伤
	local minHurt =   byBigInt(dps, "0.1",true)   
	if not MaxBigInt(minHurt,"1")  then
		minHurt = "1"
	end 
	local value = subBigInt(dps, def)  
	if not MaxBigInt(value,minHurt) then
		value = minHurt
	end 
	local attHurt = self:mathHurtAtt(info,toinfo) 
	value = addBigInt(attHurt, value)
	return value
end

--计算魔法伤害
function batMath:mathHurtMF(info,toinfo,dps) 
	--获取攻击
	local dps = dps or info.dpsMf
	--获取防御
	local def = toinfo.defMf
	--计算减伤
	local minHurt =   byBigInt(dps, "0.1",true)    
	local value = subBigInt(dps, def)  
	if not MaxBigInt(value,minHurt) then
		value = minHurt
	end 
	local attHurt = self:mathHurtAtt(info,toinfo) 
	value = addBigInt(attHurt, value)
	return value
end

--计算属性伤害
function batMath:mathHurtAtt(info,toinfo) 
	--获取属性攻击
	local allHurt = "0"
	for i=1,4 do
		local dps = info.attHurt[1] or "0"
		local def = toinfo.attHurtDef[1] or "0"
		local value = subBigInt(dps, def) 
		if not MaxBigInt(value,"0")  then
			value = "0"
		end 
		allHurt = addBigInt(allHurt, value)
	end 
	return allHurt
end

--计算伤害baoji
function batMath:mathHurtBaoji(info,hurt) 
	local baojiHurt = info.baojiHurt or 150
	if baojiHurt < 100 then
		baojiHurt = 100
	end 
	if baojiHurt > 8000 then
	end 
	
	local hurt1 = byBigInt(baojiHurt,hurt)  
	local hurt =  byBigInt(hurt1, "0.01",true) 
	return hurt
end

---=========================================================
--统计伤害
--
function batMath:reloadStartCount() 
	self.startTime = g_getCursvTime()
	self.GameCount = {kill = 0 ,dps =  "0",res = "0"}
end 
function batMath:addKillCount() 
	--self.GameCount.kill = self.GameCount.kill + 1
	local res = g_batMath:mathFbBatEnemyRes() 
	if not self.GameCount.res then
		self.GameCount.res = 0
	end 
	local valueD = addBigInt(self.GameCount.res, res)  
	self.GameCount.res =  valueD
end
function batMath:addDpsCount(value) 
	if not self.GameCount.dps then
		self.GameCount.dps = 0
	end 
	local valueD = addBigInt(self.GameCount.dps, value)  
	self.GameCount.dps =  valueD
end
function batMath:mathHurtDps() 
	local nTime = g_getCursvTime() - self.startTime
	if nTime <= 0  then
		return
	end 
	if not self.GameCount.dps then
		self.GameCount.dps = 0
	end 
	if not self.GameCount.res then
		self.GameCount.res = 0
	end 
	local ration =  math.floor( 60*100/nTime )/100
	--cclog("===mathHurtDps======",self.GameCount.dps, ration,nTime)
	local valueD1 = byBigInt(self.GameCount.dps, ration,true)  
	local valueD2 = byBigInt(self.GameCount.res, ration,true)
	g_batTbMsg:setFbBatMsg(fbBatMsgKey.dpsMath,valueD1) 	
	g_batTbMsg:setFbBatMsg(fbBatMsgKey.resMath,valueD2) 

	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	B_FbBat:setFbMsgPanleText()
	self.GameCount.dps = 0
	self.GameCount.res = 0
end 

function batMath:ctor()
	
	self.GameCount = {}
end

g_batMath =  batMath:create()