------------------
-- 文件名:	batPetSkillContorl.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local batPetSkillContorl = class("batPetSkillContorl")

---=================================================
--获取技能数值
function batPetSkillContorl:mathSkillValue(skillID)
	local skillIDLev =  g_bagMsg:getpetSkillTbMsgLev(skillID)  
	local tb_number = g_mathConTrol:mathPetSkillValue(skillIDLev,skillID)

	return tb_number
end 

---=================================================
--[[
openSkillMsg = {}
openSkillMsg.attackFront = 1
openSkillMsg.attackBehi = 2
openSkillMsg.beAttack = 3
openSkillMsg.baoji = 4
openSkillMsg.duoshan = 5
openSkillMsg.death = 6
openSkillMsg.openSkill = 7
openSkillMsg.beAttackFriend = 8
]]
function batPetSkillContorl:showSkillFactory(nType,attckId,toAttckId,...)

	local status = handler(self, self["showSkill"..nType])(attckId,toAttckId,...)  
	return status
end 
---攻击前触发
function batPetSkillContorl:showSkill1(attckId)
	for skillID=21 ,25 do
		self:skillFactory(skillID,attckId)
	end 
	return
end

---攻击后触发
function batPetSkillContorl:showSkill2(attckId,toAttckId)
	self:skillFactory(19,attckId,toAttckId)
end
---被攻击后触发
function batPetSkillContorl:showSkill3(attckId)
	
end

---暴击触发
function batPetSkillContorl:showSkill4(attckId)
end
---闪避触发
function batPetSkillContorl:showSkill5(attckId)
end
---死亡触发
function batPetSkillContorl:showSkill6(attckId,toAttckId)
	if toAttckId <= 100 then
		local tbInfo = g_batTbMsg:getFbPetMsg() or {}
		for  index,info in pairs(tbInfo)do
			if info.status >= 0 and info.status ~= ROLESTATUSS.death and info.index ~= toAttckId then
				self:skillFactory(18,info.index,toAttckId)
			end 
		end 
	end 
end
---主动技能触发
function batPetSkillContorl:showSkill7(attckId)
	local isOpen 
	for nType=8 ,16 do
		local status = self:skillFactory(nType,attckId)
		if status == true then
			isOpen = true
		end 
	end 
	return isOpen
end

---友军被攻击后触发
function batPetSkillContorl:showSkill8(attckId,toAttckId,hurt)
	local batPatMsg = g_baseMsg:getTbInteger(tbIntegerKEy.BatPetMsg) or {}	
	for index,petID in pairs(batPatMsg)do
		if petID > 0 and petID ~= toAttckId  then
			local hurt = self:skillFactory(17,petID,toAttckId,hurt)
			return hurt
		end 
	end 
end

---判断是否有该技能
function batPetSkillContorl:isHSkill(petId, skillID)
	local info =  g_batTbMsg:getBatInfo(petId) 
	if not info or  not info.skillMsg then
		return
	end
	for i=1,6 do
		local skillMsg = info.skillMsg[i] or {}
		local curSkillID = skillMsg.value1 or 0
		local nType = math.floor( curSkillID/100 ) %1000
		if  nType == skillID then
			local skillIDLev =  g_bagMsg:getpetSkillTbMsgLev(curSkillID)  
			return curSkillID
		end 
	end 
	
	return 
end

------技能工厂 ---isOpen  必施放
function batPetSkillContorl:skillFactory(skillID,attckId,toAttckId,hurt)
	---判断是否有该技能
	--cclog("===skillFactory====",skillID,attckId)
	if  attckId >= 100 then
		return
	end 

	local skillCfg = self:isHSkill(attckId,skillID)
	----skillCfg = 87000801
	if not skillCfg then	
		--cclog("=not lev"..skillID)
		return
	end 
	
	--是否死亡或者晕眩或者禁魔
	local info =  g_batTbMsg:getBatInfo(attckId) 
	if info.status == ROLESTATUSS.death  then
		cclog("==死亡中... ")
		return 
	end 
	
	local tbBufMsg = {70,71,78}
	local nTime = g_batRoleSkillContorl:getBufByID(attckId,tbBufMsg)
	
	if  nTime then
		--显示禁魔火或者buf标记
		cclog(nTime,"====显示禁魔火或者buf标记==")
		return true
	end 
	
	---是否在冷却
	if not info.coolTimeSkill then
		info.coolTimeSkill = {}
	end 
	if not info.coolTimeSkill[skillID] then
		info.coolTimeSkill[skillID] =  0
	end 
	local startIme = g_getCursvTime() - info.coolTimeSkill[skillID]
	
	local baseCool = 3
	local addVa = g_tianfuConTrol:getTianfuOpenValue(54) 
	baseCool = baseCool- addVa
	if baseCool  < 1 then
		baseCool = 1
	end 
		
	if startIme < baseCool and not isOpen then
		--cclog(startIme,"==冷却中==")
		return
	end 
	info.coolTimeSkill[skillID] = g_getCursvTime() 
	
	--是否需要概率释放
	local tbMsg =  g_cfgMsg:getCfgMsg("petSkill_D",skillCfg)
	--获取数值
	local tbValue = self:mathSkillValue(skillCfg)
	--cclog(tbMsg.isRandom,"=====tbMsg.isRandom===112====")
	if tbMsg.isRandom >= 1 and not isOpen then
		local ration = tbValue[1]
		local statue = g_batRoleSkillContorl:mathRandomOpen(ration)
		if not statue then
			return
		end 
	end 
	
	--获取目标- 单体或者几个全体
	local tbToAttckId = self:mathSkillToObj(skillCfg,toAttckId)
	local stasu 

	local info =  g_batTbMsg:getBatInfo(attckId) 
	local anCfgID  = tbMsg.anima1 or 0
	local wndAnima = 0
	if anCfgID  >  0  then
		local tbMsg2 =  g_cfgMsg:getCfgMsg("animaEffct_D",anCfgID)
		if  tbMsg2.startType == 0  then
			wndAnima = 1
		else
			wndAnima =  -1 
		end 
	end 
	cclog(wndAnima,"==tbToAttckId==",tbToAttckId,skillID)	
	local staus 
	for i,toAttckId in pairs(tbToAttckId)do
		if wndAnima == 1 then
			g_batWndContorl:showSkillEffctItemPool(attckId,toAttckId,skillCfg)
		end 
		staus = handler(self, self["skillIDContorl"..skillID])(attckId,toAttckId,tbValue,hurt) 
	end 
	--播放效果
	if wndAnima == -1 then
		g_batWndContorl:showSkillEffctItemPool(attckId,attckId,skillCfg)
	end 
	return staus
end
----获取目标- 单体或者几个全体
function batPetSkillContorl:mathSkillToObj(skillID,attckId,toAttckId)
	local tbMsg =  g_cfgMsg:getCfgMsg("petSkill_D",skillID)
	cclog("======mathSkillToObj======",killID,attckId,toAttckId)
	local nType = tbMsg.attckObjType -- 目标类型1是敌人2是自己3是队友4指定
	local attckNum = tbMsg.attckNum  --- 目标个数-1是全体
	local tbToAttckId = {}
	if nType == 1  then
		tbToAttckId = g_batContorl:getAttckObjRan(attckNum)
	elseif nType == 2  then
		tbToAttckId = {attckId}
	elseif nType == 3  then
		tbToAttckId = g_batContorl:getAttckObjFriend(attckNum)
		skillID = math.floor(skillID/100)%1000
		if  skillID == 9  then --掉血最多
			local minHpIndex
			local minHp = 0
			for idex,v in pairs(tbToAttckId)do
				local info =  g_batTbMsg:getBatInfo(idex) 
				local addHp  =  info.maxHp - info.hp
				if  addHp >= minHp then
					minHpIndex = idex
				end 
			end 
			tbToAttckId = {minHpIndex}		
		end 
	elseif nType == 4  then	
		tbToAttckId = {toAttckId}
	end 
	cclog(nType,attckNum,"=========mathSkillToObj=====",tbToAttckId)
	return tbToAttckId
end 

---技能 8  (x%概率触发)迅猛攻击目标，造成攻击的y%+z点伤害
function batPetSkillContorl:skillIDContorl8(attckId,toAttckId,tbValue)
	local ration = tbValue[2]/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)
	hurt = addBigInt(hurt,tbValue[3])
	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
	return true
end
---技能 9  (x%概率触发)治疗血量最低单位攻击的y%+z点血
function batPetSkillContorl:skillIDContorl9(attckId,toAttckId,tbValue)
	local ration = tbValue[2]/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)
	hurt = addBigInt(hurt,tbValue[3])

	g_batRoleSkillContorl:skillZiliaoRole(attckId,toAttckId,hurt)
	return true
end

---技能 10   (x%概率触发)攻击提高y%+z，持续5秒
function batPetSkillContorl:skillIDContorl10(attckId,toAttckId,tbValue)
	local ration = tbValue[2]/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)
	hurt = addBigInt(hurt,tbValue[3])
	g_batRoleSkillContorl:toBojBuf(toAttckId,91,hurt,5,attckId)	
		
	return true	
end
---技能 11  (x%概率触发)造成攻击的y%+z点伤害，并使目标减防3秒
function batPetSkillContorl:skillIDContorl11(attckId,toAttckId,tbValue)
	local ration = tbValue[2]/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)
	hurt = addBigInt(hurt,tbValue[3])
	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
		
	g_batRoleSkillContorl:toBojBuf(toAttckId,75,hurt,3,attckId)		
	return true
end

---技能 12  (x%概率触发)造成攻击的y%+z点伤害，并重置目标身上效果时间
function batPetSkillContorl:skillIDContorl12(attckId,toAttckId,tbValue)
	local ration = tbValue[2]/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)
	hurt = addBigInt(hurt,tbValue[3])
	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
		
	--重置时间	
	g_batRoleSkillContorl:reloadRoleBufTime(toAttckId)
	return true
end

---技能 13  (x%概率触发)攻击全部敌人，攻击的y%+z点伤害
function batPetSkillContorl:skillIDContorl13(attckId,toAttckId,tbValue)
	local ration = tbValue[2]/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)
	hurt = addBigInt(hurt,tbValue[3])
	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
	return true
end

---技能 14  (x%概率触发)使目标中毒2秒，[中毒]每0.2秒掉血攻击的y%+z点伤害
function batPetSkillContorl:skillIDContorl14(attckId,toAttckId,tbValue)
	local ration = tbValue[2]/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)
	hurt = addBigInt(hurt,tbValue[3])
	g_batRoleSkillContorl:toBojBuf(toAttckId,72,hurt,2,attckId)	
	return true	
end

---技能 15  (x%概率触发)造成攻击的y%+z点伤害，并使目标眩晕1秒
function batPetSkillContorl:skillIDContorl15(attckId,toAttckId,tbValue)
	local ration = tbValue[2]/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)
	hurt = addBigInt(hurt,tbValue[3])
	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
	
	g_batRoleSkillContorl:toBojBuf(toAttckId,70,hurt,1,attckId)		
	
	return true
end

---技能 16  (x%概率触发)对5个敌人造成攻击的y%+z点伤害
function batPetSkillContorl:skillIDContorl16(attckId,toAttckId,tbValue)
	local ration = tbValue[2]/100
	local hurt  = g_batRoleSkillContorl:mathMFHurt(ration,attckId)
	hurt = addBigInt(hurt,tbValue[3])
	g_batRoleSkillContorl:skillHurtRole(attckId,toAttckId,hurt)
	
	return true
end

---技能 17  (x%概率触发)其他宠物掉血时，分担y%伤害
function batPetSkillContorl:skillIDContorl17(attckId,toAttckId,tbValue,hurt)
	local ration = tbValue[2]/100
	local strLDEnd , strLDEndCN = byBigInt(hurt, ration)
	g_batRoleSkillContorl:skillHurtRole(attckId,attckId,strLDEnd)
	local addHurt = subBigInt(strLDEnd, hurt)
	return strLDEnd
end
---技能 18  消耗x%血量复活死亡单位并回复y点血(血量高于30%触发)
function batPetSkillContorl:skillIDContorl18(attckId,toAttckId,tbValue)
	local info =  g_batTbMsg:getBatInfo(attckId) 
	local hpOne = byBigInt(info.maxHp , "0.3")  
	if not MaxBigInt(info.hp, hpOne) then
		return 
	end 
	local addHp = tbValue[2] or 0
	self:fuhuoRole(toAttckId,addHp)
	
	return true
end
---技能 19  攻击后提高暴击x点，暴击伤害提高y%，打出暴击后重置(可叠加)
function batPetSkillContorl:skillIDContorl19(attckId,toAttckId,tbValue)
	local value1 = tbValue[1] or 0
	local value2 = tbValue[2] or 0
	
	g_batRoleSkillContorl:addToBojBuf(toAttckId,8,value1,-1,attckId)	
	g_batRoleSkillContorl:addToBojBuf(toAttckId,94,value2,-1,attckId)

	return true	
end
---技能 20 
function batPetSkillContorl:skillIDContorl20(attckId,toAttckId,tbValue)
	
end

---技能 21 自身血量每减少10%，攻击提高x%
function batPetSkillContorl:skillIDContorl21(attckId,toAttckId,tbValue)
	local num = g_batRoleSkillContorl:mathHpRolePro(attckId)
	if num == 0 then
		return
	end 
	local ration = tbValue[1] or 0
	g_batRoleSkillContorl:toBojBuf(attckId,91,ration,nTime,attckId)	
end
---技能 22  自身血量每减少10%，全防御提高x%
function batPetSkillContorl:skillIDContorl22(attckId,toAttckId,tbValue)
	local num = g_batRoleSkillContorl:mathHpRolePro(attckId)
	if num == 0 then
		return
	end 
	local ration = tbValue[1] or 0
	g_batRoleSkillContorl:toBojBuf(attckId,96,ration,nTime,attckId)	
end

---技能 23  自身血量每减少10%，躲闪提高x%
function batPetSkillContorl:skillIDContorl23(attckId,toAttckId,tbValue)
	local num = g_batRoleSkillContorl:mathHpRolePro(attckId)
	if num == 0 then
		return
	end 
	local ration = tbValue[1] or 0
	g_batRoleSkillContorl:toBojBuf(attckId,97,ration,nTime,attckId)	
end

---技能 24  目标血量每减少10%，速度提高x%
function batPetSkillContorl:skillIDContorl24(attckId,toAttckId,tbValue)
	local num = g_batRoleSkillContorl:mathHpRolePro(attckId)
	if num == 0 then
		return
	end 
	local ration = tbValue[1] or 0
	g_batRoleSkillContorl:toBojBuf(attckId,90,ration,nTime,attckId)	
end

---技能 25 目标血量每减少10%，暴击概率提高x%
function batPetSkillContorl:skillIDContorl25(attckId,toAttckId,tbValue)
	local num = g_batRoleSkillContorl:mathHpRolePro(attckId)
	if num == 0 then
		return
	end 
	local ration = tbValue[1] or 0
	g_batRoleSkillContorl:toBojBuf(attckId,94,ration,nTime,attckId)	
end

function batPetSkillContorl:ctor()

end

g_batPetSkillContorl =  batPetSkillContorl:create()