------------------
-- 文件名:	batWndContorl.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local batWndContorl = class("batWndContorl")

local enemyPosTbMsg = {
	{50,582},{52,620},{40,691},{81,656},{79,552},{660,532},{610,691},{653,638},{630,577},{619,566},{578,588},{598,621},{648,642},{499,666},{526,585},{471,580},{445,629},{380,649},{418,595},{350,600},{293,604},{321,632},{258,654},{235,596},{198,663},{143,635},{172,607},
}

local enemyPosTbMsg2 = {
	{50,582},{52,620},{40,691},{81,656},{79,552},{660,532},{610,691},{653,638},{630,577},{619,566},{578,588},{598,621},{648,642},{499,666},{526,585},{198,663},{143,635},{172,607},
}


function batWndContorl:getItem(roleID)
	local info =  g_batTbMsg:getBatInfo(roleID)  
	
	local item 
	if roleID >= 1000  then
		item = info.item
	elseif roleID == 100  then
		local B_FbBat = g_WndMgr:getWnd("B_FbBat")
		item =  B_FbBat.rootLayout:getChild("roleItem") 
	elseif roleID == 500  then	
		local B_FbBat = g_WndMgr:getWnd("B_FbBat")
		item =  B_FbBat.rootLayout:getChild("BigBossItem500") 
	else
		local B_FbBat = g_WndMgr:getWnd("B_FbBat")
		item =  B_FbBat.rootLayout:getChild("cuItem"..roleID) 
	end 
	return item
end 

---敌人攻击动画
function batWndContorl:enemyAttckAnima(roleID)
	if roleID <= 150 then
		return
	end 
	local item = self:getItem(roleID)
	local t0 = item:getTransition("t0")
	t0:play()
end 
---敌人技能动画
function batWndContorl:enemySkillAttckAnima(roleID)
	if roleID <= 200 then
		return
	end 
	local item = self:getItem(roleID)
	local t1 = item:getTransition("t1")
	if t1 then
		t1:play()
	end 
end 

function batWndContorl:cleanItemBuf(roleID)
	local item = self:getItem(roleID)
	local bufList = item:getChild("bufList") 
	self:setItemBuf(roleID)
end 
function batWndContorl:setItemBuf(roleID)	
	local Modelbat = cc.UserDefault:getInstance():getIntegerForKey("Modelbat", 1)
	if  Modelbat == 1  then
		return
	end 
	local item = self:getItem(roleID)
	local info =  g_batTbMsg:getBatInfo(roleID) 
	local bufList = item:getChild("bufList") 
	local tbListMsg = {}

	for ID,tbMsg in pairs(info.bufMsg)do
		if  tbMsg.nTime ~= 0 then
			local bufID = math.floor(ID/1000)
			tbListMsg[#tbListMsg+1] = bufID
		end 
	end 
	bufList:itemRenderer(function(index, obj)
			local indexD = index + 1
			local attID = tbListMsg[indexD]
			local cfgMsg =  g_cfgMsg:getCfgMsg("att_D",attID)
			obj:setText(cfgMsg.dec)
			local title = obj:getChild("title") 
			cc.g_setTextColor(title,cfgMsg.nType or 1,true)
		end)
	
	bufList:setVirtual()--回调
	bufList:setNumItems(#tbListMsg);
end 

---创建出敌人item
function batWndContorl:createEnemyBaseItem(enemyID)
	if  enemyID  == 500 then
		return
	end 
	local info = g_batTbMsg:getFbEnemyMsg(enemyID) 
	local item 
	if not info.item then
		item = g_itemPoolContorl:getItemPool("EnemyPool")
		info.item = item
	else
		item = info.item
		local c1 =  item:getController("c1") --控制器
		c1:setSelectedIndex(0)
		local c2 =  item:getController("c2") --控制器
		c2:setSelectedIndex(0)
	end 
	local pos 
	
	---cclog(g_batContorl.isBossBat,"======= g_batContorl.isBossBat===")
	if g_batContorl.isBossBat then
		local posIndex = math.random(1,#enemyPosTbMsg2)
		pos = enemyPosTbMsg2[posIndex]
		item:setScale(0.7,0.7)
		--cclog("======= g_batContorl.isBossBat===",pos)
	else
		local posIndex = math.random(1,#enemyPosTbMsg)
		pos = enemyPosTbMsg[posIndex]
		item:setScale(1,1)
	end 
	local offx = math.random(-15,15)
	local offy = math.random(-15,15)
	item:setPosition(pos[1]+offx,pos[2]+offy)
	
	--计算一个随机移动的x和y
	--获取往左还是右
	local ran = math.random(1,100)
	local offMaxX = 30
	local offMaxY = 200
	local offType = 1
	if ran <= 50 then --zuo
		offType = -1
		if pos[1] < 100  then
			offMaxX = pos[1]
			offType = 1
		end 
		
	else
		if  (710- pos[1]) < 100  then
			offMaxX =  (710- pos[1])
			offType = -1
		end 
	end 
	info.moveX = pos[1] + math.random(0,offMaxX)*offType
	info.moveY = pos[2] + math.random(0,offMaxY)
	info.moveOff = offType
	g_batTbMsg:setFbEnemyMsg(info)

	item:setVisible(true)
	
	local itemObj = item:displayObject()
	local actionFadeIn = cc.FadeIn:create(1)
	itemObj:runAction(actionFadeIn)
	
	if enemyID >= 1000 then
		local cfgMsg1 =  g_cfgMsg:getCfgMsg("enemyName_D",info.EnemyName) 
		--item:setText(cfgMsg1.name)
		local c1 =  item:getController("c1") --控制器
		c1:setSelectedIndex(cfgMsg1.icon)
	end 
	
	return item
end

---显示伤害飘字
function batWndContorl:createHurtPiaozi(roleID,str,colorID,nType,isMp)
	local curWndID = g_WndMgr:getTopWndID()
	---cclog(curWndID,"=====createHurtPiaozi=======")
	if curWndID ~= "B_FbBat" then
		return
	end 
	
	local item ,dongH,poolName
	local nType = nType or 1
	--cclog(nType,"=====createHurtPiaozi=======",roleID,str,colorID,nTyp)
	if nType == 1 then
		if isMp then
			poolName = "mpHurt"
		else
			poolName = "hurt"
		end 
		
		item =  g_itemPoolContorl:getItemPool(poolName)
		dongH = item:getTransition("t1")

	elseif nType == 2 then --暴击
		poolName = "baoji"
		item =  g_itemPoolContorl:getItemPool("baoji")
		dongH = item:getTransition("t0")
	elseif nType == 3 then --治疗
		local Modelbat = cc.UserDefault:getInstance():getIntegerForKey("Modelbat", 1)
		if  Modelbat == 1  then
			return
		end 
		poolName = "zhiliao"
		item =  g_itemPoolContorl:getItemPool("zhiliao")
		dongH = item:getTransition("t0")
	elseif nType == 4 then --魔法
		poolName = "addMp"
		item =  g_itemPoolContorl:getItemPool("addMp")
		dongH = item:getTransition("t1")
	end 

	item:setVisible(true)
	item:setText(str)
	if colorID then
		local  title =  item:getChild("title") 
		cc.g_setTextColor(title,colorID,true)
	end 
	
	--cclog(str,"=====createHurtPiaozi===222====")
	local function callback()
		g_itemPoolContorl:returnItemPool(poolName,item)
	end 
	dongH:play(callback)
	if roleID then
		local roleItem = self:getItem(roleID)
		local pos = roleItem:getPosition()
		local Random1 = math.random(-10,10)
		local Random2 = math.random(-10,10)
		item:setPosition(pos.x + 10+Random2 ,pos.y+Random1)
		---=cclog(pos,"======setPosition========")
	end 
	self:setWndHp(roleID)
end

function batWndContorl:setWndHp(roleID)
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local curWndID = g_WndMgr:getTopWndID()
	if curWndID ~= "B_FbBat" then
		return
	end 
	if roleID == 100  then
		B_FbBat:setFbMsgPanleRoleHp()
	elseif roleID < 100 then
		--B_FbBat:setFbMsgPanlePetHp(roleID)
	elseif roleID == 500  then --BOSS
		B_FbBat:setFbMsgPanleBOSSHp()
	else
		--local roleItem = self:getItem(roleID)
		--B_FbBat:setFbMsgPanleEnemy0Hp(roleItem,roleID)
	end 
end 
function batWndContorl:setWndMp(roleID)
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	if roleID == 100  then
		B_FbBat:setFbMsgPanleRoleMp()
	end 
end 
---显示状态飘字
function batWndContorl:createStausPiaozi(roleID,str,colorID)
	local curWndID = g_WndMgr:getTopWndID()
	if curWndID ~= "B_FbBat" then
		return
	end 
	local Modelbat = cc.UserDefault:getInstance():getIntegerForKey("Modelbat", 1)
	if  Modelbat == 1 then
		return
	end 
	local item =  g_itemPoolContorl:getItemPool("stausText")
	local dongH = item:getTransition("t0")
	item:setVisible(true)
	item:setText(str)
	if colorID then
		local  title =  item:getChild("title") 
		cc.g_setTextColor(title,colorID,true)
	end 
	
	local function callback()
		g_itemPoolContorl:returnItemPool("stausText",item)
	end 
	dongH:play(callback)
	if roleID then
		local roleItem = self:getItem(roleID)
		local pos = roleItem:getPosition()
		item:setPosition(pos.x,pos.y)
	end 
end


--技能特效
function batWndContorl:showSkillEffctItemPool(roleID,toRoleID,skillID,callBack)
	local curWndID = g_WndMgr:getTopWndID()
	if curWndID ~= "B_FbBat" then
		if callBack then
			callBack()
		end 
		return
	end 
	local  batEffct = cc.UserDefault:getInstance():getIntegerForKey("batEffct", 0)
	if  batEffct > 0  then
		if callBack then
			callBack()
		end 
		return
	end 
	local tbMsg 
	--cclog("=======skillID======",skillID)
	if skillID >= 95000001 then
		 tbMsg = g_cfgMsg:getCfgMsg("roleSkill_D",skillID)
	else
		 tbMsg = g_cfgMsg:getCfgMsg("petSkill_D",skillID)
	end 
	
	local info =  g_batTbMsg:getBatInfo(roleID) 
	if tbMsg then
		local cfgID  = tbMsg.anima1 or 0
		if cfgID <= 0  then
			return
		end 
		self:showSkillEffctItem(roleID,toRoleID,cfgID,callBack)
	end 

end

function batWndContorl:showSkillEffctItem(roleID,toRoleID,cfgID,callBack)
	
	local tbMsg2 =  g_cfgMsg:getCfgMsg("animaEffct_D",cfgID)
	if not tbMsg2 then
		return
	end 
	local name = tbMsg2.name
	
	local movieClip = fgui.UIPackage:createObject("Res_skill_effect",name)
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local parentPanle =  B_FbBat.rootLayout:getChild("skillPanle") 
	parentPanle:addChild(movieClip)
	local offx = tbMsg2.posx or 0
	local offy = tbMsg2.posy or 0
	self.animaD  = self.animaD  + 1
	local count = self.animaD 
	movieClip:setCustomData(count)
	if  tbMsg2.startType == 0  then
		local roleItem = self:getItem(toRoleID)
		local atPos = roleItem:getPosition()
		movieClip:setPosition(atPos.x+ offx ,atPos.y+ offy )

	elseif tbMsg2.startType == 3 then
		if  roleID <= 100 then
			movieClip:setPosition(200 + offx,544 + offy) 
		else
			movieClip:setPosition(200 + offx,880 + offy) 
		end 
	
	elseif  tbMsg2.startType == 1  then	
		local roleItem = self:getItem(roleID)
		local atPos = roleItem:getPosition()
		movieClip:setPosition(atPos.x + offx,atPos.y + offy)
		--cclog(atPos,"=====atPos=====1=====")
	end 
	local scale = tbMsg2.scale
	if scale ~= 0 and scale ~= 1 then
		movieClip:setScale(scale,scale)
	end 
	
	
	local function Moviecallback()
		movieClip:removeFromParent()
		if callback then
			callback()
		end 
   end
	
	movieClip:setPlaySettings(0,-1,1,-1,Moviecallback)
	
	if tbMsg2.musicEff then
		g_gameMusic:playEffect(tbMsg2.musicEff)
	end 
end 


--攻击特效
function batWndContorl:showAttckEffctItemPool(roleID,toRoleID,callBack)
	local curWndID = g_WndMgr:getTopWndID()
	---cclog(curWndID,"==showAttckEffctItemPool===")
	if curWndID ~= "B_FbBat" then
		callBack()
		return
	end 
	
	local info =  g_batTbMsg:getBatInfo(roleID) 
	local cfgID 
	if roleID == 100 then
		local tbMsg =  g_cfgMsg:getCfgMsg("role_D",info.cfgID)
		cfgID = 1019 --tbMsg.effctID
	elseif roleID < 100 then
		local tbMsg =  g_cfgMsg:getCfgMsg("pet_D",info.cfgID)
		cfgID = tbMsg.effctID
	end  
	
	local tbMsg2 =  g_cfgMsg:getCfgMsg("animaEffct_D",cfgID)
	---cclog(roleID,info.cfgID,"=========animaEffct_D=====",cfgID)
	if  tbMsg2.ntype  == "2"  then
		self:showAttckEffctItemPool2(roleID,tbMsg2,toRoleID,callBack)
	elseif tbMsg2.ntype  == "3"  then
		self:showAttckEffctItemPool3(roleID,tbMsg2,toRoleID,callBack)
	elseif tbMsg2.ntype  == "4"  then
	end 

	if  tbMsg2.musicEff > 0 then
		local curWndID = g_WndMgr:getTopWndID()
		if curWndID == "B_FbBat" then
			g_gameMusic:playEffect(tbMsg2.musicEff)
		end 
	end 
end

--其他特效
function batWndContorl:showEffctItemPool(roleID,toRoleID,cfgID,callBack)
	local curWndID = g_WndMgr:getTopWndID()
	if curWndID ~= "B_FbBat" then
		callBack()
		return
	end 
	local info =  g_batTbMsg:getBatInfo(roleID) 

	local tbMsg2 =  g_cfgMsg:getCfgMsg("animaEffct_D",cfgID)
	if  tbMsg2.ntype  == "2"  then
		self:showAttckEffctItemPool2(roleID,tbMsg2,toRoleID,callBack)
	elseif tbMsg2.ntype  == "3"  then
		self:showAttckEffctItemPool3(roleID,tbMsg2,toRoleID,callBack)
	elseif tbMsg2.ntype  == "1"  then
		self:showAttckEffctItemPool1(roleID,cfgID,toRoleID,callBack)
	end 

	if  tbMsg2.musicEff > 0 then
		local curWndID = g_WndMgr:getTopWndID()
		if curWndID == "B_FbBat" then
			g_gameMusic:playEffect(tbMsg2.musicEff)
		end 
		
	end 
end 


function batWndContorl:animaISCocos(effNameID,atIndex,endCallBack,toIndex)
	
	local tbCfg = g_cfgMsg:getCfgMsg("animaEffct_D",effNameID) 
	local name = tbCfg.name
	local pos ,atPos
	if  atIndex  then
		local roleItem = self:getItem(atIndex)
		pos = roleItem:getPosition()
	else
		pos = cc.p(355,880)
	end 

	local skillScale1 = tbCfg.scale or 1
	if skillScale1 <= 0 then
		skillScale1 = 1
	end 
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local parentPanle =  B_FbBat.rootLayout:getChild("enemyPanle") 
	local parent = parentPanle
	local startType = tbCfg.startType
	if startType  == 1  then
		local item = self:getItem(atIndex)
		parent = item
		local isVisble = item:isVisible()
		if isVisble == false then
			return
		end 
		local nRandomY = math.random(-80,80)
		pos = cc.p(88,117 + nRandomY)
	end 

	local armature = g_gArmature:showArmature(name,parent,tbCfg.anima,nil,pos,nil,endCallBack)
	armature:setScale(skillScale1)
	local rate =  tbCfg.rate
	armature:setRotation(rate)	
	if toIndex and tbCfg.startType == 2 then
		local pos
		local roleItem = self:getItem(toIndex)
		pos = roleItem:getPosition()
		if toIndex > 10  then
			 pos  = cc.p(toPos.x+ tbCfg.posx , 653-toPos.y - tbCfg.posy )
		else
			pos = cc.p(toPos.x+ tbCfg.posx , 801 - toPos.y + tbCfg.posy )
		end 
		--获取方向
		local asinX = g_getRotationSinx(atPos,pos) or 0
		armature:setRotation(rate + asinX)
		local moveTo1 = cc.MoveTo:create(0.1,pos)
		local function endCallback1()	
			if tbCfg.nextID and tbCfg.nextID > 0  then
				self:animaISCocos(tbCfg.nextID,toIndex)
			end 
			if callBack then
				callBack()
			end 
		end

		local actionEnd1 = cc.CallFunc:create(endCallback1)
		local actionSequence2 = cc.Sequence:create(moveTo1,actionEnd1)
		actionSequence2:setTag(13)
		armature:stopActionByTag(13)
		armature:runAction(actionSequence2)	
	end 
end 

--攻击 特效类型1
function batWndContorl:showAttckEffctItemPool1(roleID,EffctID,toRoleID,callBack)
	self:animaISCocos(EffctID,toRoleID,endCallBack,toRoleID)
end 

--攻击 特效类型3
function batWndContorl:showAttckEffctItemPool2(roleID,tbMsg,toRoleID,callBack)
	
	local item =  g_itemPoolContorl:getItemPool(tbMsg.itemName)
	item:setVisible(true)
	local atPos
	if roleID then
		local roleItem = self:getItem(roleID)
		atPos = roleItem:getPosition()
		item:setPosition(atPos.x  ,atPos.y )
		item:setIcon(g_iconConTrol:getEffctIcon(tbMsg.name))
	end 
	--是否播放动画
	if tbMsg.isT0 ~= "" then
		local dongH = item:getTransition(tbMsg.isT0)
		dongH:play()
	end 
	if tbMsg.scale ~= 0 then
		item:setScale(tbMsg.scale,tbMsg.scale)
	else
		item:setScale(1,1)
	end 
	
	if tbMsg.startType ~= 2 then
		return
	end 
	
	local toRoleItem = self:getItem(toRoleID)
	local toPos = toRoleItem:getPosition()
	local pos = cc.p(0,0)
	pos.y = atPos.y - toPos.y 
	pos.x = toPos.x - atPos.x 
	
	local itemObj = item:displayObject()
	local posX,posY = itemObj:getPosition()
	
	local function callBackFunc()
		if callBack then
			callBack()
		end 
		itemObj:setPosition(posX,posY)
		g_itemPoolContorl:returnItemPool(tbMsg.itemName,item)
	end 
	g_action:moveByAction(itemObj,nil,pos,callBackFunc,nil,0.2)
	
	if tbMsg.isRate then
		local asinX = g_getRotationSinx(atPos,toPos) or 0
		item:setRotation(-asinX)
	end 
end

--攻击 特效类型3
function batWndContorl:showAttckEffctItemPool3(roleID,tbMsg,toRoleID,callBack)
	
	local item =  g_itemPoolContorl:getItemPool(tbMsg.itemName)
	item:setVisible(true)
	local atPos
	if roleID then
		local roleItem = self:getItem(roleID)
		atPos = roleItem:getPosition()
		local offX ,offY = 0
		if roleID == 100  then
			local nrandom = math.random(-80,80)
			local nrandomY = math.random(-20,50)
			offX = nrandom
			offY = nrandomY
		end 
		item:setPosition(atPos.x + offX,atPos.y + offY)
		item:setIcon(g_iconConTrol:getEffctIcon(tbMsg.name))
	end 
	--是否播放动画
	if tbMsg.isT0 ~= "" then
		local dongH = item:getTransition(tbMsg.isT0)
		dongH:play()
	end 
	if tbMsg.scale ~= 0 then
		item:setScale(tbMsg.scale,tbMsg.scale)
	else
		item:setScale(1,1)
	end 
	
	if tbMsg.startType ~= 2 then
		return
	end 
	
	local toRoleItem = self:getItem(toRoleID)
	local toPos = toRoleItem:getPosition()
	local pos = cc.p(0,0)
	pos.y = atPos.y - toPos.y 
	pos.x = toPos.x - atPos.x 
	local isVisble = toRoleItem:isVisible()
	cclog(toRoleItem,pos,isVisble,"======getItem=======")
	local itemObj = item:displayObject()
	local posX,posY = itemObj:getPosition()
	
	local function callBackFunc()
		if callBack then
			callBack()
		end 
		itemObj:setPosition(posX,posY)
		g_itemPoolContorl:returnItemPool(tbMsg.itemName,item)
	end 
	g_action:moveByAction(itemObj,nil,pos,callBackFunc,nil,0.2)
	
	if tbMsg.isRate then
		local asinX = g_getRotationSinx(atPos,toPos) or 0
		item:setRotation(-asinX)
	end 
end



--死亡控件操作
function batWndContorl:deatItem(roleID)
	local roleItem = self:getItem(roleID)
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	if roleID >= 1000 then
		
		local item = g_batWndContorl:getItem(roleID)
		local c1 =  item:getController("c1") --控制器
		c1:setSelectedIndex(3)
		local function callFunc()
			item:setVisible(false)
		end 
		if not self.isBossBat  then
			local killEnemyNum = (g_batTbMsg:getFbBatMsg(fbBatMsgKey.killEnemyNum) or 0)
			local maxNum = g_batMath:mathFbBatKillMaxNum() 
			if killEnemyNum < maxNum then
				g_batTbMsg:setFbBatMsg(fbBatMsgKey.killEnemyNum,killEnemyNum+1)
			end 
		end
		self:setEnemyTalk(roleID,EnemyTalkStatus_DEAD,callFunc)
		
		if not self.isBossBat  then
			self:baokuAddRes()
			g_batWndContorl:dropCoin(roleID,1)
			--local curWndID = g_WndMgr:getTopWndID()
			--if curWndID == "B_FbBat" then
				--g_gameMusic:playEffect(75)
			---end 
		end

		B_FbBat:setFbMsgPanleBar()
		g_batMath:addKillCount() 
	
	elseif 	roleID == 500  then
		local item = g_batWndContorl:getItem(roleID)
		local c1 =  item:getController("c1") --控制器
		c1:setSelectedIndex(1)	
		local curWndID = g_WndMgr:getTopWndID()
		if curWndID == "B_FbBat" then
			local id =  math.random(26,32)
			g_gameMusic:playEffect(id)
		end
		--local  value1 = g_roleMsg:getRoleAttValue(RoleAttMsg.baoji)
		--local  value2 =  g_roleMsg:getRoleAttValue(RoleAttMsg.mfDps,nil,true)
		--local  value3 =  g_roleMsg:getRoleAttValue(RoleAttMsg.wlDps,nil,true)
		---local  value4 = 150 + g_roleMsg:getRoleAttValue(RoleAttMsg.baojiHurt)
		--cclog(value1,value2,value3,"====leaveGameTime====222====")
		---local string1 = {tostring(value1),tostring(value2),tostring(value3),tostring(value4)}
		
		
	elseif roleID == 100   then
		local curWndID = g_WndMgr:getTopWndID()
		if curWndID == "B_FbBat" then
			g_gameMusic:playEffect(32)
		end
	elseif roleID < 100   then	
		local item = g_batWndContorl:getItem(roleID)
		local c1 =  item:getController("c1") --控制器
		c1:setSelectedIndex(1)	
	end 
end 

---玩家说话
EnemyTalkStatus_Lost = 1
EnemyTalkStatus_DEAD = 2
EnemyTalkStatus_BatIng = 3


function batWndContorl:setEnemyTalk(roleID,status,callFunc)
	local batTalk =  cc.UserDefault:getInstance():getIntegerForKey("dropCoin", 0)
	if batTalk == 1  then	
		if callFunc then	
			callFunc()
		end 
		return
	end 
	local mapLev = g_batMath:getMapLev() 
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	if mapType ~= 1 or mapLev > 500 then
		if callFunc then	
			callFunc()
		end 
		return
	end 
	local status = handler(self, self["setEnemyTalk"..status])(roleID,callFunc)
	if not status then
		if callFunc then	
			callFunc()
		end 
	end 
	
	return status
end

function batWndContorl:setEnemyTalk1(roleID,callFunc)
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local curWndID = g_WndMgr:getTopWndID()
	if not B_FbBat or curWndID ~= "B_FbBat" then
		return
	end 
	local mapLev = g_batMath:getMapLev() 
	local ratio = 100 + mapLev*3
	local nRandom = math.random(1,ratio)
	
	local mapLev = g_batMath:getMapLev() 
	if nRandom <= 20 then
		local item = g_batWndContorl:getItem(roleID)
		
		local nRandomID = math.random(1,10)
		local cfgMsg =  g_cfgMsg:getCfgMsg("talkwj_D",nRandomID)
		B_FbBat:setEnemyTalk(item,cfgMsg.dec,callFunc)
		return true 
	end 
	return  
end 

function batWndContorl:setEnemyTalk2(roleID,callFunc)
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local curWndID = g_WndMgr:getTopWndID()
	if not B_FbBat or curWndID ~= "B_FbBat" then
		return
	end 
	local mapLev = g_batMath:getMapLev() 
	local ratio = 100 + mapLev*3
	local nRandom = math.random(1,ratio)
	if nRandom <= 10 then
		local item = g_batWndContorl:getItem(roleID)
		
		local nRandomID = math.random(500,506)
		local cfgMsg =  g_cfgMsg:getCfgMsg("talkwj_D",nRandomID)
		B_FbBat:setEnemyTalk(item,cfgMsg.dec,callFunc)
		return true 
	end 
	return  
end 
function batWndContorl:setEnemyTalk3(roleID,callFunc)
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local curWndID = g_WndMgr:getTopWndID()
	if not B_FbBat or curWndID ~= "B_FbBat" then
		return
	end 
	local mapLev = g_batMath:getMapLev() 
	local ratio = 100 + mapLev*3
	local nRandom = math.random(1,ratio)
	--local nRandom = math.random(1,100)
	
	local ration = 2
	if mapLev < 10  then
		ration = 5
	end 
	if nRandom <= ration then
		local item = g_batWndContorl:getItem(roleID)
		
		local nRandomID = math.random(100,123)
		local cfgMsg =  g_cfgMsg:getCfgMsg("talkwj_D",nRandomID)
		B_FbBat:setEnemyTalk(item,cfgMsg.dec,callFunc)
		return true 
	end 
	return  
end 

function batWndContorl:initTopPanel()
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	B_FbBat:setTextFbName()
	B_FbBat:textBaoKu()
	B_FbBat:setFbMsgPanle()	
	B_FbBat:setFbMsgPanleBar(true)	
	B_FbBat:setFbMsgPanleText()
end 


function batWndContorl:dropCoinAnimaLost(atPos)
	local item =  g_itemPoolContorl:getItemPool("DropCoinPool")
	item:setVisible(true)
	local posx =  math.random(-100,100)
	local height = math.random(30,80)
	local posx2 =  math.random(150,660)
	item:setPosition(posx2,1186)
	
	local itemObj	= item:displayObject()	
	local posX,posY = itemObj:getPosition()
	local function callBackFunc()
		itemObj:setPosition(posX,posY)
		g_itemPoolContorl:returnItemPool("DropCoinPool",item)
	end 

	local toPos =  cc.p( atPos.x,atPos.y-1440)  
	cclog(atPos,"=========dropAction============",cc.p(posx,10),height,toPos)
	g_action:dropAction(itemObj,cc.p(posx,10),height,toPos,callBackFunc)
end 
function batWndContorl:dropCoinLost(roleID,num)
	local atPos
	if roleID then
		local roleItem = self:getItem(roleID)
		atPos = roleItem:getPosition()	
	end 
	for i=1, num do
		batWndContorl:dropCoinAnimaLost(atPos)
	end 
end
function batWndContorl:dropCoinLostAll()
 
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	local textFbName = B_FbBat.rootLayout:getChild("textFbName")
	local textFbName = textFbName:displayObject()
	local tbInfo = g_batTbMsg:getFbEnemyMsg() 
	
	local tbMsg = {}
	for  index,info in pairs(tbInfo)do
		if info.status >= 0 and info.status ~= 3 and #tbMsg < 10 then
			tbMsg[#tbMsg+1] = index
		end 
	end 
	local Num = 0
	local count = 1
	local value = g_batTbMsg:getFbBatMsg(fbBatMsgKey.BaokuResMath) or 0
	value =  byBigInt(value, 0.1,true)
	local btnMag = B_FbBat.rootLayout:getChild("btnMag")
	local btnMag = btnMag:displayObject()
	local function callBack()
		textFbName:stopActionByTag(100)
		btnMag:stopActionByTag(100)
		g_batContorl:initGameMsg()
		g_action:ts_hszz_antion("你被夺走了"..value.."金币",nil,nil,nil,nil,nil)
	end 
	local function scheduleByOne()
		local index = tbMsg[count]
		self:dropCoinLost(index,5)
		self:setEnemyTalk(index,EnemyTalkStatus_Lost)
		count = count%(#tbMsg) + 1
		Num = Num + 1
		
		if Num == #tbMsg then
			callBack()
		end 
	end 
	g_svSendMsgControl:request_geBatMsg(5,curMapLev)
	local num = #tbMsg
	if num < 3 then
		num  = 3 
	end 
	g_scheduleTime:scheduleByTimes(textFbName, 0.2,#tbMsg,scheduleByOne)

	g_scheduleTime:scheduleByTimes(btnMag, 1.5,1,callBack)
end 

function batWndContorl:dropCoinAnima(atPos)
	local item =  g_itemPoolContorl:getItemPool("DropCoinPool")
	item:setVisible(true)
	item:setPosition(atPos.x ,atPos.y )
	local itemObj	= item:displayObject()	
	local posX,posY = itemObj:getPosition()
	local function callBackFunc()
		itemObj:setPosition(posX,posY)
		g_itemPoolContorl:returnItemPool("DropCoinPool",item)
	end 
	
	local posx =  math.random(-100,100)
	local height = math.random(30,80)
	local posx2 =  math.random(150,660)
	local toPos = cc.p(posx2,-1186)

	g_action:dropAction(itemObj,cc.p(posx,10),height,nil,callBackFunc)
end 



function batWndContorl:dropCoin(roleID,num)
	local dropCoin =  cc.UserDefault:getInstance():getIntegerForKey("dropCoin", 0)
	if dropCoin == 1  then	
		return
	end 
	--local mapType =  g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	--if mapType ~= 1 then
	---	return
	--end 
	local atPos
	if roleID then
		local roleItem = self:getItem(roleID)
		atPos = roleItem:getPosition()	
	end 
	for i=1, num do
		batWndContorl:dropCoinAnima(atPos)
	end 
end 



--获取离线
function batWndContorl:gotoFuben(index)
	--local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	--if  B_FbBat and index ==  B_FbBat.fbIndex  then
		g_batContorl:initGameMsg()
		g_WndMgr:openWnd("B_FbBat")
		if index and g_fbName[index] then	
			g_action:ts_hszz_antion("进入副本"..g_fbName[index])
		end 
		
	--else
	--	g_WndMgr:openWnd("B_FbBat")
	--end 	
end 

--获取离线
function batWndContorl:getOff(index)
	g_svSendMsgControl:request_geBatMsg(2,index)
end 

--宝库计算
function batWndContorl:baokuAddRes()
	local maxValue = g_mathConTrol.bkMaxValue
	local addVaLue = 1
	local Allvalue = g_batTbMsg:getFbBatMsg(fbBatMsgKey.BaokuResMath) or 0
	--cclog(Allvalue,maxValue,"===11==baokuAddRes=======")
	local value,lev = g_batMath:mathFbBatEnemyRes()
	if   MaxBigInt(Allvalue, maxValue)then
		return
	end 
	local AllvalueD = addBigInt(Allvalue, value)
	--cclog(AllvalueD,maxValue,value,"==222===baokuAddRes=======")
	g_batTbMsg:setFbBatMsg(fbBatMsgKey.BaokuResMath,AllvalueD) 
	local B_FbBat = g_WndMgr:getWnd("B_FbBat")
	B_FbBat:textBaoKu()
	B_FbBat.countResD = B_FbBat.countResD + addVaLue

	local ComponentFubenPanle = g_WndMgr:getWnd("ComponentFubenPanle")
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	if ComponentFubenPanle then
		
		ComponentFubenPanle:reloadDecPanle(mapType)
	end  
	local baokuKillValue1 = g_baseMsg:getOther(otherDBMsgID.baokuKillValue1) or 0
	baokuKillValue1 = baokuKillValue1+ 1
	g_baseMsg:setOtherStrByID(otherStrDBMsgID["baokuValue1"],AllvalueD)
	local baokuValue2 = g_baseMsg:getOtherStr(otherStrDBMsgID["baokuValue2"]) or "0"
	local value = byBigInt(value, "2")  
	local valueD = addBigInt(baokuValue2, value)  
	--cclog(valueD,baokuValue2,"=====baokuAddRes===222====",AllvalueD)
	g_baseMsg:setOtherStrByID(otherStrDBMsgID["baokuValue2"],valueD)
end

function batWndContorl:initItemPool()
	fgui.UIPackage:addPackage("B_FuBen");
	---fgui.UIPackage:addPackage("z_role");
	
	g_itemPoolContorl:initItemPool("EnemyPool",20,"B_FuBen", "batWanJiaItem")
	g_itemPoolContorl:initItemPool("attckEff1",10,"B_FuBen", "attckEff1")
	g_itemPoolContorl:initItemPool("attckEff2",10,"B_FuBen", "attckEff2")
	g_itemPoolContorl:initItemPool("attckEff3",10,"B_FuBen", "attckEff3")
	g_itemPoolContorl:initItemPool("DropCoinPool",100,"B_FuBen", "ComponentDropCoin")
	g_itemPoolContorl:initItemPool("hurt",50,"B_FuBen", "Component_hurt")
	g_itemPoolContorl:initItemPool("baoji",50,"B_FuBen", "Component_baoji")
	g_itemPoolContorl:initItemPool("zhiliao",10,"B_FuBen", "Component_add")
	g_itemPoolContorl:initItemPool("stausText",10,"B_FuBen", "Component_staus")
	g_itemPoolContorl:initItemPool("addMp",10,"B_FuBen", "Component_addMP")
	g_itemPoolContorl:initItemPool("mpHurt",50,"B_FuBen", "Component_mpHurt")
	
	
end 


function batWndContorl:ctor()
	self.animaD = 1
end

g_batWndContorl =  batWndContorl:create()