------------------
-- 文件名:	batMathPK.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local batMathPK = class("batMathPK")

---==============================================
---==============================================
-- 
function batMathPK:getMapLev(mapType) 
	local mapType = mapType or g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local fubenCurLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenCurLev) or {}
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}		
	local curMapLev = fubenCurLev[mapType] or 1
	local maxMapLev = fubenMaxLev[mapType] or 1
	return curMapLev,maxMapLev
end


---===========初始化=======================================

---===============================
--速度转换为秒 1是pet
function batMathPK:mathSpeed(speed,nType) 
	local baseTime = 1
	local mapType = g_baseMsg:getOther(otherDBMsgID.mapType) or 1
	local fubenMaxLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenMaxLev) or {}	
	local fubenCurLev = g_baseMsg:getTbInteger(tbIntegerKEy.fubenCurLev) or {}	
	local curMapLev = fubenCurLev[mapType] or 1
	
	local level =  g_roleAttConTrol:getMaxLev()
	local minSpeed = 6 + level
	local maxSpeed = minSpeed * 1.5 + 10
	
	if mapType == 1 and curMapLev <= 300  then
		if nType == 1 then
			return 0.5
		end 
		if curMapLev <= 50  then
			return 0.1
		end 
		return 0.2
	end 
	if  tonumber(speed) <= minSpeed  then	
		return baseTime
	end 
	if  speed >= maxSpeed and curMapLev > 300  then	
		if nType == 1 then
			return 0.5
		end 
		return 0.2
	end 
	local speedD = speed - minSpeed
	local offSpeed = maxSpeed - minSpeed
	local pro = speedD/offSpeed
	local nTime = 1 * pro
	local speedD = baseTime - nTime
	
	if speedD < 0.2  then
		return 0.2
	end 
	speedD = math.floor(speedD*100)/100
	return speedD
end

---随机获取x个目标
function batMathPK:mathFbBatEnemyObj(num)  
	local info100 = g_batTbMsg:getFbRoleMsg() 
	--获取存活
	local tbMsg = {}
	local tbMsg2 = {}
	if info100.status >= 0 and info100.status ~= ROLESTATUSS.death then
		tbMsg[1] = {100,info100.chouhen}
		tbMsg2[1] = 100
	end 
	local tbInfo = g_batTbMsg:getFbPetMsg() or {}
	local count = 0
	for  index,info in pairs(tbInfo)do
		if info.status >= 0 and info.status ~= ROLESTATUSS.death then
			tbMsg[#tbMsg+1] = {index,info.chouhen} 
			tbMsg2[#tbMsg2+1] = index
			count = count + info.chouhen
		end 
		--cclog(info,"=======info========",index)
	end 
	if num == -1 then
		return tbMsg2
	end 
	local tbObj = {}
	if  num >= #tbMsg  then
		for i=1, #tbMsg  do
			tbObj[#tbObj+1] = tbMsg2[i]
		end 
	else
		for i=1, num do
			local key,index = getRandomBytbRation2(tbMsg,count)
			--cclog(key,"===getRandomBytbRation2=====",tbMsg,count,key,index )
			tbObj[#tbObj+1] = tbMsg2[index]
			count = count -  tbMsg[index][2]
			table.remove(tbMsg,index)
			---cclog(tbObj,"===getRandomBytbRation2=====",tbMsg2[index],tbMsg2)
		end 
	end 
	return tbObj
end 

---随机获取x个目标 --
function batMathPK:mathFbBatRoleObj(num,nType) 
	local tbMsg = {}
	
	local tbInfo = g_batTbMsgPK:getBatInfo() 
	for  index,info in pairs(tbInfo)do
		if info.status >= 0 and info.status ~= 3 then
			if nType ==  1 and info.index > 1000 then
				tbMsg[#tbMsg+1] = index
			elseif nType ==  2 and info.index < 1000 then
				tbMsg[#tbMsg+1] = index
			end 	
		end 
	end 
	if num == -1 then
		return tbMsg
	end 
	local tbObj = {}
	for i=1, num do
		local nRandom = math.random(1,#tbMsg)
		tbObj[#tbObj+1] = tbMsg[nRandom]
		table.remove(tbMsg,nRandom)
	end 
	return tbObj
end 

---随机获取x个目标 仇恨最高
function batMathPK:mathFbBatRoleObj2(num,nType) 
	local tbMsg = {}
	
	local tbInfo = g_batTbMsgPK:getBatInfo() 
	for  index,info in pairs(tbInfo)do
		if info.status >= 0 and info.status ~= 3 then
			if nType ==  1 and info.index > 1000 then
				tbMsg[#tbMsg+1] = {index ,info.chouhen}
			elseif nType ==  2 and info.index < 1000 then
				tbMsg[#tbMsg+1] = {index ,info.chouhen}
			end 	
		end 
	end 
	if num == -1 then
		return tbMsg
	end 
	--排序
	local function comps(a,b)
		if a[2] ==  b[2]  then
			return a[1]  >  b[1]
		else
			return  a[2]  >  b[2]
		end 
	end 
	table.sort(tbMsg, comps)
	local tbObj = {}
	if num > #tbMsg then
		num = #tbMsg
	end 
	for i=1, num do
		tbObj[#tbObj+1] = tbMsg[i][1]
	end 
	return tbObj
end 
--对方是否躲闪
function batMathPK:mathDuoshan(jingzhun,duoshan,toRoleID) 
	local value = duoshan/(jingzhun*2 + duoshan)
	value = value*10000
	local rantom = math.random(1,10000)
	
	local addvalue = g_batRoleSkillContorlPK:isZhongZhuSkillYS(toRoleID) or 0
	value = value + addvalue
	if value > 9000 then
		value = 9000
	end 
	cclog(rantom,value,"===mathDuoshan==22====",duoshan,jingzhun)
	
	if rantom <= value then
		return batStatusTypes.sb 
	end 
	return
end
--是否暴击
function batMathPK:mathBaoji(baoji1,toBaoji,toRoleID)
	
	local addvalue = g_batRoleSkillContorlPK:isZhongZhuSkillFlong(toRoleID)  or 0
	if addvalue == 1  then
		return
	end 
	local nBaoji = baoji1 - toBaoji
	nBaoji = nBaoji*100
	local rantom = math.random(1,10000)
	if rantom <= nBaoji then
		return 1
	end 
	return
end
--是否释放技能
function batMathPK:mathIsSkill(info) 
	local isSkill
	return isSkill
end 
--计算物理伤害
function batMathPK:mathHurtWl(info,toinfo,dps) 
	--获取攻击
	local dps = dps or  info.dpsWl
	--获取防御
	local def = toinfo.defWL
	--计算减伤
	local minHurt =    byBigInt(toinfo.defWL, "0.9",true)  
	if not MaxBigInt(minHurt,"1")  then
		minHurt = "1"
	end 
	local value = subBigInt(dps, def)  
	if not MaxBigInt(value,minHurt) then
		value = minHurt
	end 
	local attHurt = self:mathHurtAtt(info,toinfo) 
	value = addBigInt(attHurt, value)
	return value
end

--计算魔法伤害
function batMathPK:mathHurtMF(info,toinfo,dps) 
	--获取攻击
	local dps = dps or info.dpsMf
	--获取防御
	local def =   byBigInt(toinfo.defMf, "0.9",true)  
	--计算减伤
	local minHurt =   byBigInt(dps, "0.1",true)    
	local value = subBigInt(dps, def)  
	if not MaxBigInt(value,minHurt) then
		value = minHurt
	end 
	local attHurt = self:mathHurtAtt(info,toinfo) 
	value = addBigInt(attHurt, value)
	return value
end

--计算属性伤害
function batMathPK:mathHurtAtt(info,toinfo) 
	--获取属性攻击
	local allHurt = "0"
	for i=1,4 do
		local dps = info.attHurt[1] or "0"
		local def = toinfo.attHurtDef[1] or "0"
		local value = subBigInt(dps, def) 
		if not MaxBigInt(value,"0")  then
			value = "0"
		end 
		allHurt = addBigInt(allHurt, value)
	end 
	return allHurt
end

--计算伤害baoji
function batMathPK:mathHurtBaoji(info,hurt) 
	local baojiHurt = info.baojiHurt or 150
	if baojiHurt < 100 then
		baojiHurt = 100
	end 
	local hurt1 = byBigInt(baojiHurt,hurt)  
	local hurt =  byBigInt(hurt1, "0.01",true) 
	
	
	return hurt
end



function batMathPK:ctor()
	
	self.GameCount = {}
end

g_batMathPK =  batMathPK:create()