------------------
-- 文件名:	batWndContorlPK.lua
-- 版  权:	(C)  铁锤工作室
-- 创建人:	陆奎安
-- 日  期:	2019-12-2 11:24
-- 版  本:	1.0
-- 描  述:	图片Icon操作
-- 应  用:  
-------------------
local batWndContorlPK = class("batWndContorlPK")


function batWndContorlPK:getItem(roleID)
	local info =  g_batTbMsgPK:getBatInfo(roleID) 
	local item 
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	if roleID == 100  then
		item =  B_FbBatPk.rootLayout:getChild("roleItem1") 
	elseif  roleID  <= 100   then
		item =  B_FbBatPk.rootLayout:getChild("petItem"..roleID) 
	elseif  roleID == 1100  then
		item =  B_FbBatPk.rootLayout:getChild("roleItem2") 
	elseif  roleID > 1000 and roleID <= 1008   then
		item =  B_FbBatPk.rootLayout:getChild("petItem"..roleID) 
	end 
	cclog(item,"====getItem=========",roleID)
	return item
end 

function batWndContorlPK:cleanItemBuf(roleID)
	local item = self:getItem(roleID)
	local bufList = item:getChild("bufList") 
	self:setItemBuf(roleID)
end 
function batWndContorlPK:setItemBuf(roleID)
	local item = self:getItem(roleID)
	local info =  g_batTbMsgPK:getBatInfo(roleID) 
	cclog(info,"====setItemBuf=======",roleID)
	local bufList = item:getChild("bufList") 
	local tbListMsg = {}
	
	for ID,tbMsg in pairs(info.bufMsg)do
		
		if  tbMsg.nTime ~= 0 then
			local bufID = math.floor(ID/10000)
			
			tbListMsg[#tbListMsg+1] = bufID
		end 
	end 
	bufList:itemRenderer(function(index, obj)
			local indexD = index + 1
			local attID = tbListMsg[indexD]
			local cfgMsg =  g_cfgMsg:getCfgMsg("att_D",attID)
			cclog(attID,"====tbListMsg=====",cfgMsg.dec)
			obj:setText(cfgMsg.dec)
			local title = obj:getChild("title") 
			cc.g_setTextColor(title,cfgMsg.nType or 1,true)
		end)
	
	bufList:setVirtual()--回调
	bufList:setNumItems(#tbListMsg);

end 

---显示伤害飘字
function batWndContorlPK:createHurtPiaozi(roleID,str,colorID,nType,isMp)
	local curWndID = g_WndMgr:getTopWndID()
	---cclog(curWndID,"=====createHurtPiaozi=======")
	if curWndID ~= "B_FbBatPk" then
		return
	end 
	local item ,dongH,poolName
	local nType = nType or 1
	--cclog(nType,"=====createHurtPiaozi=======",roleID,str,colorID,nTyp)
	if nType == 1 then
		if isMp then
			poolName = "mpHurt"
		else
			poolName = "hurt"
		end 
		
		item =  g_itemPoolContorl:getItemPoolPk(poolName)
		dongH = item:getTransition("t1")

	elseif nType == 2 then --暴击
		poolName = "baoji"
		item =  g_itemPoolContorl:getItemPoolPk("baoji")
		dongH = item:getTransition("t0")
	elseif nType == 3 then --治疗
		poolName = "zhiliao"
		item =  g_itemPoolContorl:getItemPoolPk("zhiliao")
		dongH = item:getTransition("t0")
	elseif nType == 4 then --魔法
		poolName = "addMp"
		item =  g_itemPoolContorl:getItemPoolPk("addMp")
		dongH = item:getTransition("t1")
	end 

	item:setVisible(true)
	item:setText(str)
	if colorID then
		local  title =  item:getChild("title") 
		cc.g_setTextColor(title,colorID,true)
	end 
	
	--cclog(str,"=====createHurtPiaozi===222====")
	local function callback()
		g_itemPoolContorl:returnItemPoolPk(poolName,item)
	end 
	dongH:play(callback)
	if roleID then
		local roleItem = self:getItem(roleID)
		local pos = roleItem:getPosition()
		local Random1 = math.random(-10,10)
		local Random2 = math.random(-10,10)
		item:setPosition(pos.x + 10+Random2 ,pos.y+Random1)
		---=cclog(pos,"======setPosition========")
	end 
	self:setWndHp(roleID)
end

function batWndContorlPK:setWndHp(roleID)
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	if roleID == 100  then
		B_FbBatPk:setFbMsgPanleRoleHp(1)
	elseif roleID == 1100  then
		B_FbBatPk:setFbMsgPanleRoleHp(2)
	elseif roleID == 500  then --BOSS
		---B_FbBatPk:setFbMsgPanleBOSSHp()
	else
		--local roleItem = self:getItem(roleID)
		--B_FbBatPk:setFbMsgPanleEnemy0Hp(roleItem,roleID)
	end 
end 
function batWndContorlPK:setWndMp(roleID)
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	if roleID == 100  then
		B_FbBatPk:setFbMsgPanleRoleMp()
	end 
end 
---显示状态飘字
function batWndContorlPK:createStausPiaozi(roleID,str,colorID)
	local curWndID = g_WndMgr:getTopWndID()
	cclog("====createStausPiaozi======",curWndID)
	if curWndID ~= "B_FbBatPk" then
		return
	end 
	local item =  g_itemPoolContorl:getItemPoolPk("stausText")
	local dongH = item:getTransition("t0")
	item:setVisible(true)
	item:setText(str)
	if colorID then
		local  title =  item:getChild("title") 
		cc.g_setTextColor(title,colorID,true)
	end 
	
	local function callback()
		g_itemPoolContorl:returnItemPoolPk("stausText",item)
	end 
	dongH:play(callback)
	if roleID then
		local roleItem = self:getItem(roleID)
		local pos = roleItem:getPosition()
		item:setPosition(pos.x,pos.y)
	end 
end


--技能特效
function batWndContorlPK:showSkillEffctItemPool(roleID,toRoleID,skillID,callBack)
	local curWndID = g_WndMgr:getTopWndID()
	if curWndID ~= "B_FbBatPk" then
		if callBack then
			callBack()
		end 
		return
	end 
	local tbMsg 
	--cclog("=======skillID======",skillID)
	if skillID >= 95000001 then
		 tbMsg = g_cfgMsg:getCfgMsg("roleSkill_D",skillID)
	else
		 tbMsg = g_cfgMsg:getCfgMsg("petSkill_D",skillID)
	end 
	
	local info =  g_batTbMsgPK:getBatInfo(roleID) 
	if tbMsg then
		local cfgID  = tbMsg.anima1 or 0
		if cfgID <= 0  then
			return
		end 
		self:showSkillEffctItem(roleID,toRoleID,cfgID,callBack)
	end 

end

function batWndContorlPK:showSkillEffctItem(roleID,toRoleID,cfgID,callBack)
	
	local tbMsg2 =  g_cfgMsg:getCfgMsg("animaEffct_D",cfgID)
	if not tbMsg2 then
		return
	end 
	local name = tbMsg2.name
	
	local movieClip = fgui.UIPackage:createObject("Res_skill_effect",name)
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	local parentPanle =  B_FbBatPk.rootLayout:getChild("skillPanle") 
	parentPanle:addChild(movieClip)
	local offx = tbMsg2.posx or 0
	local offy = tbMsg2.posy or 0
	self.animaD  = self.animaD  + 1
	local count = self.animaD 
	movieClip:setCustomData(count)
	if  tbMsg2.startType == 0  then
		local roleItem = self:getItem(toRoleID)
		local atPos = roleItem:getPosition()
		movieClip:setPosition(atPos.x+ offx ,atPos.y+ offy )

	elseif tbMsg2.startType == 3 then
		if  roleID <= 100 then
			movieClip:setPosition(200 + offx,544 + offy) 
		else
			movieClip:setPosition(200 + offx,880 + offy) 
		end 
	
	elseif  tbMsg2.startType == 1  then	
		local roleItem = self:getItem(roleID)
		local atPos = roleItem:getPosition()
		movieClip:setPosition(atPos.x + offx,atPos.y + offy)
		--cclog(atPos,"=====atPos=====1=====")
	end 
	local scale = tbMsg2.scale
	if scale ~= 0 and scale ~= 1 then
		movieClip:setScale(scale,scale)
	end 
	
	
	local function Moviecallback()
		movieClip:removeFromParent()
		if callback then
			callback()
		end 
   end
	
	movieClip:setPlaySettings(0,-1,1,-1,Moviecallback)
	
	if tbMsg2.musicEff then
		g_gameMusic:playEffect(tbMsg2.musicEff)
	end 
end 


--攻击特效
function batWndContorlPK:showAttckEffctItemPool(roleID,toRoleID,callBack)
	local curWndID = g_WndMgr:getTopWndID()
	if curWndID ~= "B_FbBatPk" then
		callBack()
		return
	end 
	
	local info =  g_batTbMsgPK:getBatInfo(roleID) 
	local cfgID 
	if roleID == 100 then
		local tbMsg =  g_cfgMsg:getCfgMsg("role_D",info.cfgID)
		cfgID = 1019 --tbMsg.effctID
	elseif roleID < 100 then
		local tbMsg =  g_cfgMsg:getCfgMsg("pet_D",info.cfgID)
		cfgID = tbMsg.effctID
	end  
	
	local tbMsg2 =  g_cfgMsg:getCfgMsg("animaEffct_D",cfgID)
	----cclog(roleID,info.cfgID,"=========animaEffct_D=====",cfgID)
	if  tbMsg2.ntype  == "2"  then
		self:showAttckEffctItemPool2(roleID,tbMsg2,toRoleID,callBack)
	elseif tbMsg2.ntype  == "3"  then
		self:showAttckEffctItemPool3(roleID,tbMsg2,toRoleID,callBack)
	elseif tbMsg2.ntype  == "4"  then
	end 

	if  tbMsg2.musicEff > 0 then
		local curWndID = g_WndMgr:getTopWndID()
		if curWndID == "B_FbBatPk" then
			g_gameMusic:playEffect(tbMsg2.musicEff)
		end 
	end 
end

--其他特效
function batWndContorlPK:showEffctItemPool(roleID,toRoleID,cfgID,callBack)
	local curWndID = g_WndMgr:getTopWndID()
	if curWndID ~= "B_FbBatPk" then
		callBack()
		return
	end 
	local info =  g_batTbMsgPK:getBatInfo(roleID) 

	local tbMsg2 =  g_cfgMsg:getCfgMsg("animaEffct_D",cfgID)
	if  tbMsg2.ntype  == "2"  then
		self:showAttckEffctItemPool2(roleID,tbMsg2,toRoleID,callBack)
	elseif tbMsg2.ntype  == "3"  then
		self:showAttckEffctItemPool3(roleID,tbMsg2,toRoleID,callBack)
	elseif tbMsg2.ntype  == "1"  then
		self:showAttckEffctItemPool1(roleID,cfgID,toRoleID,callBack)
	end 

	if  tbMsg2.musicEff > 0 then
		local curWndID = g_WndMgr:getTopWndID()
		if curWndID == "B_FbBatPk" then
			g_gameMusic:playEffect(tbMsg2.musicEff)
		end 
		
	end 
end 


function batWndContorlPK:animaISCocos(effNameID,atIndex,endCallBack,toIndex)
	
	local tbCfg = g_cfgMsg:getCfgMsg("animaEffct_D",effNameID) 
	local name = tbCfg.name
	local pos ,atPos
	if  atIndex  then
		local roleItem = self:getItem(atIndex)
		pos = roleItem:getPosition()
	else
		pos = cc.p(355,880)
	end 

	local skillScale1 = tbCfg.scale or 1
	if skillScale1 <= 0 then
		skillScale1 = 1
	end 
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	local parentPanle =  B_FbBatPk.rootLayout:getChild("enemyPanle") 
	local parent = parentPanle
	local startType = tbCfg.startType
	if startType  == 1  then
		local item = self:getItem(atIndex)
		parent = item
		local isVisble = item:isVisible()
		if isVisble == false then
			return
		end 
		local nRandomY = math.random(-80,80)
		pos = cc.p(88,117 + nRandomY)
	end 

	local armature = g_gArmature:showArmature(name,parent,tbCfg.anima,nil,pos,nil,endCallBack)
	armature:setScale(skillScale1)
	local rate =  tbCfg.rate
	armature:setRotation(rate)	
	if toIndex and tbCfg.startType == 2 then
		local pos
		local roleItem = self:getItem(toIndex)
		pos = roleItem:getPosition()
		if toIndex > 10  then
			 pos  = cc.p(toPos.x+ tbCfg.posx , 653-toPos.y - tbCfg.posy )
		else
			pos = cc.p(toPos.x+ tbCfg.posx , 801 - toPos.y + tbCfg.posy )
		end 
		--获取方向
		local asinX = g_getRotationSinx(atPos,pos) or 0
		armature:setRotation(rate + asinX)
		local moveTo1 = cc.MoveTo:create(0.1,pos)
		local function endCallback1()	
			if tbCfg.nextID and tbCfg.nextID > 0  then
				self:animaISCocos(tbCfg.nextID,toIndex)
			end 
			if callBack then
				callBack()
			end 
		end

		local actionEnd1 = cc.CallFunc:create(endCallback1)
		local actionSequence2 = cc.Sequence:create(moveTo1,actionEnd1)
		actionSequence2:setTag(13)
		armature:stopActionByTag(13)
		armature:runAction(actionSequence2)	
	end 
end 

--攻击 特效类型1
function batWndContorlPK:showAttckEffctItemPool1(roleID,EffctID,toRoleID,callBack)
	self:animaISCocos(EffctID,toRoleID,endCallBack,toRoleID)
end 

--攻击 特效类型3
function batWndContorlPK:showAttckEffctItemPool2(roleID,tbMsg,toRoleID,callBack)
	
	local item =  g_itemPoolContorl:getItemPoolPk(tbMsg.itemName)
	item:setVisible(true)
	local atPos
	if roleID then
		local roleItem = self:getItem(roleID)
		atPos = roleItem:getPosition()
		item:setPosition(atPos.x  ,atPos.y )
		item:setIcon(g_iconConTrol:getEffctIcon(tbMsg.name))
	end 
	--是否播放动画
	if tbMsg.isT0 ~= "" then
		local dongH = item:getTransition(tbMsg.isT0)
		dongH:play()
	end 
	if tbMsg.scale ~= 0 then
		item:setScale(tbMsg.scale,tbMsg.scale)
	else
		item:setScale(1,1)
	end 
	
	if tbMsg.startType ~= 2 then
		return
	end 
	
	local toRoleItem = self:getItem(toRoleID)
	local toPos = toRoleItem:getPosition()
	local pos = cc.p(0,0)
	pos.y = atPos.y - toPos.y 
	pos.x = toPos.x - atPos.x 
	
	local itemObj = item:displayObject()
	local posX,posY = itemObj:getPosition()
	
	local function callBackFunc()
		if callBack then
			callBack()
		end 
		itemObj:setPosition(posX,posY)
		g_itemPoolContorl:returnItemPoolPk(tbMsg.itemName,item)
	end 
	g_action:moveByAction(itemObj,nil,pos,callBackFunc,nil,0.2)
	
	if tbMsg.isRate then
		local asinX = g_getRotationSinx(atPos,toPos) or 0
		item:setRotation(-asinX)
	end 
end


--攻击 特效类型3
function batWndContorlPK:showAttckEffctItemPool3(roleID,tbMsg,toRoleID,callBack)
	
	local item =  g_itemPoolContorl:getItemPoolPk(tbMsg.itemName)
	item:setVisible(true)
	local atPos
	if roleID then
		local roleItem = self:getItem(roleID)
		atPos = roleItem:getPosition()
		local offX ,offY = 0
		if roleID == 100  then
			local nrandom = math.random(-80,80)
			local nrandomY = math.random(-20,50)
			offX = nrandom
			offY = nrandomY
		end 
		item:setPosition(atPos.x + offX,atPos.y + offY)
		item:setIcon(g_iconConTrol:getEffctIcon(tbMsg.name))
	end 
	--是否播放动画
	if tbMsg.isT0 ~= "" then
		local dongH = item:getTransition(tbMsg.isT0)
		dongH:play()
	end 
	if tbMsg.scale ~= 0 then
		item:setScale(tbMsg.scale,tbMsg.scale)
	else
		item:setScale(1,1)
	end 
	
	if tbMsg.startType ~= 2 then
		return
	end 
	
	local toRoleItem = self:getItem(toRoleID)
	local toPos = toRoleItem:getPosition()
	local pos = cc.p(0,0)
	pos.y = atPos.y - toPos.y 
	pos.x = toPos.x - atPos.x 
	
	local itemObj = item:displayObject()
	local posX,posY = itemObj:getPosition()
	
	local function callBackFunc()
		if callBack then
			callBack()
		end 
		itemObj:setPosition(posX,posY)
		g_itemPoolContorl:returnItemPoolPk(tbMsg.itemName,item)
	end 
	g_action:moveByAction(itemObj,nil,pos,callBackFunc,nil,0.2)
	
	if tbMsg.isRate then
		local asinX = g_getRotationSinx(atPos,toPos) or 0
		item:setRotation(-asinX)
	end 
end


--死亡控件操作
function batWndContorlPK:deatItem(roleID)
	local roleItem = self:getItem(roleID)

	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	if roleID == 100 or roleID == 1100  then
		B_FbBatPk:showMpStatusText(roleID,1,"死亡")
		
	else
		local item = g_batWndContorlPK:getItem(roleID)
		local c1 =  item:getController("c1") --控制器
		c1:setSelectedIndex(1)	
	end
	
end 

---复活
function batWndContorlPK:deatItemFh(roleID)
	local roleItem = self:getItem(roleID)

	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	if roleID == 100 or roleID == 1100  then
		B_FbBatPk:showMpStatusText(roleID,0)
	else
		local item = g_batWndContorlPK:getItem(roleID)
		local c1 =  item:getController("c1") --控制器
		c1:setSelectedIndex(0)	
	end
end 

--治疗特效
function batWndContorlPK:showAnimaZhilieo(index)
	local item = self:getItem(index)
	local pos = cc.p(110,120)
	local  ArmatureEndA = g_gArmature:showArmature("skillzhiliao3",item,nil,nil,pos)
	ArmatureEndA:setScale(1)
end


function batWndContorlPK:setItemHpPet(index,status)
	local item = self:getItem(index)
	if index == 100 or index == 1100 then
		return
	else
		local c3 =  item:getController("c3") --控制器
		c3:setSelectedIndex(status)	
		if status == 1 then	
			local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
			local hpBar = B_FbBatPk:setFbMsgPanlePetHp(index)
			local itemObj = hpBar:displayObject()
			--local function scheduleByOne()
				--self:setItemHpPet(index,0)
			--end 
			--g_scheduleTime:scheduleByTimes(itemObj, 0.5,1,scheduleByOne)
		end 
	end
end

function batWndContorlPK:setItemMaoPao(index,status)
	local item = self:getItem(index)
	if index == 100 or index == 1100 then
		local c3 =  item:getController("c3") --控制器
		c3:setSelectedIndex(status)	
	else
		local c2 =  item:getController("c2") --控制器
		c2:setSelectedIndex(status)	
	end
end

--攻击 动画
function batWndContorlPK:showActor(roleID,toRole,callBack)
	local item = self:getItem(roleID)
	if not toRole then
		cclog("=not toRole ===")
		if callBack then
			callBack()
			g_batContorlPK:startAllTimeSchedu()
		end 
		return
	end 
	local function callBackEnd()
		if callBack then
			callBack()
			g_batContorlPK:startAllTimeSchedu()
		end 
	end  
	if roleID == 100  or  roleID == 1100  then
		local t1 = item:getTransition("t1")
		t1:play(callBackEnd)
	elseif  roleID == 1100  then	
		local t2 = item:getTransition("t2")
		t2:play(callBackEnd)
	else
		self:toRolePos(roleID,toRole,callBack)
	end 
end

function batWndContorlPK:toRolePos(roleID,toRole,callBack)
	local item1 = self:getItem(roleID)
	local item2 = self:getItem(toRole)
	local pos1 = item1:getPosition()
	local pos2 = item2:getPosition()
	local function callBackEnd()
		item1:setPosition(pos1.x,pos1.y)
		self:setItemMaoPao(roleID,1)
		g_batContorlPK:startAllTimeSchedu()
		
	end 
	cclog(pos2,"=======toRolePos=======",toRole)
	local PoY
	if roleID < 1000 then
		local function callBackD()
			item1:setPosition(pos2.x,pos2.y )
			
			local t11 = item1:getTransition("t11")
			t11:play(callBackEnd)
		end 
		local t1 = item1:getTransition("t1")
		t1:play(callBackD)
		PoY = 20
	else
		local function callBackD()
			local t21 = item1:getTransition("t21")
			item1:setPosition(pos2.x,pos2.y - 90)
			t21:play(callBackEnd)
		end 
		local t2 = item1:getTransition("t2")
		t2:play(callBackD)
		PoY = -20
	end 
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	local rootLayout = B_FbBatPk.rootLayout:displayObject()
	local function scheduleByOne()	
		 g_action:shakeAction(rootLayout,PoY)
		 if callBack then
			callBack()
		 end 
	end 	
	local itemObj = item1:displayObject()
	g_scheduleTime:scheduleByTimes(itemObj, 0.3,1,scheduleByOne)
end


function batWndContorlPK:initTopPanel()
	local B_FbBatPk = g_WndMgr:getWnd("B_FbBatPk")
	---我方名字
	local  Test_playerName1 = B_FbBatPk.rootLayout:getChild("Test_playerName1") 
	Test_playerName1:setText(g_GameDataMgr.nickname)
	--对方名字
	local  Test_playerName2 = B_FbBatPk.rootLayout:getChild("Test_playerName2") 
	Test_playerName2:setText(g_playerMsg.nickname)
	
end 


function batWndContorlPK:initItemPool()
	g_itemPoolContorl.itemPoolPk  = {}
	g_itemPoolContorl:initItemPoolPk("hurt",10,"B_FuBen", "Component_hurt")
	g_itemPoolContorl:initItemPoolPk("baoji",10,"B_FuBen", "Component_baoji")
	g_itemPoolContorl:initItemPoolPk("zhiliao",10,"B_FuBen", "Component_add")
	g_itemPoolContorl:initItemPoolPk("stausText",10,"B_FuBen", "Component_staus")
	g_itemPoolContorl:initItemPoolPk("addMp",10,"B_FuBen", "Component_addMP")
	g_itemPoolContorl:initItemPoolPk("mpHurt",10,"B_FuBen", "Component_mpHurt")

end 


function batWndContorlPK:ctor()
	self.animaD = 1
end

g_batWndContorlPK =  batWndContorlPK:create()