--https://blog.csdn.net/z9061/article/details/38313467
--https://blog.csdn.net/erweimac/article/details/79754715
WebSocket = class("WebSocket")
WebSocket.__index = WebSocket
local iProtoHeadMax = 3

function WebSocket:actor()
	self:parseProto()
	self.tbWebSCallBackFunc = {}
	self.socket = nil
	self.bConnectSucc = nil
	self.bConnecting = nil
	self.reconnectCount = 0
	self.dumpMsgDetail = true
	self.tbDelayMsg = {}
end


function WebSocket:parseProto()
	local strProtoBuf = ""
	for key, value in pairs(tbProtos) do
		strProtoBuf = strProtoBuf .. require(value)
	end
	--print(strProtoBuf)
	
	local sproto = require "public.sproto.sproto"
	local core = require "sproto_core"
	local parse, tbRet = sproto.parse(strProtoBuf)
	self.proto_parse = parse
--	core.dumpproto(parse.__cobj)

	print("===========Proto<=>ID begin===========")
	self.tbProto2ID = tbRet.tbMsgSproto
		
	self.tbID2Proto = {}
	local tbMsgInfo = {}
	local iCount = 0
	for key, value in pairs(self.tbProto2ID) do
	 -- print(key.." "..value.." "..tonumber('0x'..value))
	  self.tbID2Proto[value] = key
	  tbMsgInfo[tonumber('0x'..value)] = {key, value}
	  iCount = iCount + 1
	end
	--[[
	print("===========iCount==========="..iCount)
	for i = 1, iCount do
		print(tbMsgInfo[i][1].." "..tbMsgInfo[i][2].." "..i)
	end
	print("===========Proto<=>ID  end==========="..iCount)
	]]
end

-- 发送
function WebSocket:wsC2SMessage(msgdata)
	if self.socket then
		self.socket:sendString(msgdata)
		--[[
			local strMsg = string.format("wsC2SMessage datalen=%d databuf=", #msgdata)
			for i=1, #msgdata  do
				strMsg = strMsg .. string.format("%x ", string.byte(msgdata,i) )
			end
			cclog(strMsg)
		]]
	else
		print("wsC2SMessage socket nil")
	end
end

function WebSocket:reConectGameServer()
	if self.socket then
		print("reConectGameServer error")
		return
	end
	
	if self.reconnectCount > 3 then
		print("reConectGameServer max count")
		if g_delayNode then
			g_delayNode:showWnd(5)
		end
		return
	end

	local function reconnectGameServer()
		local usrid = nil
		if g_GameDataMgr then
			usrid = g_GameDataMgr.userid
		end
		print("reconnectGameServer "..tostring(usrid))	
		self.reconnectCount = self.reconnectCount + 1
		self:connectToServer(usrid)
	end
	
	local fInterval = math.random(100, 500)/100 + 15
	print("reConectGameServer "..fInterval)
	g_Timer:pushLimtCountTimer(1, fInterval, reconnectGameServer)
	if g_delayNode then
		g_delayNode:showWnd(5)
	end
end

function WebSocket:connectToServer(userid)
	if self.socket then
		print("error connectToServer again")
		return
	end
	
	if self.bConnecting then
		print("error connectToServer bConnecting")
		return
	end
	
	self.bConnecting = true
	userid = userid or 0
	local strCurAppVersion = get_szAppVersion()
	local resVersion = get_szCurVersion()
	local Platform = cc.Application:getInstance():getTargetPlatform()
	local DeviceID = "windos"
	cclog("===setPlatformCallBack =======",kTargetWindows, Platform)
	if Platform == kTargetWindows  then
	else
		DeviceID = API_GetDeviceID()
	end 
	self.socket = cc.WebSocket:create(string.format("ws://%s/1.0/websocket?uid=%d&deviceuid=%s&appVer=%s&resVer=%s", g_GameDataMgr.SvrIp, userid, DeviceID, strCurAppVersion, resVersion))
	print(g_GameDataMgr.SvrIp.." "..userid.." connectToServer "..tostring(self.socket))
	-- 触发WebSocket的链接服务区成功后WebSocket就会调用onOpen,通知客户的和服务器的已经成功的建立了链接通道。
	local function wsSocketOpen(strData)
		print("wsSendTextOpen")
		self.bConnectSucc = true
		local event = cc.EventCustom:new("__G__WS_SOCKET__")
		event._usedata = cc.WEBSOCKET_OPEN
		
		cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
		
		if g_delayNode then
			g_delayNode:closeWnd("222222")
		end
		
		if self.reconnectCount > 0 then
			self:showTips("重连成功")
		end
		self.reconnectCount = 0
		self.bConnecting = nil
		self:SendAllDelayMsg()
	end

	-- 服务器向客户端发送的数据（在当前的测试环境服务器下，服务器会把前端发送的数据转发回到客户端）
	local function wsS2CMessage(strData)
		--[[--cclog("—————————respones——————"..#strData)
        local strMsg = ""
        for i=1, #strData  do
            strMsg = strMsg .. string.format("%x ", string.byte(strData,i) )
        end
        --cclog(strMsg)
		]]
		local strHexMsgID = string.sub(strData,1, iProtoHeadMax)
		local strProtoName = self.tbID2Proto[strHexMsgID]
		local iMsgLen = #strData
		--print(string.format("wsS2CMessage head:iMsgID=%d iMsgLen=%d strProtoName=%s",tonumber('0x'..strHexMsgID), iMsgLen, tostring(strProtoName) ))
		if not strProtoName then
			print("wsS2CMessage protoname is not exist!"..strData)
		else
			local decode = self.proto_parse:decode(strProtoName, string.sub(strData,iProtoHeadMax + 1))	
			if self.dumpMsgDetail then
				if iMsgLen < 4096 then
					--print("wsS2CMessage "..sz_T2S(decode))
				else
					local strMsgData = sz_T2S(decode)
					local iStrMsgDataLen = string.len(strMsgData)
					local iIndex = 0;
					repeat
						if (iIndex+1)*4096-1 < iMsgLen then
							print("wsS2CMessage "..strMsgData.sub(iIndex*4096,iMsgLen))
						else
							print("wsS2CMessage "..strMsgData.sub(iIndex*4096, (iIndex+1)*4096-1))
						end
						iIndex = iIndex + 1
					until(iIndex*4096 <= iMsgLen)
				end
			end

			local func = self.tbWebSCallBackFunc[strProtoName]
			if  func then
				func(decode)
			else
				print("wsS2CMessage func is not exist! "..strProtoName)
			end
		end
	end

	-- 不管是前端还是服务器关闭了WebSocket都会收到该回调，所以把wsSendText置空
	local function wsSocketClose(strData)
		print("_wsiSendText websocket instance closed."..tostring(self.socket))
		self.socket = nil
		self.bConnectSucc = nil
		local event = cc.EventCustom:new("__G__WS_SOCKET__")
		event._usedata = cc.WEBSOCKET_CLOSE
		
		cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
		self.bConnecting = nil
		
		if g_GameDataMgr.loginSucc then
			self:showTips("网络异常,重连中...")
		end
	end

	-- 客户端请求错误的时候回调，可更具不同的错误码进行相应的处理
	local function wsSocketError(strData)
		print("sendText Error was fired "..tostring(self.socket))
		self.socket = nil
		self.bConnectSucc = nil
		self:ClearAllDelayMsg()
		self.bConnecting = nil
			
		local event = cc.EventCustom:new("__G__WS_SOCKET__")
		event._usedata = cc.WEBSOCKET_ERROR
		cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	end

	-- 注册回调以上的函数
	if nil ~= self.socket then
		self.socket:registerScriptHandler(wsSocketOpen, cc.WEBSOCKET_OPEN)
		self.socket:registerScriptHandler(wsS2CMessage, cc.WEBSOCKET_MESSAGE)
		self.socket:registerScriptHandler(wsSocketClose, cc.WEBSOCKET_CLOSE)
		self.socket:registerScriptHandler(wsSocketError, cc.WEBSOCKET_ERROR)
	end
end
 
 
  function WebSocket:client_Response(strProtoName, decode)
		local func = self.tbWebSCallBackFunc[strProtoName]
		if  func then
			func(decode)
		else
			print("wsS2CMessage func is not exist! "..strProtoName)
		end
  end 
 
 function WebSocket:Close()
	if self.socket then
		self.socket:close()
		self.socket = nil
		self.bConnecting = nil
		self.bConnectSucc = nil
		print("WebSocket:Close")
	end
 end
 
function WebSocket:SendAllDelayMsg()
	local iCount =  #self.tbDelayMsg
	print("sendWsSocketData SendAllDelayMsg "..iCount)
	for i=1, iCount do
		self:sendWsSocketData(self.tbDelayMsg[i].msgname, self.tbDelayMsg[i].data)
	end
	
	self.tbDelayMsg = {}
end

function WebSocket:ClearAllDelayMsg()
	print("sendWsSocketData ClearAllDelayMsg")
	self.tbDelayMsg = {}
end


function WebSocket:sendWsSocketData(strProtoName, tbData)
	local strHexMsgID = self.tbProto2ID[strProtoName]
	if not strHexMsgID then
		cclog("sendWsSocketData id not exist :"..strProtoName)
	else
		if self.dumpMsgDetail then
			print(string.format("sendWsSocketData iMsgID=%d ProtoName=%s tbData= %s", tonumber('0x'..strHexMsgID), strProtoName, sz_T2S(tbData)))
		end
		--print(string.format("sendWsSocketData iMsgID=%d ProtoName=%s", tonumber('0x'..strHexMsgID), strProtoName))
		local code = self.proto_parse:encode(strProtoName, tbData)
		self:wsC2SMessage(strHexMsgID..code)	
	end
end


function sendWsSocketData(strProtoName, tbData)
	if not WebSocket.socket then
		cclog(g_GameDataMgr,"sendWsSocketData error socket is nil "..strProtoName)	
		table.insert(WebSocket.tbDelayMsg, {msgname = strProtoName, data = tbData})	
		if strProtoName =="req_login" then
			WebSocket:connectToServer()
		elseif g_GameDataMgr and not g_GameDataMgr.KickoffType then
			WebSocket:connectToServer(g_GameDataMgr.userid)
		end		
		return
	end
	
	if  not WebSocket.bConnectSucc then		
		local iMsgCount = #WebSocket.tbDelayMsg
		print(strProtoName.."sendWsSocketData bConnectSucc is fail "..iMsgCount)
		if iMsgCount > 0 then
			if WebSocket.tbDelayMsg[iMsgCount].msgname ~= strProtoName then
				table.insert(WebSocket.tbDelayMsg, {msgname = strProtoName, data = tbData})
			end
		else
			table.insert(WebSocket.tbDelayMsg, {msgname = strProtoName, data = tbData})
		end
		return
	end
	
	WebSocket:sendWsSocketData(strProtoName, tbData)
end

function registerWsSocketMsg(strProtoName, func)
    WebSocket.tbWebSCallBackFunc[strProtoName] = func
end


function WebSocket:showTips(strDesc)
	g_action:ts_hszz_antion(strDesc,nil,-2,true)
end

WebSocket:actor()
