
-- 0 - disable debug info, 1 - less debug info, 2 - verbose debug info
DEBUG = 2

-- use framework, will disable all de撒打算放安抚precated API, false - use legacy API
CC_USE_FRAMEWORK = true

-- show FPS on screen
CC_SHOW_FPS = false

-- disable create unexpected global variable
CC_DISABLE_GLOBAL = false

-- for module display
CC_DESIGN_RESOLUTION = {
    width = 710,
    height = 1440,
    autoscale = "SHOW_ALL", --"FIXED_HEIGHT", SHOW_ALL    
    callback = function(framesize)
	    widthRate = framesize.width / CC_DESIGN_RESOLUTION.width
		heightRate = framesize.height / CC_DESIGN_RESOLUTION.height
		
		g_ScaleRate = widthRate
		printInfo(string.format("widthRate=%f, heightRate=%f",widthRate,heightRate) ) 
		--https://blog.csdn.net/weixin_34258078/article/details/92552008
		if (widthRate >= heightRate) then
       -- local ratio = framesize.width / framesize.height
       -- if ratio <= 1.34 then
            -- iPad 768*1024(1536*2048) is 4:3 screen
			g_ScaleRate = 1/widthRate
            return {autoscale = "SHOW_ALL"}
        end
    end
}


function cc.getObjectVal(obj)
    if type(obj) == "table" then
        local status, jsonStr = pcall(json.encode, obj)
        if status and jsonStr ~= nil then
            return jsonStr
        elseif jsonStr == nil then
            local arr = {}
            for k, v in pairs(obj) do
                if type(v) ~= "boolean" and type(v) ~= "number" and type(v) ~= "string" then
                    arr[k] = tostring(v)
                else
                    arr[k] = v
                end
            end
            return json.encode(arr)
        else
            return tostring(obj)
        end
    end
    if tolua == nil then
        return tostring(obj)
    end
    local type_ = tolua.type(obj)
    local arr
    if type_ == "CCPoint" then
        arr = {x = obj.x, y = obj.y}
    elseif type_ == "CCSize" then
        arr = {width = obj.width, height = obj.height}
    elseif type_ == "CCRect" then
        arr = {
            origin = {x = obj.origin.x, y = obj.origin.y},
            size = {width = obj.size.width, height = obj.size.height},
        }
    elseif type_ == "ccColor3B" then
        arr = {r = obj.r, g = obj.g, b = obj.b}
    elseif type_ == "ccColor4B" or type_ == "ccColor4F" then
        arr = {r = obj.r, g = obj.g, b = obj.b, a = obj.a}
    else
        return tostring(obj)
    end
    arr.type = type_
    return json.encode(arr)
end	

--[[
获取对象的值
@param userdata obj
@return string
]]
local function __tostring1(value, indent, vmap,bLine)  
    local str = ''  
    indent = indent or ''  
    vmap = vmap or {}  
      
    --递归结束条件  
    if (type(value) ~= 'table') then  
        if (type(value) == 'string') then  
            --字符串  
			--str = cc.getObjectVal(value)
			str = string.format('"%s"', value)  
        else  
            --整数  
            str = tostring(value)  
        end  
    else  
        if type(vmap) == 'table' then  
            if vmap[value] then 
				return '('..tostring(value)..')' 
			end  
            vmap[value] = true  
        end  
          
        local auxTable = {}     --保存元表KEY(非整数)  
        local iauxTable = {}    --保存元表value  
        local iiauxTable = {}   --保存数组(key为0)  
        table.foreach(value, function(i, v)  
            if type(i) == 'number' then  
                if i == 0 then  
                    table.insert(iiauxTable, i)  
                else  
                    table.insert(iauxTable, i)  
                end  
            elseif type(i) ~= 'table' then  
                table.insert(auxTable, i)  
            end  
        end)  
        table.sort(iauxTable)  
  
        str = str..'{'  
        local separator = ""  
        local entry = ""  
        local barray = true  
        local kk,vv  
        table.foreachi (iauxTable, function (i, k)  
            if i == k and barray then  
                entry = __tostring1(value[k], indent, vmap,true)  
                str = str..separator..indent..entry  
                separator = ","       
            else  
                barray = false  
                table.insert(iiauxTable, k)  
            end  
        end)  
        table.sort(iiauxTable)  
       
        table.foreachi (iiauxTable, function (i, fieldName)  
              
            kk = tostring(fieldName)  
            if type(fieldName) == "number" then   
                kk = '['..kk.."]"  
            end   
            entry = kk .. " = " .. __tostring1(value[fieldName],indent,vmap,true)  
              
            str = str..separator..indent..entry  
            separator = ","    
        end)  
        table.sort(auxTable)  
          
        table.foreachi (auxTable, function (i, fieldName)  
  
            kk = tostring(fieldName)  
            if type(fieldName) == "number" then   
                kk = '['..kk.."]"  
            end   
			local fieldNameStr = tostring(fieldName)
			local subStr =string.sub(fieldNameStr,1,2) 
			local valueStr = tostring(value[fieldName])
			local valuesubStr = string.sub(valueStr,1,8) 
			
            if subStr == "__" or valuesubStr == "function" or fieldNameStr == "dataIndex" then
			else
				entry = kk .. " = " .. __tostring1(value[fieldName],indent,vmap,true)  
  
				str = str..separator..indent..entry  
				separator = ","  
			end 
        end)  
          
        str = str..indent..'}'
    end  
      
    return str  
end  

local function __tostring(value, indent, vmap,bLine)  
    local str = ''  
    indent = indent or ''  
    vmap = vmap or {}  
      
    --递归结束条件  
    if (type(value) ~= 'table') then  
        if (type(value) == 'string') then  
            --字符串  
			--str = cc.getObjectVal(value)
			str = string.format('"%s"', value)  
        else  
            --整数  
            str = tostring(value)  
        end  
    else  
        if type(vmap) == 'table' then  
            if vmap[value] then 
				return '('..tostring(value)..')' 
			end  
            vmap[value] = true  
        end  
          
        local auxTable = {}     --保存元表KEY(非整数)  
        local iauxTable = {}    --保存元表value  
        local iiauxTable = {}   --保存数组(key为0)  
        table.foreach(value, function(i, v)  
            if type(i) == 'number' then  
                if i == 0 then  
                    table.insert(iiauxTable, i)  
                else  
                    table.insert(iauxTable, i)  
                end  
            elseif type(i) ~= 'table' then  
                table.insert(auxTable, i)  
            end  
        end)  
        table.sort(iauxTable)  
  
        str = str..'{\n'  
        local separator = ""  
        local entry = "\n"  
        local barray = true  
        local kk,vv  
        table.foreachi (iauxTable, function (i, k)  
            if i == k and barray then  
                entry = __tostring(value[k], indent..'\t', vmap,true)  
                str = str..separator..indent..'\t'..entry  
                separator = ", \n"       
            else  
                barray = false  
                table.insert(iiauxTable, k)  
            end  
        end)  
        table.sort(iiauxTable)  
       
        table.foreachi (iiauxTable, function (i, fieldName)  
              
            kk = tostring(fieldName)  
            if type(fieldName) == "number" then   
                kk = '['..kk.."]"  
            end   
            entry = kk .. " = " .. __tostring(value[fieldName],indent..'\t',vmap,true)  
              
            str = str..separator..indent..'\t'..entry  
            separator = ", \n"    
        end)  
        table.sort(auxTable)  
          
        table.foreachi (auxTable, function (i, fieldName)  
  
            kk = tostring(fieldName)  
            if type(fieldName) == "number" then   
                kk = '['..kk.."]"  
            end   
			local fieldNameStr = tostring(fieldName)
			local subStr =string.sub(fieldNameStr,1,2) 
			local valueStr = tostring(value[fieldName])
			local valuesubStr = string.sub(valueStr,1,8) 
			
            if subStr == "__" or valuesubStr == "function" or fieldNameStr == "dataIndex" then
			else
				entry = kk .. " = " .. __tostring(value[fieldName],indent..'\t',vmap,true)  
  
				str = str..separator..indent..'\t'..entry  
				separator = ", \n"  
			end 
        end)  
          
        str = str..'\n'..indent..'}'
    end  
      
    return str  
end  

--配置表
g_Cfg = {
	ShowFps = false, 
	test = 0,	
	shenhe = 1,
	online = 2,
}

g_Cfg.curGameType = g_Cfg.online
g_Cfg.Platform = cc.Application:getInstance():getTargetPlatform()

local debug = print
local info = release_print
local warning = warning_print
local errors = error_print
g_Cfg.Debug  = 1

cclog = function(...)  
	if  g_Cfg.Debug == true  or  cc.Application:getInstance():getTargetPlatform()  == kTargetWindows  then
		local argc = select("#", ...)
		local argv = {...}
		local arr = ""
		for i = 1, argc do
			local str = ""
			if type(argv[i]) == "table" then  
				str = __tostring1(argv[i]) 
			else 
				str = tostring(argv[i])
			end  
			arr = arr.." "..str
		end
		
		debug(arr) 
	end
end

---table 整齐输出
cclogTb = function(...)  
	if  g_Cfg.Debug == true or cc.Application:getInstance():getTargetPlatform()  == kTargetWindows  then
		local argc = select("#", ...)
		local argv = {...}
		local arr = ""
		for i = 1, argc do
			local str = ""
			if type(argv[i]) == "table" then  
				str = __tostring(argv[i]) 
			else 
				str = tostring(argv[i])
			end  
			arr = arr.." "..str
			
		end
		
		debug(arr) 
	end
end
ccwarnig = cclog
ccerror = cclog
ccinfo = cclog
cclogD = cclogTb
--print = cclog
cc.Director:getInstance():setDisplayStats(g_Cfg.ShowFps)


function split( str,reps )
    local resultStrList = {}
    string.gsub(str,'[^'..reps..']+',function ( w )
        table.insert(resultStrList,w)
    end)
    return resultStrList
end

--local HU = require("Debugger/HotUpdate")
--HU.Init()
--require("Debugger/ReloadUtil")
function WndProc(iKey)
    cclog("WndProc", iKey)
	if iKey == 27 then --Esc
		if g_WndMgr then
			g_WndMgr:closeWnd()
		end
	elseif iKey == 112 then --F1
        --ReloadUtil("app.views.LoginScene")
        HU.HotUpdate("app.views.LoginScene")
	end
end

g_GameDataMgr = {}
require("lfs")

function os.isDirectoryExist(path)
    return cc.FileUtils:getInstance():isDirectoryExist(path)
end

function os.isFileExist(path)
    return cc.FileUtils:getInstance():isFileExist(path)
end


function os.mkdir(path)
    if not os.isDirectoryExist(path) then
        return lfs.mkdir(path)
    end
    return true
end


function os.rmdir(path)
    print("---------------os.rmdir:", path)
    if os.isDirectoryExist(path) then
        local function _rmdir(path)
            local iter, dir_obj = lfs.dir(path)
            while true do
                local dir = iter(dir_obj)
                if dir == nil then
                    break
                end
               -- print(dir)
                if dir ~= "." and dir ~= ".." then
                    local curDir = path..dir
                    --print(curDir)
                    local mode = lfs.attributes(curDir, "mode")
                    if mode == "directory" then
                        _rmdir(curDir.."/")
					
						os.remove(curDir)
						print("remove dir->"..curDir)
                    elseif mode == "file" then
                        os.remove(curDir)
						print("remove file->"..curDir)
                    end
                end
            end

            local succ, des = os.remove(path)
            if des then
                print(des)
			else
				print(des)
            end
            return succ
        end

        _rmdir(path)
    end

    return false
end

function CreateTimer(func, fTime)
	local callbackEntry = nil
	local scheduler = cc.Director:getInstance():getScheduler()
	local function callback(dt)
		scheduler:unscheduleScriptEntry(callbackEntry)
		if func then
			func()
		end
	end

	callbackEntry = scheduler:scheduleScriptFunc(callback, fTime, false)
end

--字符串分割  里面有 | 字符 分割前后 
function cc.g_inalienContentByCfgMsg(text,nType,fgStr)
	--cclog("===字符串分割===",text,nType,fgStr)
	if not text then
		return
	end 
	local index = 1  
	local tbStrNumber = {}
	local subStr = ""
	local strIndex = 1
	local is_end = true
	local index_max =  string.len(text)
    local fgStr = fgStr or "|"
	while (is_end) do  
		local temp = string.byte(text,index) 
		if not temp then
			return
		end 
        if (temp >= 0 and temp <= 127) then 
			subStr =string.sub(text,index,index) 
  			if subStr == fgStr then
				local curStr =string.sub(text,strIndex,index-1) 
				if nType == 1 then
					curStr = tonumber(curStr)
				end 
				tbStrNumber[#tbStrNumber+1] = curStr
				index = index + 1 
				strIndex = index
			else
				index = index + 1 
			end
        else 		
			subStr =string.sub(text,index,index + 2) 
			index = index + 3
        end  
        if (index>=index_max) then  
			local curStr =string.sub(text,strIndex,index) 
			if nType == 1 then
				curStr = tonumber(curStr)
			end 
			tbStrNumber[#tbStrNumber+1] = curStr
            is_end=false  
        end
    end 	

	return tbStrNumber
end

---枚举的设置
cc.RelationType = {}
cc.RelationType.Left_Left = 0
cc.RelationType.Left_Center = 1
cc.RelationType.Left_Right = 2
cc.RelationType.Center_Center = 3
cc.RelationType.Right_Left = 4
cc.RelationType.Right_Center = 5
cc.RelationType.Right_Right = 6
cc.RelationType.Top_Top = 7
cc.RelationType.Top_Middle = 8
cc.RelationType.Top_Bottom = 9
cc.RelationType.Middle_Middle = 10
cc.RelationType.Bottom_Top = 11
cc.RelationType.Bottom_Middle = 12
cc.RelationType.Bottom_Bottom = 13
cc.RelationType.Width = 14
cc.RelationType.Height = 15
cc.RelationType.LeftExt_Left = 16
cc.RelationType.LeftExt_Right = 17
cc.RelationType.RightExt_Left = 18
cc.RelationType.RightExt_Right = 19
cc.RelationType.TopExt_Top = 20
cc.RelationType.TopExt_Bottom = 21
cc.RelationType.BottomExt_Top = 22
cc.RelationType.BottomExt_Bottom = 23
cc.RelationType.Size = 24

cc.TweenPropType = {}
cc.TweenPropType.None = 0
cc.TweenPropType.X = 1
cc.TweenPropType.Y = 2
cc.TweenPropType.Position = 3
cc.TweenPropType.Width = 4
cc.TweenPropType.Height = 5
cc.TweenPropType.Size = 6
cc.TweenPropType.ScaleX = 7
cc.TweenPropType.ScaleY = 8
cc.TweenPropType.Scale = 9
cc.TweenPropType.Rotation = 10
cc.TweenPropType.Alpha = 11
cc.TweenPropType.Progress = 12

cc.UIEventType = {}
cc.UIEventType.Enter = 0
cc.UIEventType.Exit = 1
cc.UIEventType.Changed = 2
cc.UIEventType.Submit = 3
cc.UIEventType.TouchBegin = 10
cc.UIEventType.TouchMove = 11
cc.UIEventType.TouchEnd = 12
cc.UIEventType.Click = 13
cc.UIEventType.RollOver = 14
cc.UIEventType.RollOut = 15
cc.UIEventType.MouseWheel = 16
cc.UIEventType.RightClick = 17
cc.UIEventType.MiddleClick = 18

cc.UIEventType.PositionChange = 20
cc.UIEventType.SizeChange = 21

cc.UIEventType.KeyDown = 30
cc.UIEventType.KeyUp = 31

cc.UIEventType.Scroll = 40
cc.UIEventType.ScrollEnd = 41
cc.UIEventType.PullDownRelease = 42
cc.UIEventType.PullUpRelease = 43

cc.UIEventType.ClickItem = 50
cc.UIEventType.ClickLink = 51
cc.UIEventType.ClickMenu = 52
cc.UIEventType.RightClickItem = 53

cc.UIEventType.DragStart = 60
cc.UIEventType.DragMove = 61
cc.UIEventType.DragEnd = 62
cc.UIEventType.Drop = 63

cc.UIEventType.GearStop = 70

cc.UIEventType.JoystickModuleMOVE = 100
cc.UIEventType.JoystickModuleEND = 101


cc.PopupDirection = {}
cc.PopupDirection.AUTO = 0
cc.PopupDirection.UP = 1
cc.PopupDirection.DOWN = 2